# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal
from bitarray import bitarray
import six

# PY3 support of some PY2 keywords (needs improved)
if six.PY3:
    import builtins as __builtin__

    long = int
elif six.PY2:
    import __builtin__


class config(PybindBase):
    """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-platform - based on the path /components/component/transceiver/config. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration data for client port transceivers
  """
    __slots__ = (
        "_path_helper",
        "_extmethods",
        "__enabled",
        "__form_factor_preconf",
        "__ethernet_pmd_preconf",
    )

    _yang_name = "config"

    _pybind_generated_by = "container"

    def __init__(self, *args, **kwargs):

        self._path_helper = False

        self._extmethods = False
        self.__enabled = YANGDynClass(
            base=YANGBool,
            is_leaf=True,
            yang_name="enabled",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/platform/transceiver",
            defining_module="openconfig-platform-transceiver",
            yang_type="boolean",
            is_config=True,
        )
        self.__form_factor_preconf = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_type="dict_key",
                restriction_arg={
                    "CFP": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:CFP": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "CFP2": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:CFP2": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "CFP2_ACO": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:CFP2_ACO": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "CFP4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:CFP4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "QSFP": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:QSFP": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "QSFP_PLUS": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:QSFP_PLUS": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "QSFP28": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:QSFP28": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "CPAK": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:CPAK": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "SFP": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:SFP": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "SFP_PLUS": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:SFP_PLUS": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "XFP": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:XFP": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "X2": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:X2": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "NON_PLUGGABLE": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:NON_PLUGGABLE": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "OTHER": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:OTHER": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                },
            ),
            is_leaf=True,
            yang_name="form-factor-preconf",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/platform/transceiver",
            defining_module="openconfig-platform-transceiver",
            yang_type="identityref",
            is_config=True,
        )
        self.__ethernet_pmd_preconf = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_type="dict_key",
                restriction_arg={
                    "ETH_10GBASE_LRM": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_10GBASE_LRM": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_10GBASE_LR": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_10GBASE_LR": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_10GBASE_ZR": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_10GBASE_ZR": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_10GBASE_ER": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_10GBASE_ER": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_10GBASE_SR": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_10GBASE_SR": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_40GBASE_CR4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_40GBASE_CR4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_40GBASE_SR4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_40GBASE_SR4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_40GBASE_LR4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_40GBASE_LR4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_40GBASE_ER4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_40GBASE_ER4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_40GBASE_PSM4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_40GBASE_PSM4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_4X10GBASE_LR": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_4X10GBASE_LR": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_4X10GBASE_SR": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_4X10GBASE_SR": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_100G_AOC": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_100G_AOC": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_100G_ACC": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_100G_ACC": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_100GBASE_SR10": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_100GBASE_SR10": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_100GBASE_SR4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_100GBASE_SR4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_100GBASE_LR4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_100GBASE_LR4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_100GBASE_ER4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_100GBASE_ER4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_100GBASE_CWDM4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_100GBASE_CWDM4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_100GBASE_CLR4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_100GBASE_CLR4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_100GBASE_PSM4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_100GBASE_PSM4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_100GBASE_CR4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_100GBASE_CR4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_UNDEFINED": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_UNDEFINED": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                },
            ),
            is_leaf=True,
            yang_name="ethernet-pmd-preconf",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/platform/transceiver",
            defining_module="openconfig-platform-transceiver",
            yang_type="identityref",
            is_config=True,
        )

        load = kwargs.pop("load", None)
        if args:
            if len(args) > 1:
                raise TypeError("cannot create a YANG container with >1 argument")
            all_attr = True
            for e in self._pyangbind_elements:
                if not hasattr(args[0], e):
                    all_attr = False
                    break
            if not all_attr:
                raise ValueError("Supplied object did not have the correct attributes")
            for e in self._pyangbind_elements:
                nobj = getattr(args[0], e)
                if nobj._changed() is False:
                    continue
                setmethod = getattr(self, "_set_%s" % e)
                if load is None:
                    setmethod(getattr(args[0], e))
                else:
                    setmethod(getattr(args[0], e), load=load)

    def _path(self):
        if hasattr(self, "_parent"):
            return self._parent._path() + [self._yang_name]
        else:
            return ["components", "component", "transceiver", "config"]

    def _get_enabled(self):
        """
    Getter method for enabled, mapped from YANG variable /components/component/transceiver/config/enabled (boolean)

    YANG Description: Turns power on / off to the transceiver -- provides a means
to power on/off the transceiver (in the case of SFP, SFP+,
QSFP,...) or enable high-power mode (in the case of CFP,
CFP2, CFP4) and is optionally supported (device can choose to
always enable).  True = power on / high power, False =
powered off
    """
        return self.__enabled

    def _set_enabled(self, v, load=False):
        """
    Setter method for enabled, mapped from YANG variable /components/component/transceiver/config/enabled (boolean)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_enabled is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_enabled() directly.

    YANG Description: Turns power on / off to the transceiver -- provides a means
to power on/off the transceiver (in the case of SFP, SFP+,
QSFP,...) or enable high-power mode (in the case of CFP,
CFP2, CFP4) and is optionally supported (device can choose to
always enable).  True = power on / high power, False =
powered off
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=YANGBool,
                is_leaf=True,
                yang_name="enabled",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/platform/transceiver",
                defining_module="openconfig-platform-transceiver",
                yang_type="boolean",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """enabled must be of a type compatible with boolean""",
                    "defined-type": "boolean",
                    "generated-type": """YANGDynClass(base=YANGBool, is_leaf=True, yang_name="enabled", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/platform/transceiver', defining_module='openconfig-platform-transceiver', yang_type='boolean', is_config=True)""",
                }
            )

        self.__enabled = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_enabled(self):
        self.__enabled = YANGDynClass(
            base=YANGBool,
            is_leaf=True,
            yang_name="enabled",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/platform/transceiver",
            defining_module="openconfig-platform-transceiver",
            yang_type="boolean",
            is_config=True,
        )

    def _get_form_factor_preconf(self):
        """
    Getter method for form_factor_preconf, mapped from YANG variable /components/component/transceiver/config/form_factor_preconf (identityref)

    YANG Description: Indicates the type of optical transceiver used on this
port.  If the client port is built into the device and not
pluggable, then non-pluggable is the corresponding state. If
a device port supports multiple form factors (e.g. QSFP28
and QSFP+, then the value of the transceiver installed shall
be reported. If no transceiver is present, then the value of
the highest rate form factor shall be reported
(QSFP28, for example).

The form factor is included in configuration data to allow
pre-configuring a device with the expected type of
transceiver ahead of deployment.  The corresponding state
leaf should reflect the actual transceiver type plugged into
the system.
    """
        return self.__form_factor_preconf

    def _set_form_factor_preconf(self, v, load=False):
        """
    Setter method for form_factor_preconf, mapped from YANG variable /components/component/transceiver/config/form_factor_preconf (identityref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_form_factor_preconf is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_form_factor_preconf() directly.

    YANG Description: Indicates the type of optical transceiver used on this
port.  If the client port is built into the device and not
pluggable, then non-pluggable is the corresponding state. If
a device port supports multiple form factors (e.g. QSFP28
and QSFP+, then the value of the transceiver installed shall
be reported. If no transceiver is present, then the value of
the highest rate form factor shall be reported
(QSFP28, for example).

The form factor is included in configuration data to allow
pre-configuring a device with the expected type of
transceiver ahead of deployment.  The corresponding state
leaf should reflect the actual transceiver type plugged into
the system.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=six.text_type,
                    restriction_type="dict_key",
                    restriction_arg={
                        "CFP": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:CFP": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "CFP2": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:CFP2": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "CFP2_ACO": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:CFP2_ACO": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "CFP4": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:CFP4": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "QSFP": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:QSFP": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "QSFP_PLUS": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:QSFP_PLUS": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "QSFP28": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:QSFP28": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "CPAK": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:CPAK": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "SFP": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:SFP": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "SFP_PLUS": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:SFP_PLUS": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "XFP": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:XFP": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "X2": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:X2": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "NON_PLUGGABLE": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:NON_PLUGGABLE": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "OTHER": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:OTHER": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                    },
                ),
                is_leaf=True,
                yang_name="form-factor-preconf",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/platform/transceiver",
                defining_module="openconfig-platform-transceiver",
                yang_type="identityref",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """form_factor_preconf must be of a type compatible with identityref""",
                    "defined-type": "openconfig-platform-transceiver:identityref",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=six.text_type, restriction_type="dict_key", restriction_arg={'CFP': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:CFP': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'CFP2': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:CFP2': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'CFP2_ACO': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:CFP2_ACO': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'CFP4': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:CFP4': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'QSFP': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:QSFP': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'QSFP_PLUS': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:QSFP_PLUS': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'QSFP28': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:QSFP28': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'CPAK': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:CPAK': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'SFP': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:SFP': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'SFP_PLUS': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:SFP_PLUS': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'XFP': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:XFP': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'X2': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:X2': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'NON_PLUGGABLE': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:NON_PLUGGABLE': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'OTHER': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:OTHER': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}},), is_leaf=True, yang_name="form-factor-preconf", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/platform/transceiver', defining_module='openconfig-platform-transceiver', yang_type='identityref', is_config=True)""",
                }
            )

        self.__form_factor_preconf = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_form_factor_preconf(self):
        self.__form_factor_preconf = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_type="dict_key",
                restriction_arg={
                    "CFP": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:CFP": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "CFP2": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:CFP2": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "CFP2_ACO": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:CFP2_ACO": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "CFP4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:CFP4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "QSFP": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:QSFP": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "QSFP_PLUS": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:QSFP_PLUS": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "QSFP28": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:QSFP28": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "CPAK": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:CPAK": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "SFP": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:SFP": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "SFP_PLUS": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:SFP_PLUS": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "XFP": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:XFP": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "X2": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:X2": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "NON_PLUGGABLE": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:NON_PLUGGABLE": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "OTHER": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:OTHER": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                },
            ),
            is_leaf=True,
            yang_name="form-factor-preconf",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/platform/transceiver",
            defining_module="openconfig-platform-transceiver",
            yang_type="identityref",
            is_config=True,
        )

    def _get_ethernet_pmd_preconf(self):
        """
    Getter method for ethernet_pmd_preconf, mapped from YANG variable /components/component/transceiver/config/ethernet_pmd_preconf (identityref)

    YANG Description: The Ethernet PMD is a property of the optical transceiver
used on the port, indicating the type of physical connection.
It is included in configuration data to allow pre-configuring
a port/transceiver with the expected PMD.  The actual PMD is
indicated by the ethernet-pmd state leaf.
    """
        return self.__ethernet_pmd_preconf

    def _set_ethernet_pmd_preconf(self, v, load=False):
        """
    Setter method for ethernet_pmd_preconf, mapped from YANG variable /components/component/transceiver/config/ethernet_pmd_preconf (identityref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_ethernet_pmd_preconf is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_ethernet_pmd_preconf() directly.

    YANG Description: The Ethernet PMD is a property of the optical transceiver
used on the port, indicating the type of physical connection.
It is included in configuration data to allow pre-configuring
a port/transceiver with the expected PMD.  The actual PMD is
indicated by the ethernet-pmd state leaf.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=six.text_type,
                    restriction_type="dict_key",
                    restriction_arg={
                        "ETH_10GBASE_LRM": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:ETH_10GBASE_LRM": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "ETH_10GBASE_LR": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:ETH_10GBASE_LR": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "ETH_10GBASE_ZR": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:ETH_10GBASE_ZR": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "ETH_10GBASE_ER": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:ETH_10GBASE_ER": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "ETH_10GBASE_SR": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:ETH_10GBASE_SR": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "ETH_40GBASE_CR4": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:ETH_40GBASE_CR4": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "ETH_40GBASE_SR4": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:ETH_40GBASE_SR4": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "ETH_40GBASE_LR4": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:ETH_40GBASE_LR4": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "ETH_40GBASE_ER4": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:ETH_40GBASE_ER4": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "ETH_40GBASE_PSM4": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:ETH_40GBASE_PSM4": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "ETH_4X10GBASE_LR": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:ETH_4X10GBASE_LR": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "ETH_4X10GBASE_SR": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:ETH_4X10GBASE_SR": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "ETH_100G_AOC": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:ETH_100G_AOC": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "ETH_100G_ACC": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:ETH_100G_ACC": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "ETH_100GBASE_SR10": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:ETH_100GBASE_SR10": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "ETH_100GBASE_SR4": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:ETH_100GBASE_SR4": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "ETH_100GBASE_LR4": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:ETH_100GBASE_LR4": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "ETH_100GBASE_ER4": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:ETH_100GBASE_ER4": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "ETH_100GBASE_CWDM4": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:ETH_100GBASE_CWDM4": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "ETH_100GBASE_CLR4": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:ETH_100GBASE_CLR4": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "ETH_100GBASE_PSM4": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:ETH_100GBASE_PSM4": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "ETH_100GBASE_CR4": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:ETH_100GBASE_CR4": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "ETH_UNDEFINED": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                        "oc-opt-types:ETH_UNDEFINED": {
                            "@module": "openconfig-transport-types",
                            "@namespace": "http://openconfig.net/yang/transport-types",
                        },
                    },
                ),
                is_leaf=True,
                yang_name="ethernet-pmd-preconf",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/platform/transceiver",
                defining_module="openconfig-platform-transceiver",
                yang_type="identityref",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """ethernet_pmd_preconf must be of a type compatible with identityref""",
                    "defined-type": "openconfig-platform-transceiver:identityref",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=six.text_type, restriction_type="dict_key", restriction_arg={'ETH_10GBASE_LRM': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:ETH_10GBASE_LRM': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'ETH_10GBASE_LR': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:ETH_10GBASE_LR': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'ETH_10GBASE_ZR': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:ETH_10GBASE_ZR': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'ETH_10GBASE_ER': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:ETH_10GBASE_ER': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'ETH_10GBASE_SR': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:ETH_10GBASE_SR': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'ETH_40GBASE_CR4': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:ETH_40GBASE_CR4': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'ETH_40GBASE_SR4': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:ETH_40GBASE_SR4': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'ETH_40GBASE_LR4': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:ETH_40GBASE_LR4': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'ETH_40GBASE_ER4': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:ETH_40GBASE_ER4': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'ETH_40GBASE_PSM4': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:ETH_40GBASE_PSM4': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'ETH_4X10GBASE_LR': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:ETH_4X10GBASE_LR': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'ETH_4X10GBASE_SR': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:ETH_4X10GBASE_SR': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'ETH_100G_AOC': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:ETH_100G_AOC': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'ETH_100G_ACC': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:ETH_100G_ACC': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'ETH_100GBASE_SR10': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:ETH_100GBASE_SR10': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'ETH_100GBASE_SR4': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:ETH_100GBASE_SR4': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'ETH_100GBASE_LR4': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:ETH_100GBASE_LR4': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'ETH_100GBASE_ER4': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:ETH_100GBASE_ER4': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'ETH_100GBASE_CWDM4': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:ETH_100GBASE_CWDM4': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'ETH_100GBASE_CLR4': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:ETH_100GBASE_CLR4': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'ETH_100GBASE_PSM4': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:ETH_100GBASE_PSM4': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'ETH_100GBASE_CR4': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:ETH_100GBASE_CR4': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'ETH_UNDEFINED': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}, 'oc-opt-types:ETH_UNDEFINED': {'@module': 'openconfig-transport-types', '@namespace': 'http://openconfig.net/yang/transport-types'}},), is_leaf=True, yang_name="ethernet-pmd-preconf", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/platform/transceiver', defining_module='openconfig-platform-transceiver', yang_type='identityref', is_config=True)""",
                }
            )

        self.__ethernet_pmd_preconf = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_ethernet_pmd_preconf(self):
        self.__ethernet_pmd_preconf = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_type="dict_key",
                restriction_arg={
                    "ETH_10GBASE_LRM": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_10GBASE_LRM": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_10GBASE_LR": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_10GBASE_LR": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_10GBASE_ZR": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_10GBASE_ZR": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_10GBASE_ER": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_10GBASE_ER": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_10GBASE_SR": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_10GBASE_SR": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_40GBASE_CR4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_40GBASE_CR4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_40GBASE_SR4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_40GBASE_SR4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_40GBASE_LR4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_40GBASE_LR4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_40GBASE_ER4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_40GBASE_ER4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_40GBASE_PSM4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_40GBASE_PSM4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_4X10GBASE_LR": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_4X10GBASE_LR": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_4X10GBASE_SR": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_4X10GBASE_SR": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_100G_AOC": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_100G_AOC": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_100G_ACC": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_100G_ACC": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_100GBASE_SR10": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_100GBASE_SR10": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_100GBASE_SR4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_100GBASE_SR4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_100GBASE_LR4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_100GBASE_LR4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_100GBASE_ER4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_100GBASE_ER4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_100GBASE_CWDM4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_100GBASE_CWDM4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_100GBASE_CLR4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_100GBASE_CLR4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_100GBASE_PSM4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_100GBASE_PSM4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_100GBASE_CR4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_100GBASE_CR4": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "ETH_UNDEFINED": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                    "oc-opt-types:ETH_UNDEFINED": {
                        "@module": "openconfig-transport-types",
                        "@namespace": "http://openconfig.net/yang/transport-types",
                    },
                },
            ),
            is_leaf=True,
            yang_name="ethernet-pmd-preconf",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/platform/transceiver",
            defining_module="openconfig-platform-transceiver",
            yang_type="identityref",
            is_config=True,
        )

    enabled = __builtin__.property(_get_enabled, _set_enabled)
    form_factor_preconf = __builtin__.property(
        _get_form_factor_preconf, _set_form_factor_preconf
    )
    ethernet_pmd_preconf = __builtin__.property(
        _get_ethernet_pmd_preconf, _set_ethernet_pmd_preconf
    )

    _pyangbind_elements = OrderedDict(
        [
            ("enabled", enabled),
            ("form_factor_preconf", form_factor_preconf),
            ("ethernet_pmd_preconf", ethernet_pmd_preconf),
        ]
    )
