# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal
from bitarray import bitarray
import six

# PY3 support of some PY2 keywords (needs improved)
if six.PY3:
    import builtins as __builtin__

    long = int
elif six.PY2:
    import __builtin__


class config(PybindBase):
    """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance - based on the path /network-instances/network-instance/config. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration parameters relating to a network
instance
  """
    __slots__ = (
        "_path_helper",
        "_extmethods",
        "__name",
        "__type",
        "__enabled",
        "__description",
        "__router_id",
        "__route_distinguisher",
        "__enabled_address_families",
        "__mtu",
    )

    _yang_name = "config"

    _pybind_generated_by = "container"

    def __init__(self, *args, **kwargs):

        self._path_helper = False

        self._extmethods = False
        self.__name = YANGDynClass(
            base=six.text_type,
            is_leaf=True,
            yang_name="name",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="string",
            is_config=True,
        )
        self.__type = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_type="dict_key",
                restriction_arg={
                    "DEFAULT_INSTANCE": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "oc-ni-types:DEFAULT_INSTANCE": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "L3VRF": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "oc-ni-types:L3VRF": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "L2VSI": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "oc-ni-types:L2VSI": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "L2P2P": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "oc-ni-types:L2P2P": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "L2L3": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "oc-ni-types:L2L3": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                },
            ),
            is_leaf=True,
            yang_name="type",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="identityref",
            is_config=True,
        )
        self.__enabled = YANGDynClass(
            base=YANGBool,
            is_leaf=True,
            yang_name="enabled",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="boolean",
            is_config=True,
        )
        self.__description = YANGDynClass(
            base=six.text_type,
            is_leaf=True,
            yang_name="description",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="string",
            is_config=True,
        )
        self.__router_id = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_dict={
                    "pattern": "(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])"
                },
            ),
            is_leaf=True,
            yang_name="router-id",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="yang:dotted-quad",
            is_config=True,
        )
        self.__route_distinguisher = YANGDynClass(
            base=[
                RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "^(65[0-5][0-3][0-5]|[1-5][1-5][0-9][0-9][0-9]|[1-9]?[1-9]?[0-9][0-9]|[1-9]):(4[0-2][0-9][0-4][0-9][0-6][0-7][0-2][0-9][0-5]|[0-3][0-9]{9}|[1-9][0-9]{1,8}|[1-9])$"
                    },
                ),
                RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "^(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5]):(65[0-5][0-3][0-5]|[1-5][1-5][0-9][0-9][0-9]|[1-9]?[1-9]?[0-9][0-9]|[1-9])$"
                    },
                ),
                RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "^(4[0-2][0-9][0-4][0-9][0-6][0-7][0-2][0-9][0-5]|[0-3][0-9]{9}|[1-9][0-9]{1,8}|[1-9]):(65[0-5][0-3][0-5]|[1-5]{2}[0-9]{3}|[1-9]{0,2}[0-9][0-9]|[1-9])$"
                    },
                ),
            ],
            is_leaf=True,
            yang_name="route-distinguisher",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="oc-ni-types:route-distinguisher",
            is_config=True,
        )
        self.__enabled_address_families = YANGDynClass(
            base=TypedListType(
                allowed_type=RestrictedClassType(
                    base_type=six.text_type,
                    restriction_type="dict_key",
                    restriction_arg={
                        "IPV4": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "oc-types:IPV4": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "octypes:IPV4": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "IPV6": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "oc-types:IPV6": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "octypes:IPV6": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "MPLS": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "oc-types:MPLS": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "octypes:MPLS": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "L2_ETHERNET": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "oc-types:L2_ETHERNET": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "octypes:L2_ETHERNET": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                    },
                )
            ),
            is_leaf=False,
            yang_name="enabled-address-families",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="identityref",
            is_config=True,
        )
        self.__mtu = YANGDynClass(
            base=RestrictedClassType(
                base_type=int, restriction_dict={"range": ["0..65535"]}, int_size=16
            ),
            is_leaf=True,
            yang_name="mtu",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="uint16",
            is_config=True,
        )

        load = kwargs.pop("load", None)
        if args:
            if len(args) > 1:
                raise TypeError("cannot create a YANG container with >1 argument")
            all_attr = True
            for e in self._pyangbind_elements:
                if not hasattr(args[0], e):
                    all_attr = False
                    break
            if not all_attr:
                raise ValueError("Supplied object did not have the correct attributes")
            for e in self._pyangbind_elements:
                nobj = getattr(args[0], e)
                if nobj._changed() is False:
                    continue
                setmethod = getattr(self, "_set_%s" % e)
                if load is None:
                    setmethod(getattr(args[0], e))
                else:
                    setmethod(getattr(args[0], e), load=load)

    def _path(self):
        if hasattr(self, "_parent"):
            return self._parent._path() + [self._yang_name]
        else:
            return ["network-instances", "network-instance", "config"]

    def _get_name(self):
        """
    Getter method for name, mapped from YANG variable /network_instances/network_instance/config/name (string)

    YANG Description: An operator-assigned unique name for the forwarding
instance
    """
        return self.__name

    def _set_name(self, v, load=False):
        """
    Setter method for name, mapped from YANG variable /network_instances/network_instance/config/name (string)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_name is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_name() directly.

    YANG Description: An operator-assigned unique name for the forwarding
instance
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=six.text_type,
                is_leaf=True,
                yang_name="name",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="string",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """name must be of a type compatible with string""",
                    "defined-type": "string",
                    "generated-type": """YANGDynClass(base=six.text_type, is_leaf=True, yang_name="name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='string', is_config=True)""",
                }
            )

        self.__name = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_name(self):
        self.__name = YANGDynClass(
            base=six.text_type,
            is_leaf=True,
            yang_name="name",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="string",
            is_config=True,
        )

    def _get_type(self):
        """
    Getter method for type, mapped from YANG variable /network_instances/network_instance/config/type (identityref)

    YANG Description: The type of network instance. The value of this leaf
indicates the type of forwarding entries that should be
supported by this network instance
    """
        return self.__type

    def _set_type(self, v, load=False):
        """
    Setter method for type, mapped from YANG variable /network_instances/network_instance/config/type (identityref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_type is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_type() directly.

    YANG Description: The type of network instance. The value of this leaf
indicates the type of forwarding entries that should be
supported by this network instance
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=six.text_type,
                    restriction_type="dict_key",
                    restriction_arg={
                        "DEFAULT_INSTANCE": {
                            "@module": "openconfig-network-instance-types",
                            "@namespace": "http://openconfig.net/yang/network-instance-types",
                        },
                        "oc-ni-types:DEFAULT_INSTANCE": {
                            "@module": "openconfig-network-instance-types",
                            "@namespace": "http://openconfig.net/yang/network-instance-types",
                        },
                        "L3VRF": {
                            "@module": "openconfig-network-instance-types",
                            "@namespace": "http://openconfig.net/yang/network-instance-types",
                        },
                        "oc-ni-types:L3VRF": {
                            "@module": "openconfig-network-instance-types",
                            "@namespace": "http://openconfig.net/yang/network-instance-types",
                        },
                        "L2VSI": {
                            "@module": "openconfig-network-instance-types",
                            "@namespace": "http://openconfig.net/yang/network-instance-types",
                        },
                        "oc-ni-types:L2VSI": {
                            "@module": "openconfig-network-instance-types",
                            "@namespace": "http://openconfig.net/yang/network-instance-types",
                        },
                        "L2P2P": {
                            "@module": "openconfig-network-instance-types",
                            "@namespace": "http://openconfig.net/yang/network-instance-types",
                        },
                        "oc-ni-types:L2P2P": {
                            "@module": "openconfig-network-instance-types",
                            "@namespace": "http://openconfig.net/yang/network-instance-types",
                        },
                        "L2L3": {
                            "@module": "openconfig-network-instance-types",
                            "@namespace": "http://openconfig.net/yang/network-instance-types",
                        },
                        "oc-ni-types:L2L3": {
                            "@module": "openconfig-network-instance-types",
                            "@namespace": "http://openconfig.net/yang/network-instance-types",
                        },
                    },
                ),
                is_leaf=True,
                yang_name="type",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="identityref",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """type must be of a type compatible with identityref""",
                    "defined-type": "openconfig-network-instance:identityref",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=six.text_type, restriction_type="dict_key", restriction_arg={'DEFAULT_INSTANCE': {'@module': 'openconfig-network-instance-types', '@namespace': 'http://openconfig.net/yang/network-instance-types'}, 'oc-ni-types:DEFAULT_INSTANCE': {'@module': 'openconfig-network-instance-types', '@namespace': 'http://openconfig.net/yang/network-instance-types'}, 'L3VRF': {'@module': 'openconfig-network-instance-types', '@namespace': 'http://openconfig.net/yang/network-instance-types'}, 'oc-ni-types:L3VRF': {'@module': 'openconfig-network-instance-types', '@namespace': 'http://openconfig.net/yang/network-instance-types'}, 'L2VSI': {'@module': 'openconfig-network-instance-types', '@namespace': 'http://openconfig.net/yang/network-instance-types'}, 'oc-ni-types:L2VSI': {'@module': 'openconfig-network-instance-types', '@namespace': 'http://openconfig.net/yang/network-instance-types'}, 'L2P2P': {'@module': 'openconfig-network-instance-types', '@namespace': 'http://openconfig.net/yang/network-instance-types'}, 'oc-ni-types:L2P2P': {'@module': 'openconfig-network-instance-types', '@namespace': 'http://openconfig.net/yang/network-instance-types'}, 'L2L3': {'@module': 'openconfig-network-instance-types', '@namespace': 'http://openconfig.net/yang/network-instance-types'}, 'oc-ni-types:L2L3': {'@module': 'openconfig-network-instance-types', '@namespace': 'http://openconfig.net/yang/network-instance-types'}},), is_leaf=True, yang_name="type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='identityref', is_config=True)""",
                }
            )

        self.__type = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_type(self):
        self.__type = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_type="dict_key",
                restriction_arg={
                    "DEFAULT_INSTANCE": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "oc-ni-types:DEFAULT_INSTANCE": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "L3VRF": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "oc-ni-types:L3VRF": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "L2VSI": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "oc-ni-types:L2VSI": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "L2P2P": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "oc-ni-types:L2P2P": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "L2L3": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "oc-ni-types:L2L3": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                },
            ),
            is_leaf=True,
            yang_name="type",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="identityref",
            is_config=True,
        )

    def _get_enabled(self):
        """
    Getter method for enabled, mapped from YANG variable /network_instances/network_instance/config/enabled (boolean)

    YANG Description: Whether the network instance should be configured to be
active on the network element
    """
        return self.__enabled

    def _set_enabled(self, v, load=False):
        """
    Setter method for enabled, mapped from YANG variable /network_instances/network_instance/config/enabled (boolean)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_enabled is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_enabled() directly.

    YANG Description: Whether the network instance should be configured to be
active on the network element
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=YANGBool,
                is_leaf=True,
                yang_name="enabled",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="boolean",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """enabled must be of a type compatible with boolean""",
                    "defined-type": "boolean",
                    "generated-type": """YANGDynClass(base=YANGBool, is_leaf=True, yang_name="enabled", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='boolean', is_config=True)""",
                }
            )

        self.__enabled = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_enabled(self):
        self.__enabled = YANGDynClass(
            base=YANGBool,
            is_leaf=True,
            yang_name="enabled",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="boolean",
            is_config=True,
        )

    def _get_description(self):
        """
    Getter method for description, mapped from YANG variable /network_instances/network_instance/config/description (string)

    YANG Description: A free-form string to be used by the network operator to
describe the function of this network instance
    """
        return self.__description

    def _set_description(self, v, load=False):
        """
    Setter method for description, mapped from YANG variable /network_instances/network_instance/config/description (string)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_description is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_description() directly.

    YANG Description: A free-form string to be used by the network operator to
describe the function of this network instance
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=six.text_type,
                is_leaf=True,
                yang_name="description",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="string",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """description must be of a type compatible with string""",
                    "defined-type": "string",
                    "generated-type": """YANGDynClass(base=six.text_type, is_leaf=True, yang_name="description", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='string', is_config=True)""",
                }
            )

        self.__description = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_description(self):
        self.__description = YANGDynClass(
            base=six.text_type,
            is_leaf=True,
            yang_name="description",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="string",
            is_config=True,
        )

    def _get_router_id(self):
        """
    Getter method for router_id, mapped from YANG variable /network_instances/network_instance/config/router_id (yang:dotted-quad)

    YANG Description: A identifier for the local network instance - typically
used within associated routing protocols or signalling
routing information in another network instance
    """
        return self.__router_id

    def _set_router_id(self, v, load=False):
        """
    Setter method for router_id, mapped from YANG variable /network_instances/network_instance/config/router_id (yang:dotted-quad)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_router_id is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_router_id() directly.

    YANG Description: A identifier for the local network instance - typically
used within associated routing protocols or signalling
routing information in another network instance
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])"
                    },
                ),
                is_leaf=True,
                yang_name="router-id",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="yang:dotted-quad",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """router_id must be of a type compatible with yang:dotted-quad""",
                    "defined-type": "yang:dotted-quad",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=six.text_type, restriction_dict={'pattern': '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])'}), is_leaf=True, yang_name="router-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='yang:dotted-quad', is_config=True)""",
                }
            )

        self.__router_id = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_router_id(self):
        self.__router_id = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_dict={
                    "pattern": "(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])"
                },
            ),
            is_leaf=True,
            yang_name="router-id",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="yang:dotted-quad",
            is_config=True,
        )

    def _get_route_distinguisher(self):
        """
    Getter method for route_distinguisher, mapped from YANG variable /network_instances/network_instance/config/route_distinguisher (oc-ni-types:route-distinguisher)

    YANG Description: The route distinguisher that should be used for the local
VRF or VSI instance when it is signalled via BGP.
    """
        return self.__route_distinguisher

    def _set_route_distinguisher(self, v, load=False):
        """
    Setter method for route_distinguisher, mapped from YANG variable /network_instances/network_instance/config/route_distinguisher (oc-ni-types:route-distinguisher)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_route_distinguisher is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_route_distinguisher() directly.

    YANG Description: The route distinguisher that should be used for the local
VRF or VSI instance when it is signalled via BGP.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=[
                    RestrictedClassType(
                        base_type=six.text_type,
                        restriction_dict={
                            "pattern": "^(65[0-5][0-3][0-5]|[1-5][1-5][0-9][0-9][0-9]|[1-9]?[1-9]?[0-9][0-9]|[1-9]):(4[0-2][0-9][0-4][0-9][0-6][0-7][0-2][0-9][0-5]|[0-3][0-9]{9}|[1-9][0-9]{1,8}|[1-9])$"
                        },
                    ),
                    RestrictedClassType(
                        base_type=six.text_type,
                        restriction_dict={
                            "pattern": "^(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5]):(65[0-5][0-3][0-5]|[1-5][1-5][0-9][0-9][0-9]|[1-9]?[1-9]?[0-9][0-9]|[1-9])$"
                        },
                    ),
                    RestrictedClassType(
                        base_type=six.text_type,
                        restriction_dict={
                            "pattern": "^(4[0-2][0-9][0-4][0-9][0-6][0-7][0-2][0-9][0-5]|[0-3][0-9]{9}|[1-9][0-9]{1,8}|[1-9]):(65[0-5][0-3][0-5]|[1-5]{2}[0-9]{3}|[1-9]{0,2}[0-9][0-9]|[1-9])$"
                        },
                    ),
                ],
                is_leaf=True,
                yang_name="route-distinguisher",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="oc-ni-types:route-distinguisher",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """route_distinguisher must be of a type compatible with oc-ni-types:route-distinguisher""",
                    "defined-type": "oc-ni-types:route-distinguisher",
                    "generated-type": """YANGDynClass(base=[RestrictedClassType(base_type=six.text_type, restriction_dict={'pattern': '^(65[0-5][0-3][0-5]|[1-5][1-5][0-9][0-9][0-9]|[1-9]?[1-9]?[0-9][0-9]|[1-9]):(4[0-2][0-9][0-4][0-9][0-6][0-7][0-2][0-9][0-5]|[0-3][0-9]{9}|[1-9][0-9]{1,8}|[1-9])$'}),RestrictedClassType(base_type=six.text_type, restriction_dict={'pattern': '^(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5]):(65[0-5][0-3][0-5]|[1-5][1-5][0-9][0-9][0-9]|[1-9]?[1-9]?[0-9][0-9]|[1-9])$'}),RestrictedClassType(base_type=six.text_type, restriction_dict={'pattern': '^(4[0-2][0-9][0-4][0-9][0-6][0-7][0-2][0-9][0-5]|[0-3][0-9]{9}|[1-9][0-9]{1,8}|[1-9]):(65[0-5][0-3][0-5]|[1-5]{2}[0-9]{3}|[1-9]{0,2}[0-9][0-9]|[1-9])$'}),], is_leaf=True, yang_name="route-distinguisher", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-ni-types:route-distinguisher', is_config=True)""",
                }
            )

        self.__route_distinguisher = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_route_distinguisher(self):
        self.__route_distinguisher = YANGDynClass(
            base=[
                RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "^(65[0-5][0-3][0-5]|[1-5][1-5][0-9][0-9][0-9]|[1-9]?[1-9]?[0-9][0-9]|[1-9]):(4[0-2][0-9][0-4][0-9][0-6][0-7][0-2][0-9][0-5]|[0-3][0-9]{9}|[1-9][0-9]{1,8}|[1-9])$"
                    },
                ),
                RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "^(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5]):(65[0-5][0-3][0-5]|[1-5][1-5][0-9][0-9][0-9]|[1-9]?[1-9]?[0-9][0-9]|[1-9])$"
                    },
                ),
                RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "^(4[0-2][0-9][0-4][0-9][0-6][0-7][0-2][0-9][0-5]|[0-3][0-9]{9}|[1-9][0-9]{1,8}|[1-9]):(65[0-5][0-3][0-5]|[1-5]{2}[0-9]{3}|[1-9]{0,2}[0-9][0-9]|[1-9])$"
                    },
                ),
            ],
            is_leaf=True,
            yang_name="route-distinguisher",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="oc-ni-types:route-distinguisher",
            is_config=True,
        )

    def _get_enabled_address_families(self):
        """
    Getter method for enabled_address_families, mapped from YANG variable /network_instances/network_instance/config/enabled_address_families (identityref)

    YANG Description: The address families that are to be enabled for this
network instance.
    """
        return self.__enabled_address_families

    def _set_enabled_address_families(self, v, load=False):
        """
    Setter method for enabled_address_families, mapped from YANG variable /network_instances/network_instance/config/enabled_address_families (identityref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_enabled_address_families is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_enabled_address_families() directly.

    YANG Description: The address families that are to be enabled for this
network instance.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=TypedListType(
                    allowed_type=RestrictedClassType(
                        base_type=six.text_type,
                        restriction_type="dict_key",
                        restriction_arg={
                            "IPV4": {
                                "@module": "openconfig-types",
                                "@namespace": "http://openconfig.net/yang/openconfig-types",
                            },
                            "oc-types:IPV4": {
                                "@module": "openconfig-types",
                                "@namespace": "http://openconfig.net/yang/openconfig-types",
                            },
                            "octypes:IPV4": {
                                "@module": "openconfig-types",
                                "@namespace": "http://openconfig.net/yang/openconfig-types",
                            },
                            "IPV6": {
                                "@module": "openconfig-types",
                                "@namespace": "http://openconfig.net/yang/openconfig-types",
                            },
                            "oc-types:IPV6": {
                                "@module": "openconfig-types",
                                "@namespace": "http://openconfig.net/yang/openconfig-types",
                            },
                            "octypes:IPV6": {
                                "@module": "openconfig-types",
                                "@namespace": "http://openconfig.net/yang/openconfig-types",
                            },
                            "MPLS": {
                                "@module": "openconfig-types",
                                "@namespace": "http://openconfig.net/yang/openconfig-types",
                            },
                            "oc-types:MPLS": {
                                "@module": "openconfig-types",
                                "@namespace": "http://openconfig.net/yang/openconfig-types",
                            },
                            "octypes:MPLS": {
                                "@module": "openconfig-types",
                                "@namespace": "http://openconfig.net/yang/openconfig-types",
                            },
                            "L2_ETHERNET": {
                                "@module": "openconfig-types",
                                "@namespace": "http://openconfig.net/yang/openconfig-types",
                            },
                            "oc-types:L2_ETHERNET": {
                                "@module": "openconfig-types",
                                "@namespace": "http://openconfig.net/yang/openconfig-types",
                            },
                            "octypes:L2_ETHERNET": {
                                "@module": "openconfig-types",
                                "@namespace": "http://openconfig.net/yang/openconfig-types",
                            },
                        },
                    )
                ),
                is_leaf=False,
                yang_name="enabled-address-families",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="identityref",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """enabled_address_families must be of a type compatible with identityref""",
                    "defined-type": "openconfig-network-instance:identityref",
                    "generated-type": """YANGDynClass(base=TypedListType(allowed_type=RestrictedClassType(base_type=six.text_type, restriction_type="dict_key", restriction_arg={'IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}},)), is_leaf=False, yang_name="enabled-address-families", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='identityref', is_config=True)""",
                }
            )

        self.__enabled_address_families = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_enabled_address_families(self):
        self.__enabled_address_families = YANGDynClass(
            base=TypedListType(
                allowed_type=RestrictedClassType(
                    base_type=six.text_type,
                    restriction_type="dict_key",
                    restriction_arg={
                        "IPV4": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "oc-types:IPV4": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "octypes:IPV4": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "IPV6": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "oc-types:IPV6": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "octypes:IPV6": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "MPLS": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "oc-types:MPLS": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "octypes:MPLS": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "L2_ETHERNET": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "oc-types:L2_ETHERNET": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "octypes:L2_ETHERNET": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                    },
                )
            ),
            is_leaf=False,
            yang_name="enabled-address-families",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="identityref",
            is_config=True,
        )

    def _get_mtu(self):
        """
    Getter method for mtu, mapped from YANG variable /network_instances/network_instance/config/mtu (uint16)

    YANG Description: The maximum frame size which should be supported for this
instance for Layer 2 frames
    """
        return self.__mtu

    def _set_mtu(self, v, load=False):
        """
    Setter method for mtu, mapped from YANG variable /network_instances/network_instance/config/mtu (uint16)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_mtu is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_mtu() directly.

    YANG Description: The maximum frame size which should be supported for this
instance for Layer 2 frames
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=int, restriction_dict={"range": ["0..65535"]}, int_size=16
                ),
                is_leaf=True,
                yang_name="mtu",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="uint16",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """mtu must be of a type compatible with uint16""",
                    "defined-type": "uint16",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), is_leaf=True, yang_name="mtu", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint16', is_config=True)""",
                }
            )

        self.__mtu = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_mtu(self):
        self.__mtu = YANGDynClass(
            base=RestrictedClassType(
                base_type=int, restriction_dict={"range": ["0..65535"]}, int_size=16
            ),
            is_leaf=True,
            yang_name="mtu",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="uint16",
            is_config=True,
        )

    name = __builtin__.property(_get_name, _set_name)
    type = __builtin__.property(_get_type, _set_type)
    enabled = __builtin__.property(_get_enabled, _set_enabled)
    description = __builtin__.property(_get_description, _set_description)
    router_id = __builtin__.property(_get_router_id, _set_router_id)
    route_distinguisher = __builtin__.property(
        _get_route_distinguisher, _set_route_distinguisher
    )
    enabled_address_families = __builtin__.property(
        _get_enabled_address_families, _set_enabled_address_families
    )
    mtu = __builtin__.property(_get_mtu, _set_mtu)

    _pyangbind_elements = OrderedDict(
        [
            ("name", name),
            ("type", type),
            ("enabled", enabled),
            ("description", description),
            ("router_id", router_id),
            ("route_distinguisher", route_distinguisher),
            ("enabled_address_families", enabled_address_families),
            ("mtu", mtu),
        ]
    )


class config(PybindBase):
    """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance-l2 - based on the path /network-instances/network-instance/config. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration parameters relating to a network
instance
  """
    __slots__ = (
        "_path_helper",
        "_extmethods",
        "__name",
        "__type",
        "__enabled",
        "__description",
        "__router_id",
        "__route_distinguisher",
        "__enabled_address_families",
        "__mtu",
    )

    _yang_name = "config"

    _pybind_generated_by = "container"

    def __init__(self, *args, **kwargs):

        self._path_helper = False

        self._extmethods = False
        self.__name = YANGDynClass(
            base=six.text_type,
            is_leaf=True,
            yang_name="name",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="string",
            is_config=True,
        )
        self.__type = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_type="dict_key",
                restriction_arg={
                    "DEFAULT_INSTANCE": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "oc-ni-types:DEFAULT_INSTANCE": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "L3VRF": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "oc-ni-types:L3VRF": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "L2VSI": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "oc-ni-types:L2VSI": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "L2P2P": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "oc-ni-types:L2P2P": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "L2L3": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "oc-ni-types:L2L3": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                },
            ),
            is_leaf=True,
            yang_name="type",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="identityref",
            is_config=True,
        )
        self.__enabled = YANGDynClass(
            base=YANGBool,
            is_leaf=True,
            yang_name="enabled",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="boolean",
            is_config=True,
        )
        self.__description = YANGDynClass(
            base=six.text_type,
            is_leaf=True,
            yang_name="description",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="string",
            is_config=True,
        )
        self.__router_id = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_dict={
                    "pattern": "(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])"
                },
            ),
            is_leaf=True,
            yang_name="router-id",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="yang:dotted-quad",
            is_config=True,
        )
        self.__route_distinguisher = YANGDynClass(
            base=[
                RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "^(65[0-5][0-3][0-5]|[1-5][1-5][0-9][0-9][0-9]|[1-9]?[1-9]?[0-9][0-9]|[1-9]):(4[0-2][0-9][0-4][0-9][0-6][0-7][0-2][0-9][0-5]|[0-3][0-9]{9}|[1-9][0-9]{1,8}|[1-9])$"
                    },
                ),
                RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "^(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5]):(65[0-5][0-3][0-5]|[1-5][1-5][0-9][0-9][0-9]|[1-9]?[1-9]?[0-9][0-9]|[1-9])$"
                    },
                ),
                RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "^(4[0-2][0-9][0-4][0-9][0-6][0-7][0-2][0-9][0-5]|[0-3][0-9]{9}|[1-9][0-9]{1,8}|[1-9]):(65[0-5][0-3][0-5]|[1-5]{2}[0-9]{3}|[1-9]{0,2}[0-9][0-9]|[1-9])$"
                    },
                ),
            ],
            is_leaf=True,
            yang_name="route-distinguisher",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="oc-ni-types:route-distinguisher",
            is_config=True,
        )
        self.__enabled_address_families = YANGDynClass(
            base=TypedListType(
                allowed_type=RestrictedClassType(
                    base_type=six.text_type,
                    restriction_type="dict_key",
                    restriction_arg={
                        "IPV4": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "oc-types:IPV4": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "octypes:IPV4": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "IPV6": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "oc-types:IPV6": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "octypes:IPV6": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "MPLS": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "oc-types:MPLS": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "octypes:MPLS": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "L2_ETHERNET": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "oc-types:L2_ETHERNET": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "octypes:L2_ETHERNET": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                    },
                )
            ),
            is_leaf=False,
            yang_name="enabled-address-families",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="identityref",
            is_config=True,
        )
        self.__mtu = YANGDynClass(
            base=RestrictedClassType(
                base_type=int, restriction_dict={"range": ["0..65535"]}, int_size=16
            ),
            is_leaf=True,
            yang_name="mtu",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="uint16",
            is_config=True,
        )

        load = kwargs.pop("load", None)
        if args:
            if len(args) > 1:
                raise TypeError("cannot create a YANG container with >1 argument")
            all_attr = True
            for e in self._pyangbind_elements:
                if not hasattr(args[0], e):
                    all_attr = False
                    break
            if not all_attr:
                raise ValueError("Supplied object did not have the correct attributes")
            for e in self._pyangbind_elements:
                nobj = getattr(args[0], e)
                if nobj._changed() is False:
                    continue
                setmethod = getattr(self, "_set_%s" % e)
                if load is None:
                    setmethod(getattr(args[0], e))
                else:
                    setmethod(getattr(args[0], e), load=load)

    def _path(self):
        if hasattr(self, "_parent"):
            return self._parent._path() + [self._yang_name]
        else:
            return ["network-instances", "network-instance", "config"]

    def _get_name(self):
        """
    Getter method for name, mapped from YANG variable /network_instances/network_instance/config/name (string)

    YANG Description: An operator-assigned unique name for the forwarding
instance
    """
        return self.__name

    def _set_name(self, v, load=False):
        """
    Setter method for name, mapped from YANG variable /network_instances/network_instance/config/name (string)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_name is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_name() directly.

    YANG Description: An operator-assigned unique name for the forwarding
instance
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=six.text_type,
                is_leaf=True,
                yang_name="name",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="string",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """name must be of a type compatible with string""",
                    "defined-type": "string",
                    "generated-type": """YANGDynClass(base=six.text_type, is_leaf=True, yang_name="name", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='string', is_config=True)""",
                }
            )

        self.__name = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_name(self):
        self.__name = YANGDynClass(
            base=six.text_type,
            is_leaf=True,
            yang_name="name",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="string",
            is_config=True,
        )

    def _get_type(self):
        """
    Getter method for type, mapped from YANG variable /network_instances/network_instance/config/type (identityref)

    YANG Description: The type of network instance. The value of this leaf
indicates the type of forwarding entries that should be
supported by this network instance
    """
        return self.__type

    def _set_type(self, v, load=False):
        """
    Setter method for type, mapped from YANG variable /network_instances/network_instance/config/type (identityref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_type is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_type() directly.

    YANG Description: The type of network instance. The value of this leaf
indicates the type of forwarding entries that should be
supported by this network instance
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=six.text_type,
                    restriction_type="dict_key",
                    restriction_arg={
                        "DEFAULT_INSTANCE": {
                            "@module": "openconfig-network-instance-types",
                            "@namespace": "http://openconfig.net/yang/network-instance-types",
                        },
                        "oc-ni-types:DEFAULT_INSTANCE": {
                            "@module": "openconfig-network-instance-types",
                            "@namespace": "http://openconfig.net/yang/network-instance-types",
                        },
                        "L3VRF": {
                            "@module": "openconfig-network-instance-types",
                            "@namespace": "http://openconfig.net/yang/network-instance-types",
                        },
                        "oc-ni-types:L3VRF": {
                            "@module": "openconfig-network-instance-types",
                            "@namespace": "http://openconfig.net/yang/network-instance-types",
                        },
                        "L2VSI": {
                            "@module": "openconfig-network-instance-types",
                            "@namespace": "http://openconfig.net/yang/network-instance-types",
                        },
                        "oc-ni-types:L2VSI": {
                            "@module": "openconfig-network-instance-types",
                            "@namespace": "http://openconfig.net/yang/network-instance-types",
                        },
                        "L2P2P": {
                            "@module": "openconfig-network-instance-types",
                            "@namespace": "http://openconfig.net/yang/network-instance-types",
                        },
                        "oc-ni-types:L2P2P": {
                            "@module": "openconfig-network-instance-types",
                            "@namespace": "http://openconfig.net/yang/network-instance-types",
                        },
                        "L2L3": {
                            "@module": "openconfig-network-instance-types",
                            "@namespace": "http://openconfig.net/yang/network-instance-types",
                        },
                        "oc-ni-types:L2L3": {
                            "@module": "openconfig-network-instance-types",
                            "@namespace": "http://openconfig.net/yang/network-instance-types",
                        },
                    },
                ),
                is_leaf=True,
                yang_name="type",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="identityref",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """type must be of a type compatible with identityref""",
                    "defined-type": "openconfig-network-instance:identityref",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=six.text_type, restriction_type="dict_key", restriction_arg={'DEFAULT_INSTANCE': {'@module': 'openconfig-network-instance-types', '@namespace': 'http://openconfig.net/yang/network-instance-types'}, 'oc-ni-types:DEFAULT_INSTANCE': {'@module': 'openconfig-network-instance-types', '@namespace': 'http://openconfig.net/yang/network-instance-types'}, 'L3VRF': {'@module': 'openconfig-network-instance-types', '@namespace': 'http://openconfig.net/yang/network-instance-types'}, 'oc-ni-types:L3VRF': {'@module': 'openconfig-network-instance-types', '@namespace': 'http://openconfig.net/yang/network-instance-types'}, 'L2VSI': {'@module': 'openconfig-network-instance-types', '@namespace': 'http://openconfig.net/yang/network-instance-types'}, 'oc-ni-types:L2VSI': {'@module': 'openconfig-network-instance-types', '@namespace': 'http://openconfig.net/yang/network-instance-types'}, 'L2P2P': {'@module': 'openconfig-network-instance-types', '@namespace': 'http://openconfig.net/yang/network-instance-types'}, 'oc-ni-types:L2P2P': {'@module': 'openconfig-network-instance-types', '@namespace': 'http://openconfig.net/yang/network-instance-types'}, 'L2L3': {'@module': 'openconfig-network-instance-types', '@namespace': 'http://openconfig.net/yang/network-instance-types'}, 'oc-ni-types:L2L3': {'@module': 'openconfig-network-instance-types', '@namespace': 'http://openconfig.net/yang/network-instance-types'}},), is_leaf=True, yang_name="type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='identityref', is_config=True)""",
                }
            )

        self.__type = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_type(self):
        self.__type = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_type="dict_key",
                restriction_arg={
                    "DEFAULT_INSTANCE": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "oc-ni-types:DEFAULT_INSTANCE": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "L3VRF": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "oc-ni-types:L3VRF": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "L2VSI": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "oc-ni-types:L2VSI": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "L2P2P": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "oc-ni-types:L2P2P": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "L2L3": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                    "oc-ni-types:L2L3": {
                        "@module": "openconfig-network-instance-types",
                        "@namespace": "http://openconfig.net/yang/network-instance-types",
                    },
                },
            ),
            is_leaf=True,
            yang_name="type",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="identityref",
            is_config=True,
        )

    def _get_enabled(self):
        """
    Getter method for enabled, mapped from YANG variable /network_instances/network_instance/config/enabled (boolean)

    YANG Description: Whether the network instance should be configured to be
active on the network element
    """
        return self.__enabled

    def _set_enabled(self, v, load=False):
        """
    Setter method for enabled, mapped from YANG variable /network_instances/network_instance/config/enabled (boolean)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_enabled is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_enabled() directly.

    YANG Description: Whether the network instance should be configured to be
active on the network element
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=YANGBool,
                is_leaf=True,
                yang_name="enabled",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="boolean",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """enabled must be of a type compatible with boolean""",
                    "defined-type": "boolean",
                    "generated-type": """YANGDynClass(base=YANGBool, is_leaf=True, yang_name="enabled", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='boolean', is_config=True)""",
                }
            )

        self.__enabled = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_enabled(self):
        self.__enabled = YANGDynClass(
            base=YANGBool,
            is_leaf=True,
            yang_name="enabled",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="boolean",
            is_config=True,
        )

    def _get_description(self):
        """
    Getter method for description, mapped from YANG variable /network_instances/network_instance/config/description (string)

    YANG Description: A free-form string to be used by the network operator to
describe the function of this network instance
    """
        return self.__description

    def _set_description(self, v, load=False):
        """
    Setter method for description, mapped from YANG variable /network_instances/network_instance/config/description (string)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_description is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_description() directly.

    YANG Description: A free-form string to be used by the network operator to
describe the function of this network instance
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=six.text_type,
                is_leaf=True,
                yang_name="description",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="string",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """description must be of a type compatible with string""",
                    "defined-type": "string",
                    "generated-type": """YANGDynClass(base=six.text_type, is_leaf=True, yang_name="description", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='string', is_config=True)""",
                }
            )

        self.__description = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_description(self):
        self.__description = YANGDynClass(
            base=six.text_type,
            is_leaf=True,
            yang_name="description",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="string",
            is_config=True,
        )

    def _get_router_id(self):
        """
    Getter method for router_id, mapped from YANG variable /network_instances/network_instance/config/router_id (yang:dotted-quad)

    YANG Description: A identifier for the local network instance - typically
used within associated routing protocols or signalling
routing information in another network instance
    """
        return self.__router_id

    def _set_router_id(self, v, load=False):
        """
    Setter method for router_id, mapped from YANG variable /network_instances/network_instance/config/router_id (yang:dotted-quad)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_router_id is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_router_id() directly.

    YANG Description: A identifier for the local network instance - typically
used within associated routing protocols or signalling
routing information in another network instance
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])"
                    },
                ),
                is_leaf=True,
                yang_name="router-id",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="yang:dotted-quad",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """router_id must be of a type compatible with yang:dotted-quad""",
                    "defined-type": "yang:dotted-quad",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=six.text_type, restriction_dict={'pattern': '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])'}), is_leaf=True, yang_name="router-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='yang:dotted-quad', is_config=True)""",
                }
            )

        self.__router_id = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_router_id(self):
        self.__router_id = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_dict={
                    "pattern": "(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])"
                },
            ),
            is_leaf=True,
            yang_name="router-id",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="yang:dotted-quad",
            is_config=True,
        )

    def _get_route_distinguisher(self):
        """
    Getter method for route_distinguisher, mapped from YANG variable /network_instances/network_instance/config/route_distinguisher (oc-ni-types:route-distinguisher)

    YANG Description: The route distinguisher that should be used for the local
VRF or VSI instance when it is signalled via BGP.
    """
        return self.__route_distinguisher

    def _set_route_distinguisher(self, v, load=False):
        """
    Setter method for route_distinguisher, mapped from YANG variable /network_instances/network_instance/config/route_distinguisher (oc-ni-types:route-distinguisher)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_route_distinguisher is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_route_distinguisher() directly.

    YANG Description: The route distinguisher that should be used for the local
VRF or VSI instance when it is signalled via BGP.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=[
                    RestrictedClassType(
                        base_type=six.text_type,
                        restriction_dict={
                            "pattern": "^(65[0-5][0-3][0-5]|[1-5][1-5][0-9][0-9][0-9]|[1-9]?[1-9]?[0-9][0-9]|[1-9]):(4[0-2][0-9][0-4][0-9][0-6][0-7][0-2][0-9][0-5]|[0-3][0-9]{9}|[1-9][0-9]{1,8}|[1-9])$"
                        },
                    ),
                    RestrictedClassType(
                        base_type=six.text_type,
                        restriction_dict={
                            "pattern": "^(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5]):(65[0-5][0-3][0-5]|[1-5][1-5][0-9][0-9][0-9]|[1-9]?[1-9]?[0-9][0-9]|[1-9])$"
                        },
                    ),
                    RestrictedClassType(
                        base_type=six.text_type,
                        restriction_dict={
                            "pattern": "^(4[0-2][0-9][0-4][0-9][0-6][0-7][0-2][0-9][0-5]|[0-3][0-9]{9}|[1-9][0-9]{1,8}|[1-9]):(65[0-5][0-3][0-5]|[1-5]{2}[0-9]{3}|[1-9]{0,2}[0-9][0-9]|[1-9])$"
                        },
                    ),
                ],
                is_leaf=True,
                yang_name="route-distinguisher",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="oc-ni-types:route-distinguisher",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """route_distinguisher must be of a type compatible with oc-ni-types:route-distinguisher""",
                    "defined-type": "oc-ni-types:route-distinguisher",
                    "generated-type": """YANGDynClass(base=[RestrictedClassType(base_type=six.text_type, restriction_dict={'pattern': '^(65[0-5][0-3][0-5]|[1-5][1-5][0-9][0-9][0-9]|[1-9]?[1-9]?[0-9][0-9]|[1-9]):(4[0-2][0-9][0-4][0-9][0-6][0-7][0-2][0-9][0-5]|[0-3][0-9]{9}|[1-9][0-9]{1,8}|[1-9])$'}),RestrictedClassType(base_type=six.text_type, restriction_dict={'pattern': '^(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5]):(65[0-5][0-3][0-5]|[1-5][1-5][0-9][0-9][0-9]|[1-9]?[1-9]?[0-9][0-9]|[1-9])$'}),RestrictedClassType(base_type=six.text_type, restriction_dict={'pattern': '^(4[0-2][0-9][0-4][0-9][0-6][0-7][0-2][0-9][0-5]|[0-3][0-9]{9}|[1-9][0-9]{1,8}|[1-9]):(65[0-5][0-3][0-5]|[1-5]{2}[0-9]{3}|[1-9]{0,2}[0-9][0-9]|[1-9])$'}),], is_leaf=True, yang_name="route-distinguisher", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-ni-types:route-distinguisher', is_config=True)""",
                }
            )

        self.__route_distinguisher = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_route_distinguisher(self):
        self.__route_distinguisher = YANGDynClass(
            base=[
                RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "^(65[0-5][0-3][0-5]|[1-5][1-5][0-9][0-9][0-9]|[1-9]?[1-9]?[0-9][0-9]|[1-9]):(4[0-2][0-9][0-4][0-9][0-6][0-7][0-2][0-9][0-5]|[0-3][0-9]{9}|[1-9][0-9]{1,8}|[1-9])$"
                    },
                ),
                RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "^(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5]):(65[0-5][0-3][0-5]|[1-5][1-5][0-9][0-9][0-9]|[1-9]?[1-9]?[0-9][0-9]|[1-9])$"
                    },
                ),
                RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "^(4[0-2][0-9][0-4][0-9][0-6][0-7][0-2][0-9][0-5]|[0-3][0-9]{9}|[1-9][0-9]{1,8}|[1-9]):(65[0-5][0-3][0-5]|[1-5]{2}[0-9]{3}|[1-9]{0,2}[0-9][0-9]|[1-9])$"
                    },
                ),
            ],
            is_leaf=True,
            yang_name="route-distinguisher",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="oc-ni-types:route-distinguisher",
            is_config=True,
        )

    def _get_enabled_address_families(self):
        """
    Getter method for enabled_address_families, mapped from YANG variable /network_instances/network_instance/config/enabled_address_families (identityref)

    YANG Description: The address families that are to be enabled for this
network instance.
    """
        return self.__enabled_address_families

    def _set_enabled_address_families(self, v, load=False):
        """
    Setter method for enabled_address_families, mapped from YANG variable /network_instances/network_instance/config/enabled_address_families (identityref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_enabled_address_families is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_enabled_address_families() directly.

    YANG Description: The address families that are to be enabled for this
network instance.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=TypedListType(
                    allowed_type=RestrictedClassType(
                        base_type=six.text_type,
                        restriction_type="dict_key",
                        restriction_arg={
                            "IPV4": {
                                "@module": "openconfig-types",
                                "@namespace": "http://openconfig.net/yang/openconfig-types",
                            },
                            "oc-types:IPV4": {
                                "@module": "openconfig-types",
                                "@namespace": "http://openconfig.net/yang/openconfig-types",
                            },
                            "octypes:IPV4": {
                                "@module": "openconfig-types",
                                "@namespace": "http://openconfig.net/yang/openconfig-types",
                            },
                            "IPV6": {
                                "@module": "openconfig-types",
                                "@namespace": "http://openconfig.net/yang/openconfig-types",
                            },
                            "oc-types:IPV6": {
                                "@module": "openconfig-types",
                                "@namespace": "http://openconfig.net/yang/openconfig-types",
                            },
                            "octypes:IPV6": {
                                "@module": "openconfig-types",
                                "@namespace": "http://openconfig.net/yang/openconfig-types",
                            },
                            "MPLS": {
                                "@module": "openconfig-types",
                                "@namespace": "http://openconfig.net/yang/openconfig-types",
                            },
                            "oc-types:MPLS": {
                                "@module": "openconfig-types",
                                "@namespace": "http://openconfig.net/yang/openconfig-types",
                            },
                            "octypes:MPLS": {
                                "@module": "openconfig-types",
                                "@namespace": "http://openconfig.net/yang/openconfig-types",
                            },
                            "L2_ETHERNET": {
                                "@module": "openconfig-types",
                                "@namespace": "http://openconfig.net/yang/openconfig-types",
                            },
                            "oc-types:L2_ETHERNET": {
                                "@module": "openconfig-types",
                                "@namespace": "http://openconfig.net/yang/openconfig-types",
                            },
                            "octypes:L2_ETHERNET": {
                                "@module": "openconfig-types",
                                "@namespace": "http://openconfig.net/yang/openconfig-types",
                            },
                        },
                    )
                ),
                is_leaf=False,
                yang_name="enabled-address-families",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="identityref",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """enabled_address_families must be of a type compatible with identityref""",
                    "defined-type": "openconfig-network-instance:identityref",
                    "generated-type": """YANGDynClass(base=TypedListType(allowed_type=RestrictedClassType(base_type=six.text_type, restriction_type="dict_key", restriction_arg={'IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV4': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:IPV6': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:MPLS': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'oc-types:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}, 'octypes:L2_ETHERNET': {'@module': 'openconfig-types', '@namespace': 'http://openconfig.net/yang/openconfig-types'}},)), is_leaf=False, yang_name="enabled-address-families", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='identityref', is_config=True)""",
                }
            )

        self.__enabled_address_families = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_enabled_address_families(self):
        self.__enabled_address_families = YANGDynClass(
            base=TypedListType(
                allowed_type=RestrictedClassType(
                    base_type=six.text_type,
                    restriction_type="dict_key",
                    restriction_arg={
                        "IPV4": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "oc-types:IPV4": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "octypes:IPV4": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "IPV6": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "oc-types:IPV6": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "octypes:IPV6": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "MPLS": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "oc-types:MPLS": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "octypes:MPLS": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "L2_ETHERNET": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "oc-types:L2_ETHERNET": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                        "octypes:L2_ETHERNET": {
                            "@module": "openconfig-types",
                            "@namespace": "http://openconfig.net/yang/openconfig-types",
                        },
                    },
                )
            ),
            is_leaf=False,
            yang_name="enabled-address-families",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="identityref",
            is_config=True,
        )

    def _get_mtu(self):
        """
    Getter method for mtu, mapped from YANG variable /network_instances/network_instance/config/mtu (uint16)

    YANG Description: The maximum frame size which should be supported for this
instance for Layer 2 frames
    """
        return self.__mtu

    def _set_mtu(self, v, load=False):
        """
    Setter method for mtu, mapped from YANG variable /network_instances/network_instance/config/mtu (uint16)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_mtu is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_mtu() directly.

    YANG Description: The maximum frame size which should be supported for this
instance for Layer 2 frames
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=int, restriction_dict={"range": ["0..65535"]}, int_size=16
                ),
                is_leaf=True,
                yang_name="mtu",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="uint16",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """mtu must be of a type compatible with uint16""",
                    "defined-type": "uint16",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), is_leaf=True, yang_name="mtu", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint16', is_config=True)""",
                }
            )

        self.__mtu = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_mtu(self):
        self.__mtu = YANGDynClass(
            base=RestrictedClassType(
                base_type=int, restriction_dict={"range": ["0..65535"]}, int_size=16
            ),
            is_leaf=True,
            yang_name="mtu",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="uint16",
            is_config=True,
        )

    name = __builtin__.property(_get_name, _set_name)
    type = __builtin__.property(_get_type, _set_type)
    enabled = __builtin__.property(_get_enabled, _set_enabled)
    description = __builtin__.property(_get_description, _set_description)
    router_id = __builtin__.property(_get_router_id, _set_router_id)
    route_distinguisher = __builtin__.property(
        _get_route_distinguisher, _set_route_distinguisher
    )
    enabled_address_families = __builtin__.property(
        _get_enabled_address_families, _set_enabled_address_families
    )
    mtu = __builtin__.property(_get_mtu, _set_mtu)

    _pyangbind_elements = OrderedDict(
        [
            ("name", name),
            ("type", type),
            ("enabled", enabled),
            ("description", description),
            ("router_id", router_id),
            ("route_distinguisher", route_distinguisher),
            ("enabled_address_families", enabled_address_families),
            ("mtu", mtu),
        ]
    )
