# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal
from bitarray import bitarray
import six

# PY3 support of some PY2 keywords (needs improved)
if six.PY3:
    import builtins as __builtin__

    long = int
elif six.PY2:
    import __builtin__


class config(PybindBase):
    """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance - based on the path /network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ip/config. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration data
  """
    __slots__ = (
        "_path_helper",
        "_extmethods",
        "__ip_version",
        "__source_ip_address",
        "__source_ip_flow_label",
        "__destination_ip_address",
        "__destination_ip_flow_label",
        "__dscp",
        "__protocol",
        "__hop_limit",
    )

    _yang_name = "config"

    _pybind_generated_by = "container"

    def __init__(self, *args, **kwargs):

        self._path_helper = False

        self._extmethods = False
        self.__ip_version = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_type="dict_key",
                restriction_arg={
                    "unknown": {"value": 0}, "ipv4": {"value": 1}, "ipv6": {"value": 2}
                },
            ),
            is_leaf=True,
            yang_name="ip-version",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="inet:ip-version",
            is_config=True,
        )
        self.__source_ip_address = YANGDynClass(
            base=[
                RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))"
                    },
                ),
                RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-9]{2})|(1[0-1][0-9])|(12[0-8])))"
                    },
                ),
            ],
            is_leaf=True,
            yang_name="source-ip-address",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="inet:ip-prefix",
            is_config=True,
        )
        self.__source_ip_flow_label = YANGDynClass(
            base=RestrictedClassType(
                base_type=RestrictedClassType(
                    base_type=long,
                    restriction_dict={"range": ["0..4294967295"]},
                    int_size=32,
                ),
                restriction_dict={"range": ["0..1048575"]},
            ),
            is_leaf=True,
            yang_name="source-ip-flow-label",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="inet:ipv6-flow-label",
            is_config=True,
        )
        self.__destination_ip_address = YANGDynClass(
            base=[
                RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))"
                    },
                ),
                RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-9]{2})|(1[0-1][0-9])|(12[0-8])))"
                    },
                ),
            ],
            is_leaf=True,
            yang_name="destination-ip-address",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="inet:ip-prefix",
            is_config=True,
        )
        self.__destination_ip_flow_label = YANGDynClass(
            base=RestrictedClassType(
                base_type=RestrictedClassType(
                    base_type=long,
                    restriction_dict={"range": ["0..4294967295"]},
                    int_size=32,
                ),
                restriction_dict={"range": ["0..1048575"]},
            ),
            is_leaf=True,
            yang_name="destination-ip-flow-label",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="inet:ipv6-flow-label",
            is_config=True,
        )
        self.__dscp = YANGDynClass(
            base=RestrictedClassType(
                base_type=RestrictedClassType(
                    base_type=int, restriction_dict={"range": ["0..255"]}, int_size=8
                ),
                restriction_dict={"range": ["0..63"]},
            ),
            is_leaf=True,
            yang_name="dscp",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="inet:dscp",
            is_config=True,
        )
        self.__protocol = YANGDynClass(
            base=[
                RestrictedClassType(
                    base_type=RestrictedClassType(
                        base_type=int,
                        restriction_dict={"range": ["0..255"]},
                        int_size=8,
                    ),
                    restriction_dict={"range": ["0..254"]},
                ),
                RestrictedClassType(
                    base_type=six.text_type,
                    restriction_type="dict_key",
                    restriction_arg={
                        "IP_TCP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_TCP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "IP_UDP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_UDP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "IP_ICMP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_ICMP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "IP_IGMP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_IGMP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "IP_PIM": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_PIM": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "IP_RSVP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_RSVP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "IP_GRE": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_GRE": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "IP_AUTH": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_AUTH": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "IP_L2TP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_L2TP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                    },
                ),
            ],
            is_leaf=True,
            yang_name="protocol",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="oc-pkt-match-types:ip-protocol-type",
            is_config=True,
        )
        self.__hop_limit = YANGDynClass(
            base=RestrictedClassType(
                base_type=RestrictedClassType(
                    base_type=int, restriction_dict={"range": ["0..255"]}, int_size=8
                ),
                restriction_dict={"range": ["0..255"]},
            ),
            is_leaf=True,
            yang_name="hop-limit",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="uint8",
            is_config=True,
        )

        load = kwargs.pop("load", None)
        if args:
            if len(args) > 1:
                raise TypeError("cannot create a YANG container with >1 argument")
            all_attr = True
            for e in self._pyangbind_elements:
                if not hasattr(args[0], e):
                    all_attr = False
                    break
            if not all_attr:
                raise ValueError("Supplied object did not have the correct attributes")
            for e in self._pyangbind_elements:
                nobj = getattr(args[0], e)
                if nobj._changed() is False:
                    continue
                setmethod = getattr(self, "_set_%s" % e)
                if load is None:
                    setmethod(getattr(args[0], e))
                else:
                    setmethod(getattr(args[0], e), load=load)

    def _path(self):
        if hasattr(self, "_parent"):
            return self._parent._path() + [self._yang_name]
        else:
            return [
                "network-instances",
                "network-instance",
                "policy-forwarding",
                "policies",
                "policy",
                "rules",
                "rule",
                "ip",
                "config",
            ]

    def _get_ip_version(self):
        """
    Getter method for ip_version, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/ip/config/ip_version (inet:ip-version)

    YANG Description: IP version of the header.
    """
        return self.__ip_version

    def _set_ip_version(self, v, load=False):
        """
    Setter method for ip_version, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/ip/config/ip_version (inet:ip-version)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_ip_version is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_ip_version() directly.

    YANG Description: IP version of the header.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=six.text_type,
                    restriction_type="dict_key",
                    restriction_arg={
                        "unknown": {"value": 0},
                        "ipv4": {"value": 1},
                        "ipv6": {"value": 2},
                    },
                ),
                is_leaf=True,
                yang_name="ip-version",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="inet:ip-version",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """ip_version must be of a type compatible with inet:ip-version""",
                    "defined-type": "inet:ip-version",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=six.text_type,                                     restriction_type="dict_key",                                     restriction_arg={'unknown': {'value': 0}, 'ipv4': {'value': 1}, 'ipv6': {'value': 2}},), is_leaf=True, yang_name="ip-version", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='inet:ip-version', is_config=True)""",
                }
            )

        self.__ip_version = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_ip_version(self):
        self.__ip_version = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_type="dict_key",
                restriction_arg={
                    "unknown": {"value": 0}, "ipv4": {"value": 1}, "ipv6": {"value": 2}
                },
            ),
            is_leaf=True,
            yang_name="ip-version",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="inet:ip-version",
            is_config=True,
        )

    def _get_source_ip_address(self):
        """
    Getter method for source_ip_address, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/ip/config/source_ip_address (inet:ip-prefix)

    YANG Description: Destination IP address prefix.
    """
        return self.__source_ip_address

    def _set_source_ip_address(self, v, load=False):
        """
    Setter method for source_ip_address, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/ip/config/source_ip_address (inet:ip-prefix)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_source_ip_address is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_source_ip_address() directly.

    YANG Description: Destination IP address prefix.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=[
                    RestrictedClassType(
                        base_type=six.text_type,
                        restriction_dict={
                            "pattern": "(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))"
                        },
                    ),
                    RestrictedClassType(
                        base_type=six.text_type,
                        restriction_dict={
                            "pattern": "((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-9]{2})|(1[0-1][0-9])|(12[0-8])))"
                        },
                    ),
                ],
                is_leaf=True,
                yang_name="source-ip-address",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="inet:ip-prefix",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """source_ip_address must be of a type compatible with inet:ip-prefix""",
                    "defined-type": "inet:ip-prefix",
                    "generated-type": """YANGDynClass(base=[RestrictedClassType(base_type=six.text_type, restriction_dict={'pattern': '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'}),RestrictedClassType(base_type=six.text_type, restriction_dict={'pattern': '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-9]{2})|(1[0-1][0-9])|(12[0-8])))'}),], is_leaf=True, yang_name="source-ip-address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='inet:ip-prefix', is_config=True)""",
                }
            )

        self.__source_ip_address = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_source_ip_address(self):
        self.__source_ip_address = YANGDynClass(
            base=[
                RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))"
                    },
                ),
                RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-9]{2})|(1[0-1][0-9])|(12[0-8])))"
                    },
                ),
            ],
            is_leaf=True,
            yang_name="source-ip-address",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="inet:ip-prefix",
            is_config=True,
        )

    def _get_source_ip_flow_label(self):
        """
    Getter method for source_ip_flow_label, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/ip/config/source_ip_flow_label (inet:ipv6-flow-label)

    YANG Description: Source IPv6 Flow label.
    """
        return self.__source_ip_flow_label

    def _set_source_ip_flow_label(self, v, load=False):
        """
    Setter method for source_ip_flow_label, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/ip/config/source_ip_flow_label (inet:ipv6-flow-label)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_source_ip_flow_label is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_source_ip_flow_label() directly.

    YANG Description: Source IPv6 Flow label.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=RestrictedClassType(
                        base_type=long,
                        restriction_dict={"range": ["0..4294967295"]},
                        int_size=32,
                    ),
                    restriction_dict={"range": ["0..1048575"]},
                ),
                is_leaf=True,
                yang_name="source-ip-flow-label",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="inet:ipv6-flow-label",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """source_ip_flow_label must be of a type compatible with inet:ipv6-flow-label""",
                    "defined-type": "inet:ipv6-flow-label",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': ['0..1048575']}), is_leaf=True, yang_name="source-ip-flow-label", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='inet:ipv6-flow-label', is_config=True)""",
                }
            )

        self.__source_ip_flow_label = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_source_ip_flow_label(self):
        self.__source_ip_flow_label = YANGDynClass(
            base=RestrictedClassType(
                base_type=RestrictedClassType(
                    base_type=long,
                    restriction_dict={"range": ["0..4294967295"]},
                    int_size=32,
                ),
                restriction_dict={"range": ["0..1048575"]},
            ),
            is_leaf=True,
            yang_name="source-ip-flow-label",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="inet:ipv6-flow-label",
            is_config=True,
        )

    def _get_destination_ip_address(self):
        """
    Getter method for destination_ip_address, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/ip/config/destination_ip_address (inet:ip-prefix)

    YANG Description: Destination IP address prefix.
    """
        return self.__destination_ip_address

    def _set_destination_ip_address(self, v, load=False):
        """
    Setter method for destination_ip_address, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/ip/config/destination_ip_address (inet:ip-prefix)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_destination_ip_address is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_destination_ip_address() directly.

    YANG Description: Destination IP address prefix.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=[
                    RestrictedClassType(
                        base_type=six.text_type,
                        restriction_dict={
                            "pattern": "(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))"
                        },
                    ),
                    RestrictedClassType(
                        base_type=six.text_type,
                        restriction_dict={
                            "pattern": "((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-9]{2})|(1[0-1][0-9])|(12[0-8])))"
                        },
                    ),
                ],
                is_leaf=True,
                yang_name="destination-ip-address",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="inet:ip-prefix",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """destination_ip_address must be of a type compatible with inet:ip-prefix""",
                    "defined-type": "inet:ip-prefix",
                    "generated-type": """YANGDynClass(base=[RestrictedClassType(base_type=six.text_type, restriction_dict={'pattern': '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'}),RestrictedClassType(base_type=six.text_type, restriction_dict={'pattern': '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-9]{2})|(1[0-1][0-9])|(12[0-8])))'}),], is_leaf=True, yang_name="destination-ip-address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='inet:ip-prefix', is_config=True)""",
                }
            )

        self.__destination_ip_address = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_destination_ip_address(self):
        self.__destination_ip_address = YANGDynClass(
            base=[
                RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))"
                    },
                ),
                RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-9]{2})|(1[0-1][0-9])|(12[0-8])))"
                    },
                ),
            ],
            is_leaf=True,
            yang_name="destination-ip-address",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="inet:ip-prefix",
            is_config=True,
        )

    def _get_destination_ip_flow_label(self):
        """
    Getter method for destination_ip_flow_label, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/ip/config/destination_ip_flow_label (inet:ipv6-flow-label)

    YANG Description: Destination IPv6 Flow label.
    """
        return self.__destination_ip_flow_label

    def _set_destination_ip_flow_label(self, v, load=False):
        """
    Setter method for destination_ip_flow_label, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/ip/config/destination_ip_flow_label (inet:ipv6-flow-label)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_destination_ip_flow_label is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_destination_ip_flow_label() directly.

    YANG Description: Destination IPv6 Flow label.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=RestrictedClassType(
                        base_type=long,
                        restriction_dict={"range": ["0..4294967295"]},
                        int_size=32,
                    ),
                    restriction_dict={"range": ["0..1048575"]},
                ),
                is_leaf=True,
                yang_name="destination-ip-flow-label",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="inet:ipv6-flow-label",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """destination_ip_flow_label must be of a type compatible with inet:ipv6-flow-label""",
                    "defined-type": "inet:ipv6-flow-label",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': ['0..1048575']}), is_leaf=True, yang_name="destination-ip-flow-label", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='inet:ipv6-flow-label', is_config=True)""",
                }
            )

        self.__destination_ip_flow_label = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_destination_ip_flow_label(self):
        self.__destination_ip_flow_label = YANGDynClass(
            base=RestrictedClassType(
                base_type=RestrictedClassType(
                    base_type=long,
                    restriction_dict={"range": ["0..4294967295"]},
                    int_size=32,
                ),
                restriction_dict={"range": ["0..1048575"]},
            ),
            is_leaf=True,
            yang_name="destination-ip-flow-label",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="inet:ipv6-flow-label",
            is_config=True,
        )

    def _get_dscp(self):
        """
    Getter method for dscp, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/ip/config/dscp (inet:dscp)

    YANG Description: Value of diffserv codepoint.
    """
        return self.__dscp

    def _set_dscp(self, v, load=False):
        """
    Setter method for dscp, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/ip/config/dscp (inet:dscp)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_dscp is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_dscp() directly.

    YANG Description: Value of diffserv codepoint.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=RestrictedClassType(
                        base_type=int,
                        restriction_dict={"range": ["0..255"]},
                        int_size=8,
                    ),
                    restriction_dict={"range": ["0..63"]},
                ),
                is_leaf=True,
                yang_name="dscp",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="inet:dscp",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """dscp must be of a type compatible with inet:dscp""",
                    "defined-type": "inet:dscp",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..255']}, int_size=8), restriction_dict={'range': ['0..63']}), is_leaf=True, yang_name="dscp", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='inet:dscp', is_config=True)""",
                }
            )

        self.__dscp = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_dscp(self):
        self.__dscp = YANGDynClass(
            base=RestrictedClassType(
                base_type=RestrictedClassType(
                    base_type=int, restriction_dict={"range": ["0..255"]}, int_size=8
                ),
                restriction_dict={"range": ["0..63"]},
            ),
            is_leaf=True,
            yang_name="dscp",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="inet:dscp",
            is_config=True,
        )

    def _get_protocol(self):
        """
    Getter method for protocol, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/ip/config/protocol (oc-pkt-match-types:ip-protocol-type)

    YANG Description: Internet Protocol number.
    """
        return self.__protocol

    def _set_protocol(self, v, load=False):
        """
    Setter method for protocol, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/ip/config/protocol (oc-pkt-match-types:ip-protocol-type)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_protocol is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_protocol() directly.

    YANG Description: Internet Protocol number.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=[
                    RestrictedClassType(
                        base_type=RestrictedClassType(
                            base_type=int,
                            restriction_dict={"range": ["0..255"]},
                            int_size=8,
                        ),
                        restriction_dict={"range": ["0..254"]},
                    ),
                    RestrictedClassType(
                        base_type=six.text_type,
                        restriction_type="dict_key",
                        restriction_arg={
                            "IP_TCP": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "oc-pkt-match-types:IP_TCP": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "IP_UDP": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "oc-pkt-match-types:IP_UDP": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "IP_ICMP": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "oc-pkt-match-types:IP_ICMP": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "IP_IGMP": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "oc-pkt-match-types:IP_IGMP": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "IP_PIM": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "oc-pkt-match-types:IP_PIM": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "IP_RSVP": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "oc-pkt-match-types:IP_RSVP": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "IP_GRE": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "oc-pkt-match-types:IP_GRE": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "IP_AUTH": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "oc-pkt-match-types:IP_AUTH": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "IP_L2TP": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "oc-pkt-match-types:IP_L2TP": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                        },
                    ),
                ],
                is_leaf=True,
                yang_name="protocol",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="oc-pkt-match-types:ip-protocol-type",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """protocol must be of a type compatible with oc-pkt-match-types:ip-protocol-type""",
                    "defined-type": "oc-pkt-match-types:ip-protocol-type",
                    "generated-type": """YANGDynClass(base=[RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..255']}, int_size=8), restriction_dict={'range': ['0..254']}),RestrictedClassType(base_type=six.text_type, restriction_type="dict_key", restriction_arg={'IP_TCP': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'oc-pkt-match-types:IP_TCP': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'IP_UDP': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'oc-pkt-match-types:IP_UDP': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'IP_ICMP': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'oc-pkt-match-types:IP_ICMP': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'IP_IGMP': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'oc-pkt-match-types:IP_IGMP': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'IP_PIM': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'oc-pkt-match-types:IP_PIM': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'IP_RSVP': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'oc-pkt-match-types:IP_RSVP': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'IP_GRE': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'oc-pkt-match-types:IP_GRE': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'IP_AUTH': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'oc-pkt-match-types:IP_AUTH': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'IP_L2TP': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'oc-pkt-match-types:IP_L2TP': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}},),], is_leaf=True, yang_name="protocol", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-pkt-match-types:ip-protocol-type', is_config=True)""",
                }
            )

        self.__protocol = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_protocol(self):
        self.__protocol = YANGDynClass(
            base=[
                RestrictedClassType(
                    base_type=RestrictedClassType(
                        base_type=int,
                        restriction_dict={"range": ["0..255"]},
                        int_size=8,
                    ),
                    restriction_dict={"range": ["0..254"]},
                ),
                RestrictedClassType(
                    base_type=six.text_type,
                    restriction_type="dict_key",
                    restriction_arg={
                        "IP_TCP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_TCP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "IP_UDP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_UDP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "IP_ICMP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_ICMP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "IP_IGMP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_IGMP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "IP_PIM": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_PIM": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "IP_RSVP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_RSVP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "IP_GRE": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_GRE": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "IP_AUTH": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_AUTH": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "IP_L2TP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_L2TP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                    },
                ),
            ],
            is_leaf=True,
            yang_name="protocol",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="oc-pkt-match-types:ip-protocol-type",
            is_config=True,
        )

    def _get_hop_limit(self):
        """
    Getter method for hop_limit, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/ip/config/hop_limit (uint8)

    YANG Description: The IP packet's hop limit -- known as TTL (in hops) in
IPv4 packets, and hop limit in IPv6
    """
        return self.__hop_limit

    def _set_hop_limit(self, v, load=False):
        """
    Setter method for hop_limit, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/ip/config/hop_limit (uint8)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_hop_limit is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_hop_limit() directly.

    YANG Description: The IP packet's hop limit -- known as TTL (in hops) in
IPv4 packets, and hop limit in IPv6
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=RestrictedClassType(
                        base_type=int,
                        restriction_dict={"range": ["0..255"]},
                        int_size=8,
                    ),
                    restriction_dict={"range": ["0..255"]},
                ),
                is_leaf=True,
                yang_name="hop-limit",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="uint8",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """hop_limit must be of a type compatible with uint8""",
                    "defined-type": "uint8",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..255']}, int_size=8), restriction_dict={'range': ['0..255']}), is_leaf=True, yang_name="hop-limit", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint8', is_config=True)""",
                }
            )

        self.__hop_limit = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_hop_limit(self):
        self.__hop_limit = YANGDynClass(
            base=RestrictedClassType(
                base_type=RestrictedClassType(
                    base_type=int, restriction_dict={"range": ["0..255"]}, int_size=8
                ),
                restriction_dict={"range": ["0..255"]},
            ),
            is_leaf=True,
            yang_name="hop-limit",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="uint8",
            is_config=True,
        )

    ip_version = __builtin__.property(_get_ip_version, _set_ip_version)
    source_ip_address = __builtin__.property(
        _get_source_ip_address, _set_source_ip_address
    )
    source_ip_flow_label = __builtin__.property(
        _get_source_ip_flow_label, _set_source_ip_flow_label
    )
    destination_ip_address = __builtin__.property(
        _get_destination_ip_address, _set_destination_ip_address
    )
    destination_ip_flow_label = __builtin__.property(
        _get_destination_ip_flow_label, _set_destination_ip_flow_label
    )
    dscp = __builtin__.property(_get_dscp, _set_dscp)
    protocol = __builtin__.property(_get_protocol, _set_protocol)
    hop_limit = __builtin__.property(_get_hop_limit, _set_hop_limit)

    _pyangbind_elements = OrderedDict(
        [
            ("ip_version", ip_version),
            ("source_ip_address", source_ip_address),
            ("source_ip_flow_label", source_ip_flow_label),
            ("destination_ip_address", destination_ip_address),
            ("destination_ip_flow_label", destination_ip_flow_label),
            ("dscp", dscp),
            ("protocol", protocol),
            ("hop_limit", hop_limit),
        ]
    )


class config(PybindBase):
    """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance-l2 - based on the path /network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ip/config. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration data
  """
    __slots__ = (
        "_path_helper",
        "_extmethods",
        "__ip_version",
        "__source_ip_address",
        "__source_ip_flow_label",
        "__destination_ip_address",
        "__destination_ip_flow_label",
        "__dscp",
        "__protocol",
        "__hop_limit",
    )

    _yang_name = "config"

    _pybind_generated_by = "container"

    def __init__(self, *args, **kwargs):

        self._path_helper = False

        self._extmethods = False
        self.__ip_version = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_type="dict_key",
                restriction_arg={
                    "unknown": {"value": 0}, "ipv4": {"value": 1}, "ipv6": {"value": 2}
                },
            ),
            is_leaf=True,
            yang_name="ip-version",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="inet:ip-version",
            is_config=True,
        )
        self.__source_ip_address = YANGDynClass(
            base=[
                RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))"
                    },
                ),
                RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-9]{2})|(1[0-1][0-9])|(12[0-8])))"
                    },
                ),
            ],
            is_leaf=True,
            yang_name="source-ip-address",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="inet:ip-prefix",
            is_config=True,
        )
        self.__source_ip_flow_label = YANGDynClass(
            base=RestrictedClassType(
                base_type=RestrictedClassType(
                    base_type=long,
                    restriction_dict={"range": ["0..4294967295"]},
                    int_size=32,
                ),
                restriction_dict={"range": ["0..1048575"]},
            ),
            is_leaf=True,
            yang_name="source-ip-flow-label",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="inet:ipv6-flow-label",
            is_config=True,
        )
        self.__destination_ip_address = YANGDynClass(
            base=[
                RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))"
                    },
                ),
                RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-9]{2})|(1[0-1][0-9])|(12[0-8])))"
                    },
                ),
            ],
            is_leaf=True,
            yang_name="destination-ip-address",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="inet:ip-prefix",
            is_config=True,
        )
        self.__destination_ip_flow_label = YANGDynClass(
            base=RestrictedClassType(
                base_type=RestrictedClassType(
                    base_type=long,
                    restriction_dict={"range": ["0..4294967295"]},
                    int_size=32,
                ),
                restriction_dict={"range": ["0..1048575"]},
            ),
            is_leaf=True,
            yang_name="destination-ip-flow-label",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="inet:ipv6-flow-label",
            is_config=True,
        )
        self.__dscp = YANGDynClass(
            base=RestrictedClassType(
                base_type=RestrictedClassType(
                    base_type=int, restriction_dict={"range": ["0..255"]}, int_size=8
                ),
                restriction_dict={"range": ["0..63"]},
            ),
            is_leaf=True,
            yang_name="dscp",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="inet:dscp",
            is_config=True,
        )
        self.__protocol = YANGDynClass(
            base=[
                RestrictedClassType(
                    base_type=RestrictedClassType(
                        base_type=int,
                        restriction_dict={"range": ["0..255"]},
                        int_size=8,
                    ),
                    restriction_dict={"range": ["0..254"]},
                ),
                RestrictedClassType(
                    base_type=six.text_type,
                    restriction_type="dict_key",
                    restriction_arg={
                        "IP_TCP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_TCP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "IP_UDP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_UDP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "IP_ICMP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_ICMP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "IP_IGMP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_IGMP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "IP_PIM": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_PIM": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "IP_RSVP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_RSVP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "IP_GRE": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_GRE": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "IP_AUTH": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_AUTH": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "IP_L2TP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_L2TP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                    },
                ),
            ],
            is_leaf=True,
            yang_name="protocol",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="oc-pkt-match-types:ip-protocol-type",
            is_config=True,
        )
        self.__hop_limit = YANGDynClass(
            base=RestrictedClassType(
                base_type=RestrictedClassType(
                    base_type=int, restriction_dict={"range": ["0..255"]}, int_size=8
                ),
                restriction_dict={"range": ["0..255"]},
            ),
            is_leaf=True,
            yang_name="hop-limit",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="uint8",
            is_config=True,
        )

        load = kwargs.pop("load", None)
        if args:
            if len(args) > 1:
                raise TypeError("cannot create a YANG container with >1 argument")
            all_attr = True
            for e in self._pyangbind_elements:
                if not hasattr(args[0], e):
                    all_attr = False
                    break
            if not all_attr:
                raise ValueError("Supplied object did not have the correct attributes")
            for e in self._pyangbind_elements:
                nobj = getattr(args[0], e)
                if nobj._changed() is False:
                    continue
                setmethod = getattr(self, "_set_%s" % e)
                if load is None:
                    setmethod(getattr(args[0], e))
                else:
                    setmethod(getattr(args[0], e), load=load)

    def _path(self):
        if hasattr(self, "_parent"):
            return self._parent._path() + [self._yang_name]
        else:
            return [
                "network-instances",
                "network-instance",
                "policy-forwarding",
                "policies",
                "policy",
                "rules",
                "rule",
                "ip",
                "config",
            ]

    def _get_ip_version(self):
        """
    Getter method for ip_version, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/ip/config/ip_version (inet:ip-version)

    YANG Description: IP version of the header.
    """
        return self.__ip_version

    def _set_ip_version(self, v, load=False):
        """
    Setter method for ip_version, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/ip/config/ip_version (inet:ip-version)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_ip_version is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_ip_version() directly.

    YANG Description: IP version of the header.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=six.text_type,
                    restriction_type="dict_key",
                    restriction_arg={
                        "unknown": {"value": 0},
                        "ipv4": {"value": 1},
                        "ipv6": {"value": 2},
                    },
                ),
                is_leaf=True,
                yang_name="ip-version",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="inet:ip-version",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """ip_version must be of a type compatible with inet:ip-version""",
                    "defined-type": "inet:ip-version",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=six.text_type,                                     restriction_type="dict_key",                                     restriction_arg={'unknown': {'value': 0}, 'ipv4': {'value': 1}, 'ipv6': {'value': 2}},), is_leaf=True, yang_name="ip-version", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='inet:ip-version', is_config=True)""",
                }
            )

        self.__ip_version = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_ip_version(self):
        self.__ip_version = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_type="dict_key",
                restriction_arg={
                    "unknown": {"value": 0}, "ipv4": {"value": 1}, "ipv6": {"value": 2}
                },
            ),
            is_leaf=True,
            yang_name="ip-version",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="inet:ip-version",
            is_config=True,
        )

    def _get_source_ip_address(self):
        """
    Getter method for source_ip_address, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/ip/config/source_ip_address (inet:ip-prefix)

    YANG Description: Destination IP address prefix.
    """
        return self.__source_ip_address

    def _set_source_ip_address(self, v, load=False):
        """
    Setter method for source_ip_address, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/ip/config/source_ip_address (inet:ip-prefix)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_source_ip_address is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_source_ip_address() directly.

    YANG Description: Destination IP address prefix.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=[
                    RestrictedClassType(
                        base_type=six.text_type,
                        restriction_dict={
                            "pattern": "(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))"
                        },
                    ),
                    RestrictedClassType(
                        base_type=six.text_type,
                        restriction_dict={
                            "pattern": "((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-9]{2})|(1[0-1][0-9])|(12[0-8])))"
                        },
                    ),
                ],
                is_leaf=True,
                yang_name="source-ip-address",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="inet:ip-prefix",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """source_ip_address must be of a type compatible with inet:ip-prefix""",
                    "defined-type": "inet:ip-prefix",
                    "generated-type": """YANGDynClass(base=[RestrictedClassType(base_type=six.text_type, restriction_dict={'pattern': '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'}),RestrictedClassType(base_type=six.text_type, restriction_dict={'pattern': '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-9]{2})|(1[0-1][0-9])|(12[0-8])))'}),], is_leaf=True, yang_name="source-ip-address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='inet:ip-prefix', is_config=True)""",
                }
            )

        self.__source_ip_address = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_source_ip_address(self):
        self.__source_ip_address = YANGDynClass(
            base=[
                RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))"
                    },
                ),
                RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-9]{2})|(1[0-1][0-9])|(12[0-8])))"
                    },
                ),
            ],
            is_leaf=True,
            yang_name="source-ip-address",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="inet:ip-prefix",
            is_config=True,
        )

    def _get_source_ip_flow_label(self):
        """
    Getter method for source_ip_flow_label, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/ip/config/source_ip_flow_label (inet:ipv6-flow-label)

    YANG Description: Source IPv6 Flow label.
    """
        return self.__source_ip_flow_label

    def _set_source_ip_flow_label(self, v, load=False):
        """
    Setter method for source_ip_flow_label, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/ip/config/source_ip_flow_label (inet:ipv6-flow-label)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_source_ip_flow_label is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_source_ip_flow_label() directly.

    YANG Description: Source IPv6 Flow label.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=RestrictedClassType(
                        base_type=long,
                        restriction_dict={"range": ["0..4294967295"]},
                        int_size=32,
                    ),
                    restriction_dict={"range": ["0..1048575"]},
                ),
                is_leaf=True,
                yang_name="source-ip-flow-label",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="inet:ipv6-flow-label",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """source_ip_flow_label must be of a type compatible with inet:ipv6-flow-label""",
                    "defined-type": "inet:ipv6-flow-label",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': ['0..1048575']}), is_leaf=True, yang_name="source-ip-flow-label", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='inet:ipv6-flow-label', is_config=True)""",
                }
            )

        self.__source_ip_flow_label = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_source_ip_flow_label(self):
        self.__source_ip_flow_label = YANGDynClass(
            base=RestrictedClassType(
                base_type=RestrictedClassType(
                    base_type=long,
                    restriction_dict={"range": ["0..4294967295"]},
                    int_size=32,
                ),
                restriction_dict={"range": ["0..1048575"]},
            ),
            is_leaf=True,
            yang_name="source-ip-flow-label",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="inet:ipv6-flow-label",
            is_config=True,
        )

    def _get_destination_ip_address(self):
        """
    Getter method for destination_ip_address, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/ip/config/destination_ip_address (inet:ip-prefix)

    YANG Description: Destination IP address prefix.
    """
        return self.__destination_ip_address

    def _set_destination_ip_address(self, v, load=False):
        """
    Setter method for destination_ip_address, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/ip/config/destination_ip_address (inet:ip-prefix)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_destination_ip_address is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_destination_ip_address() directly.

    YANG Description: Destination IP address prefix.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=[
                    RestrictedClassType(
                        base_type=six.text_type,
                        restriction_dict={
                            "pattern": "(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))"
                        },
                    ),
                    RestrictedClassType(
                        base_type=six.text_type,
                        restriction_dict={
                            "pattern": "((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-9]{2})|(1[0-1][0-9])|(12[0-8])))"
                        },
                    ),
                ],
                is_leaf=True,
                yang_name="destination-ip-address",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="inet:ip-prefix",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """destination_ip_address must be of a type compatible with inet:ip-prefix""",
                    "defined-type": "inet:ip-prefix",
                    "generated-type": """YANGDynClass(base=[RestrictedClassType(base_type=six.text_type, restriction_dict={'pattern': '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'}),RestrictedClassType(base_type=six.text_type, restriction_dict={'pattern': '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-9]{2})|(1[0-1][0-9])|(12[0-8])))'}),], is_leaf=True, yang_name="destination-ip-address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='inet:ip-prefix', is_config=True)""",
                }
            )

        self.__destination_ip_address = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_destination_ip_address(self):
        self.__destination_ip_address = YANGDynClass(
            base=[
                RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))"
                    },
                ),
                RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-9]{2})|(1[0-1][0-9])|(12[0-8])))"
                    },
                ),
            ],
            is_leaf=True,
            yang_name="destination-ip-address",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="inet:ip-prefix",
            is_config=True,
        )

    def _get_destination_ip_flow_label(self):
        """
    Getter method for destination_ip_flow_label, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/ip/config/destination_ip_flow_label (inet:ipv6-flow-label)

    YANG Description: Destination IPv6 Flow label.
    """
        return self.__destination_ip_flow_label

    def _set_destination_ip_flow_label(self, v, load=False):
        """
    Setter method for destination_ip_flow_label, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/ip/config/destination_ip_flow_label (inet:ipv6-flow-label)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_destination_ip_flow_label is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_destination_ip_flow_label() directly.

    YANG Description: Destination IPv6 Flow label.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=RestrictedClassType(
                        base_type=long,
                        restriction_dict={"range": ["0..4294967295"]},
                        int_size=32,
                    ),
                    restriction_dict={"range": ["0..1048575"]},
                ),
                is_leaf=True,
                yang_name="destination-ip-flow-label",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="inet:ipv6-flow-label",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """destination_ip_flow_label must be of a type compatible with inet:ipv6-flow-label""",
                    "defined-type": "inet:ipv6-flow-label",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': ['0..1048575']}), is_leaf=True, yang_name="destination-ip-flow-label", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='inet:ipv6-flow-label', is_config=True)""",
                }
            )

        self.__destination_ip_flow_label = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_destination_ip_flow_label(self):
        self.__destination_ip_flow_label = YANGDynClass(
            base=RestrictedClassType(
                base_type=RestrictedClassType(
                    base_type=long,
                    restriction_dict={"range": ["0..4294967295"]},
                    int_size=32,
                ),
                restriction_dict={"range": ["0..1048575"]},
            ),
            is_leaf=True,
            yang_name="destination-ip-flow-label",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="inet:ipv6-flow-label",
            is_config=True,
        )

    def _get_dscp(self):
        """
    Getter method for dscp, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/ip/config/dscp (inet:dscp)

    YANG Description: Value of diffserv codepoint.
    """
        return self.__dscp

    def _set_dscp(self, v, load=False):
        """
    Setter method for dscp, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/ip/config/dscp (inet:dscp)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_dscp is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_dscp() directly.

    YANG Description: Value of diffserv codepoint.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=RestrictedClassType(
                        base_type=int,
                        restriction_dict={"range": ["0..255"]},
                        int_size=8,
                    ),
                    restriction_dict={"range": ["0..63"]},
                ),
                is_leaf=True,
                yang_name="dscp",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="inet:dscp",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """dscp must be of a type compatible with inet:dscp""",
                    "defined-type": "inet:dscp",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..255']}, int_size=8), restriction_dict={'range': ['0..63']}), is_leaf=True, yang_name="dscp", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='inet:dscp', is_config=True)""",
                }
            )

        self.__dscp = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_dscp(self):
        self.__dscp = YANGDynClass(
            base=RestrictedClassType(
                base_type=RestrictedClassType(
                    base_type=int, restriction_dict={"range": ["0..255"]}, int_size=8
                ),
                restriction_dict={"range": ["0..63"]},
            ),
            is_leaf=True,
            yang_name="dscp",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="inet:dscp",
            is_config=True,
        )

    def _get_protocol(self):
        """
    Getter method for protocol, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/ip/config/protocol (oc-pkt-match-types:ip-protocol-type)

    YANG Description: Internet Protocol number.
    """
        return self.__protocol

    def _set_protocol(self, v, load=False):
        """
    Setter method for protocol, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/ip/config/protocol (oc-pkt-match-types:ip-protocol-type)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_protocol is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_protocol() directly.

    YANG Description: Internet Protocol number.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=[
                    RestrictedClassType(
                        base_type=RestrictedClassType(
                            base_type=int,
                            restriction_dict={"range": ["0..255"]},
                            int_size=8,
                        ),
                        restriction_dict={"range": ["0..254"]},
                    ),
                    RestrictedClassType(
                        base_type=six.text_type,
                        restriction_type="dict_key",
                        restriction_arg={
                            "IP_TCP": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "oc-pkt-match-types:IP_TCP": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "IP_UDP": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "oc-pkt-match-types:IP_UDP": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "IP_ICMP": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "oc-pkt-match-types:IP_ICMP": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "IP_IGMP": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "oc-pkt-match-types:IP_IGMP": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "IP_PIM": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "oc-pkt-match-types:IP_PIM": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "IP_RSVP": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "oc-pkt-match-types:IP_RSVP": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "IP_GRE": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "oc-pkt-match-types:IP_GRE": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "IP_AUTH": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "oc-pkt-match-types:IP_AUTH": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "IP_L2TP": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                            "oc-pkt-match-types:IP_L2TP": {
                                "@module": "openconfig-packet-match-types",
                                "@namespace": "http://openconfig.net/yang/packet-match-types",
                            },
                        },
                    ),
                ],
                is_leaf=True,
                yang_name="protocol",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="oc-pkt-match-types:ip-protocol-type",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """protocol must be of a type compatible with oc-pkt-match-types:ip-protocol-type""",
                    "defined-type": "oc-pkt-match-types:ip-protocol-type",
                    "generated-type": """YANGDynClass(base=[RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..255']}, int_size=8), restriction_dict={'range': ['0..254']}),RestrictedClassType(base_type=six.text_type, restriction_type="dict_key", restriction_arg={'IP_TCP': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'oc-pkt-match-types:IP_TCP': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'IP_UDP': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'oc-pkt-match-types:IP_UDP': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'IP_ICMP': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'oc-pkt-match-types:IP_ICMP': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'IP_IGMP': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'oc-pkt-match-types:IP_IGMP': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'IP_PIM': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'oc-pkt-match-types:IP_PIM': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'IP_RSVP': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'oc-pkt-match-types:IP_RSVP': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'IP_GRE': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'oc-pkt-match-types:IP_GRE': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'IP_AUTH': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'oc-pkt-match-types:IP_AUTH': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'IP_L2TP': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}, 'oc-pkt-match-types:IP_L2TP': {'@module': 'openconfig-packet-match-types', '@namespace': 'http://openconfig.net/yang/packet-match-types'}},),], is_leaf=True, yang_name="protocol", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-pkt-match-types:ip-protocol-type', is_config=True)""",
                }
            )

        self.__protocol = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_protocol(self):
        self.__protocol = YANGDynClass(
            base=[
                RestrictedClassType(
                    base_type=RestrictedClassType(
                        base_type=int,
                        restriction_dict={"range": ["0..255"]},
                        int_size=8,
                    ),
                    restriction_dict={"range": ["0..254"]},
                ),
                RestrictedClassType(
                    base_type=six.text_type,
                    restriction_type="dict_key",
                    restriction_arg={
                        "IP_TCP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_TCP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "IP_UDP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_UDP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "IP_ICMP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_ICMP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "IP_IGMP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_IGMP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "IP_PIM": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_PIM": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "IP_RSVP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_RSVP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "IP_GRE": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_GRE": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "IP_AUTH": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_AUTH": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "IP_L2TP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                        "oc-pkt-match-types:IP_L2TP": {
                            "@module": "openconfig-packet-match-types",
                            "@namespace": "http://openconfig.net/yang/packet-match-types",
                        },
                    },
                ),
            ],
            is_leaf=True,
            yang_name="protocol",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="oc-pkt-match-types:ip-protocol-type",
            is_config=True,
        )

    def _get_hop_limit(self):
        """
    Getter method for hop_limit, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/ip/config/hop_limit (uint8)

    YANG Description: The IP packet's hop limit -- known as TTL (in hops) in
IPv4 packets, and hop limit in IPv6
    """
        return self.__hop_limit

    def _set_hop_limit(self, v, load=False):
        """
    Setter method for hop_limit, mapped from YANG variable /network_instances/network_instance/policy_forwarding/policies/policy/rules/rule/ip/config/hop_limit (uint8)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_hop_limit is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_hop_limit() directly.

    YANG Description: The IP packet's hop limit -- known as TTL (in hops) in
IPv4 packets, and hop limit in IPv6
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=RestrictedClassType(
                        base_type=int,
                        restriction_dict={"range": ["0..255"]},
                        int_size=8,
                    ),
                    restriction_dict={"range": ["0..255"]},
                ),
                is_leaf=True,
                yang_name="hop-limit",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="uint8",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """hop_limit must be of a type compatible with uint8""",
                    "defined-type": "uint8",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..255']}, int_size=8), restriction_dict={'range': ['0..255']}), is_leaf=True, yang_name="hop-limit", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint8', is_config=True)""",
                }
            )

        self.__hop_limit = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_hop_limit(self):
        self.__hop_limit = YANGDynClass(
            base=RestrictedClassType(
                base_type=RestrictedClassType(
                    base_type=int, restriction_dict={"range": ["0..255"]}, int_size=8
                ),
                restriction_dict={"range": ["0..255"]},
            ),
            is_leaf=True,
            yang_name="hop-limit",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="uint8",
            is_config=True,
        )

    ip_version = __builtin__.property(_get_ip_version, _set_ip_version)
    source_ip_address = __builtin__.property(
        _get_source_ip_address, _set_source_ip_address
    )
    source_ip_flow_label = __builtin__.property(
        _get_source_ip_flow_label, _set_source_ip_flow_label
    )
    destination_ip_address = __builtin__.property(
        _get_destination_ip_address, _set_destination_ip_address
    )
    destination_ip_flow_label = __builtin__.property(
        _get_destination_ip_flow_label, _set_destination_ip_flow_label
    )
    dscp = __builtin__.property(_get_dscp, _set_dscp)
    protocol = __builtin__.property(_get_protocol, _set_protocol)
    hop_limit = __builtin__.property(_get_hop_limit, _set_hop_limit)

    _pyangbind_elements = OrderedDict(
        [
            ("ip_version", ip_version),
            ("source_ip_address", source_ip_address),
            ("source_ip_flow_label", source_ip_flow_label),
            ("destination_ip_address", destination_ip_address),
            ("destination_ip_flow_label", destination_ip_flow_label),
            ("dscp", dscp),
            ("protocol", protocol),
            ("hop_limit", hop_limit),
        ]
    )
