# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal
from bitarray import bitarray
import six

# PY3 support of some PY2 keywords (needs improved)
if six.PY3:
    import builtins as __builtin__

    long = int
elif six.PY2:
    import __builtin__


class state(PybindBase):
    """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance - based on the path /network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlg/state. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: State parameters of TLV 139.
  """
    __slots__ = (
        "_path_helper",
        "_extmethods",
        "__type",
        "__system_id",
        "__psn_number",
        "__flags",
        "__ipv6_interface_address",
        "__ipv6_neighbor_address",
        "__srlg_value",
    )

    _yang_name = "state"

    _pybind_generated_by = "container"

    def __init__(self, *args, **kwargs):

        self._path_helper = False

        self._extmethods = False
        self.__type = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_type="dict_key",
                restriction_arg={
                    "AREA_ADDRESSES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:AREA_ADDRESSES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IIS_NEIGHBORS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IIS_NEIGHBORS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "INSTANCE_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:INSTANCE_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "AUTHENTICATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:AUTHENTICATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "PURGE_OI": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:PURGE_OI": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "EXTENDED_IS_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:EXTENDED_IS_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IS_NEIGHBOR_ATTRIBUTE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IS_NEIGHBOR_ATTRIBUTE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_ALIAS_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_ALIAS_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV4_INTERNAL_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV4_INTERNAL_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "NLPID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:NLPID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV4_EXTERNAL_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV4_EXTERNAL_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV4_INTERFACE_ADDRESSES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV4_INTERFACE_ADDRESSES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV4_TE_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV4_TE_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "EXTENDED_IPV4_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:EXTENDED_IPV4_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "DYNAMIC_NAME": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:DYNAMIC_NAME": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV4_SRLG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV4_SRLG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV6_SRLG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV6_SRLG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV6_TE_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV6_TE_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "MT_ISN": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:MT_ISN": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "MT_IS_NEIGHBOR_ATTRIBUTE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:MT_IS_NEIGHBOR_ATTRIBUTE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "MULTI_TOPOLOGY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:MULTI_TOPOLOGY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV6_INTERFACE_ADDRESSES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV6_INTERFACE_ADDRESSES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "MT_IPV4_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:MT_IPV4_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV6_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV6_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "MT_IPV6_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:MT_IPV6_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ROUTER_CAPABILITIES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ROUTER_CAPABILITIES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                },
            ),
            is_leaf=True,
            yang_name="type",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="identityref",
            is_config=False,
        )
        self.__system_id = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_dict={
                    "pattern": "[0-9A-Fa-f]{4}\\.[0-9A-Fa-f]{4}\\.[0-9A-Fa-f]{4}"
                },
            ),
            is_leaf=True,
            yang_name="system-id",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="oc-isis-types:system-id",
            is_config=False,
        )
        self.__psn_number = YANGDynClass(
            base=RestrictedClassType(
                base_type=int, restriction_dict={"range": ["0..255"]}, int_size=8
            ),
            is_leaf=True,
            yang_name="psn-number",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="uint8",
            is_config=False,
        )
        self.__flags = YANGDynClass(
            base=TypedListType(
                allowed_type=RestrictedClassType(
                    base_type=six.text_type,
                    restriction_type="dict_key",
                    restriction_arg={"NA": {}},
                )
            ),
            is_leaf=False,
            yang_name="flags",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="enumeration",
            is_config=False,
        )
        self.__ipv6_interface_address = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_dict={
                    "pattern": "((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\\p{N}\\p{L}]+)?"
                },
            ),
            is_leaf=True,
            yang_name="ipv6-interface-address",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="inet:ipv6-address",
            is_config=False,
        )
        self.__ipv6_neighbor_address = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_dict={
                    "pattern": "((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\\p{N}\\p{L}]+)?"
                },
            ),
            is_leaf=True,
            yang_name="ipv6-neighbor-address",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="inet:ipv6-address",
            is_config=False,
        )
        self.__srlg_value = YANGDynClass(
            base=TypedListType(
                allowed_type=RestrictedClassType(
                    base_type=long,
                    restriction_dict={"range": ["0..4294967295"]},
                    int_size=32,
                )
            ),
            is_leaf=False,
            yang_name="srlg-value",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="uint32",
            is_config=False,
        )

        load = kwargs.pop("load", None)
        if args:
            if len(args) > 1:
                raise TypeError("cannot create a YANG container with >1 argument")
            all_attr = True
            for e in self._pyangbind_elements:
                if not hasattr(args[0], e):
                    all_attr = False
                    break
            if not all_attr:
                raise ValueError("Supplied object did not have the correct attributes")
            for e in self._pyangbind_elements:
                nobj = getattr(args[0], e)
                if nobj._changed() is False:
                    continue
                setmethod = getattr(self, "_set_%s" % e)
                if load is None:
                    setmethod(getattr(args[0], e))
                else:
                    setmethod(getattr(args[0], e), load=load)

    def _path(self):
        if hasattr(self, "_parent"):
            return self._parent._path() + [self._yang_name]
        else:
            return [
                "network-instances",
                "network-instance",
                "protocols",
                "protocol",
                "isis",
                "levels",
                "level",
                "link-state-database",
                "lsp",
                "tlvs",
                "tlv",
                "ipv6-srlg",
                "state",
            ]

    def _get_type(self):
        """
    Getter method for type, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/ipv6_srlg/state/type (identityref)

    YANG Description: The type of TLV being described. The type of TLV is
expressed as a canonical name.
    """
        return self.__type

    def _set_type(self, v, load=False):
        """
    Setter method for type, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/ipv6_srlg/state/type (identityref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_type is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_type() directly.

    YANG Description: The type of TLV being described. The type of TLV is
expressed as a canonical name.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=six.text_type,
                    restriction_type="dict_key",
                    restriction_arg={
                        "AREA_ADDRESSES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:AREA_ADDRESSES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "IIS_NEIGHBORS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:IIS_NEIGHBORS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "INSTANCE_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:INSTANCE_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "AUTHENTICATION": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:AUTHENTICATION": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "PURGE_OI": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:PURGE_OI": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "EXTENDED_IS_REACHABILITY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:EXTENDED_IS_REACHABILITY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "IS_NEIGHBOR_ATTRIBUTE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:IS_NEIGHBOR_ATTRIBUTE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "ISIS_ALIAS_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:ISIS_ALIAS_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "IPV4_INTERNAL_REACHABILITY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:IPV4_INTERNAL_REACHABILITY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "NLPID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:NLPID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "IPV4_EXTERNAL_REACHABILITY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:IPV4_EXTERNAL_REACHABILITY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "IPV4_INTERFACE_ADDRESSES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:IPV4_INTERFACE_ADDRESSES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "IPV4_TE_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:IPV4_TE_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "EXTENDED_IPV4_REACHABILITY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:EXTENDED_IPV4_REACHABILITY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "DYNAMIC_NAME": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:DYNAMIC_NAME": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "IPV4_SRLG": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:IPV4_SRLG": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "IPV6_SRLG": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:IPV6_SRLG": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "IPV6_TE_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:IPV6_TE_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "MT_ISN": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:MT_ISN": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "MT_IS_NEIGHBOR_ATTRIBUTE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:MT_IS_NEIGHBOR_ATTRIBUTE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "MULTI_TOPOLOGY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:MULTI_TOPOLOGY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "IPV6_INTERFACE_ADDRESSES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:IPV6_INTERFACE_ADDRESSES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "MT_IPV4_REACHABILITY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:MT_IPV4_REACHABILITY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "IPV6_REACHABILITY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:IPV6_REACHABILITY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "MT_IPV6_REACHABILITY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:MT_IPV6_REACHABILITY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "ROUTER_CAPABILITIES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:ROUTER_CAPABILITIES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                    },
                ),
                is_leaf=True,
                yang_name="type",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="identityref",
                is_config=False,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """type must be of a type compatible with identityref""",
                    "defined-type": "openconfig-network-instance:identityref",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=six.text_type, restriction_type="dict_key", restriction_arg={'AREA_ADDRESSES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:AREA_ADDRESSES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'IIS_NEIGHBORS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:IIS_NEIGHBORS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'INSTANCE_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:INSTANCE_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'AUTHENTICATION': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:AUTHENTICATION': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'PURGE_OI': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:PURGE_OI': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'EXTENDED_IS_REACHABILITY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:EXTENDED_IS_REACHABILITY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'IS_NEIGHBOR_ATTRIBUTE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:IS_NEIGHBOR_ATTRIBUTE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'ISIS_ALIAS_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:ISIS_ALIAS_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'IPV4_INTERNAL_REACHABILITY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:IPV4_INTERNAL_REACHABILITY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'NLPID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:NLPID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'IPV4_EXTERNAL_REACHABILITY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:IPV4_EXTERNAL_REACHABILITY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'IPV4_INTERFACE_ADDRESSES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:IPV4_INTERFACE_ADDRESSES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'IPV4_TE_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:IPV4_TE_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'EXTENDED_IPV4_REACHABILITY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:EXTENDED_IPV4_REACHABILITY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'DYNAMIC_NAME': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:DYNAMIC_NAME': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'IPV4_SRLG': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:IPV4_SRLG': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'IPV6_SRLG': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:IPV6_SRLG': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'IPV6_TE_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:IPV6_TE_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'MT_ISN': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:MT_ISN': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'MT_IS_NEIGHBOR_ATTRIBUTE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:MT_IS_NEIGHBOR_ATTRIBUTE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'MULTI_TOPOLOGY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:MULTI_TOPOLOGY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'IPV6_INTERFACE_ADDRESSES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:IPV6_INTERFACE_ADDRESSES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'MT_IPV4_REACHABILITY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:MT_IPV4_REACHABILITY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'IPV6_REACHABILITY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:IPV6_REACHABILITY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'MT_IPV6_REACHABILITY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:MT_IPV6_REACHABILITY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'ROUTER_CAPABILITIES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:ROUTER_CAPABILITIES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}},), is_leaf=True, yang_name="type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='identityref', is_config=False)""",
                }
            )

        self.__type = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_type(self):
        self.__type = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_type="dict_key",
                restriction_arg={
                    "AREA_ADDRESSES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:AREA_ADDRESSES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IIS_NEIGHBORS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IIS_NEIGHBORS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "INSTANCE_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:INSTANCE_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "AUTHENTICATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:AUTHENTICATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "PURGE_OI": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:PURGE_OI": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "EXTENDED_IS_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:EXTENDED_IS_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IS_NEIGHBOR_ATTRIBUTE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IS_NEIGHBOR_ATTRIBUTE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_ALIAS_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_ALIAS_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV4_INTERNAL_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV4_INTERNAL_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "NLPID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:NLPID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV4_EXTERNAL_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV4_EXTERNAL_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV4_INTERFACE_ADDRESSES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV4_INTERFACE_ADDRESSES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV4_TE_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV4_TE_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "EXTENDED_IPV4_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:EXTENDED_IPV4_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "DYNAMIC_NAME": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:DYNAMIC_NAME": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV4_SRLG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV4_SRLG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV6_SRLG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV6_SRLG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV6_TE_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV6_TE_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "MT_ISN": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:MT_ISN": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "MT_IS_NEIGHBOR_ATTRIBUTE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:MT_IS_NEIGHBOR_ATTRIBUTE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "MULTI_TOPOLOGY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:MULTI_TOPOLOGY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV6_INTERFACE_ADDRESSES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV6_INTERFACE_ADDRESSES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "MT_IPV4_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:MT_IPV4_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV6_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV6_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "MT_IPV6_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:MT_IPV6_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ROUTER_CAPABILITIES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ROUTER_CAPABILITIES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                },
            ),
            is_leaf=True,
            yang_name="type",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="identityref",
            is_config=False,
        )

    def _get_system_id(self):
        """
    Getter method for system_id, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/ipv6_srlg/state/system_id (oc-isis-types:system-id)

    YANG Description: Neighbor system ID.
    """
        return self.__system_id

    def _set_system_id(self, v, load=False):
        """
    Setter method for system_id, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/ipv6_srlg/state/system_id (oc-isis-types:system-id)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_system_id is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_system_id() directly.

    YANG Description: Neighbor system ID.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "[0-9A-Fa-f]{4}\\.[0-9A-Fa-f]{4}\\.[0-9A-Fa-f]{4}"
                    },
                ),
                is_leaf=True,
                yang_name="system-id",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="oc-isis-types:system-id",
                is_config=False,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """system_id must be of a type compatible with oc-isis-types:system-id""",
                    "defined-type": "oc-isis-types:system-id",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=six.text_type, restriction_dict={'pattern': '[0-9A-Fa-f]{4}\\.[0-9A-Fa-f]{4}\\.[0-9A-Fa-f]{4}'}), is_leaf=True, yang_name="system-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-isis-types:system-id', is_config=False)""",
                }
            )

        self.__system_id = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_system_id(self):
        self.__system_id = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_dict={
                    "pattern": "[0-9A-Fa-f]{4}\\.[0-9A-Fa-f]{4}\\.[0-9A-Fa-f]{4}"
                },
            ),
            is_leaf=True,
            yang_name="system-id",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="oc-isis-types:system-id",
            is_config=False,
        )

    def _get_psn_number(self):
        """
    Getter method for psn_number, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/ipv6_srlg/state/psn_number (uint8)

    YANG Description: Pseudonode number if the neighbor is on a LAN interface.
    """
        return self.__psn_number

    def _set_psn_number(self, v, load=False):
        """
    Setter method for psn_number, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/ipv6_srlg/state/psn_number (uint8)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_psn_number is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_psn_number() directly.

    YANG Description: Pseudonode number if the neighbor is on a LAN interface.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=int, restriction_dict={"range": ["0..255"]}, int_size=8
                ),
                is_leaf=True,
                yang_name="psn-number",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="uint8",
                is_config=False,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """psn_number must be of a type compatible with uint8""",
                    "defined-type": "uint8",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..255']}, int_size=8), is_leaf=True, yang_name="psn-number", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint8', is_config=False)""",
                }
            )

        self.__psn_number = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_psn_number(self):
        self.__psn_number = YANGDynClass(
            base=RestrictedClassType(
                base_type=int, restriction_dict={"range": ["0..255"]}, int_size=8
            ),
            is_leaf=True,
            yang_name="psn-number",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="uint8",
            is_config=False,
        )

    def _get_flags(self):
        """
    Getter method for flags, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/ipv6_srlg/state/flags (enumeration)

    YANG Description: IPv6 SRLG flags.
    """
        return self.__flags

    def _set_flags(self, v, load=False):
        """
    Setter method for flags, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/ipv6_srlg/state/flags (enumeration)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_flags is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_flags() directly.

    YANG Description: IPv6 SRLG flags.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=TypedListType(
                    allowed_type=RestrictedClassType(
                        base_type=six.text_type,
                        restriction_type="dict_key",
                        restriction_arg={"NA": {}},
                    )
                ),
                is_leaf=False,
                yang_name="flags",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="enumeration",
                is_config=False,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """flags must be of a type compatible with enumeration""",
                    "defined-type": "openconfig-network-instance:enumeration",
                    "generated-type": """YANGDynClass(base=TypedListType(allowed_type=RestrictedClassType(base_type=six.text_type,                                     restriction_type="dict_key",                                     restriction_arg={'NA': {}},)), is_leaf=False, yang_name="flags", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='enumeration', is_config=False)""",
                }
            )

        self.__flags = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_flags(self):
        self.__flags = YANGDynClass(
            base=TypedListType(
                allowed_type=RestrictedClassType(
                    base_type=six.text_type,
                    restriction_type="dict_key",
                    restriction_arg={"NA": {}},
                )
            ),
            is_leaf=False,
            yang_name="flags",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="enumeration",
            is_config=False,
        )

    def _get_ipv6_interface_address(self):
        """
    Getter method for ipv6_interface_address, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/ipv6_srlg/state/ipv6_interface_address (inet:ipv6-address)

    YANG Description: IPv6 interface address or Link Local Identifier.
    """
        return self.__ipv6_interface_address

    def _set_ipv6_interface_address(self, v, load=False):
        """
    Setter method for ipv6_interface_address, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/ipv6_srlg/state/ipv6_interface_address (inet:ipv6-address)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_ipv6_interface_address is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_ipv6_interface_address() directly.

    YANG Description: IPv6 interface address or Link Local Identifier.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\\p{N}\\p{L}]+)?"
                    },
                ),
                is_leaf=True,
                yang_name="ipv6-interface-address",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="inet:ipv6-address",
                is_config=False,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """ipv6_interface_address must be of a type compatible with inet:ipv6-address""",
                    "defined-type": "inet:ipv6-address",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=six.text_type, restriction_dict={'pattern': '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\\p{N}\\p{L}]+)?'}), is_leaf=True, yang_name="ipv6-interface-address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='inet:ipv6-address', is_config=False)""",
                }
            )

        self.__ipv6_interface_address = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_ipv6_interface_address(self):
        self.__ipv6_interface_address = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_dict={
                    "pattern": "((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\\p{N}\\p{L}]+)?"
                },
            ),
            is_leaf=True,
            yang_name="ipv6-interface-address",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="inet:ipv6-address",
            is_config=False,
        )

    def _get_ipv6_neighbor_address(self):
        """
    Getter method for ipv6_neighbor_address, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/ipv6_srlg/state/ipv6_neighbor_address (inet:ipv6-address)

    YANG Description: IPv6 neighbor address or Link Remote Identifier.
    """
        return self.__ipv6_neighbor_address

    def _set_ipv6_neighbor_address(self, v, load=False):
        """
    Setter method for ipv6_neighbor_address, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/ipv6_srlg/state/ipv6_neighbor_address (inet:ipv6-address)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_ipv6_neighbor_address is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_ipv6_neighbor_address() directly.

    YANG Description: IPv6 neighbor address or Link Remote Identifier.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\\p{N}\\p{L}]+)?"
                    },
                ),
                is_leaf=True,
                yang_name="ipv6-neighbor-address",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="inet:ipv6-address",
                is_config=False,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """ipv6_neighbor_address must be of a type compatible with inet:ipv6-address""",
                    "defined-type": "inet:ipv6-address",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=six.text_type, restriction_dict={'pattern': '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\\p{N}\\p{L}]+)?'}), is_leaf=True, yang_name="ipv6-neighbor-address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='inet:ipv6-address', is_config=False)""",
                }
            )

        self.__ipv6_neighbor_address = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_ipv6_neighbor_address(self):
        self.__ipv6_neighbor_address = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_dict={
                    "pattern": "((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\\p{N}\\p{L}]+)?"
                },
            ),
            is_leaf=True,
            yang_name="ipv6-neighbor-address",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="inet:ipv6-address",
            is_config=False,
        )

    def _get_srlg_value(self):
        """
    Getter method for srlg_value, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/ipv6_srlg/state/srlg_value (uint32)

    YANG Description: SRLG values.
    """
        return self.__srlg_value

    def _set_srlg_value(self, v, load=False):
        """
    Setter method for srlg_value, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/ipv6_srlg/state/srlg_value (uint32)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_srlg_value is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_srlg_value() directly.

    YANG Description: SRLG values.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=TypedListType(
                    allowed_type=RestrictedClassType(
                        base_type=long,
                        restriction_dict={"range": ["0..4294967295"]},
                        int_size=32,
                    )
                ),
                is_leaf=False,
                yang_name="srlg-value",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="uint32",
                is_config=False,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """srlg_value must be of a type compatible with uint32""",
                    "defined-type": "uint32",
                    "generated-type": """YANGDynClass(base=TypedListType(allowed_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32)), is_leaf=False, yang_name="srlg-value", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint32', is_config=False)""",
                }
            )

        self.__srlg_value = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_srlg_value(self):
        self.__srlg_value = YANGDynClass(
            base=TypedListType(
                allowed_type=RestrictedClassType(
                    base_type=long,
                    restriction_dict={"range": ["0..4294967295"]},
                    int_size=32,
                )
            ),
            is_leaf=False,
            yang_name="srlg-value",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="uint32",
            is_config=False,
        )

    type = __builtin__.property(_get_type)
    system_id = __builtin__.property(_get_system_id)
    psn_number = __builtin__.property(_get_psn_number)
    flags = __builtin__.property(_get_flags)
    ipv6_interface_address = __builtin__.property(_get_ipv6_interface_address)
    ipv6_neighbor_address = __builtin__.property(_get_ipv6_neighbor_address)
    srlg_value = __builtin__.property(_get_srlg_value)

    _pyangbind_elements = OrderedDict(
        [
            ("type", type),
            ("system_id", system_id),
            ("psn_number", psn_number),
            ("flags", flags),
            ("ipv6_interface_address", ipv6_interface_address),
            ("ipv6_neighbor_address", ipv6_neighbor_address),
            ("srlg_value", srlg_value),
        ]
    )


class state(PybindBase):
    """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance-l2 - based on the path /network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlg/state. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: State parameters of TLV 139.
  """
    __slots__ = (
        "_path_helper",
        "_extmethods",
        "__type",
        "__system_id",
        "__psn_number",
        "__flags",
        "__ipv6_interface_address",
        "__ipv6_neighbor_address",
        "__srlg_value",
    )

    _yang_name = "state"

    _pybind_generated_by = "container"

    def __init__(self, *args, **kwargs):

        self._path_helper = False

        self._extmethods = False
        self.__type = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_type="dict_key",
                restriction_arg={
                    "AREA_ADDRESSES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:AREA_ADDRESSES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IIS_NEIGHBORS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IIS_NEIGHBORS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "INSTANCE_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:INSTANCE_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "AUTHENTICATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:AUTHENTICATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "PURGE_OI": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:PURGE_OI": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "EXTENDED_IS_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:EXTENDED_IS_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IS_NEIGHBOR_ATTRIBUTE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IS_NEIGHBOR_ATTRIBUTE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_ALIAS_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_ALIAS_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV4_INTERNAL_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV4_INTERNAL_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "NLPID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:NLPID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV4_EXTERNAL_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV4_EXTERNAL_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV4_INTERFACE_ADDRESSES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV4_INTERFACE_ADDRESSES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV4_TE_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV4_TE_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "EXTENDED_IPV4_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:EXTENDED_IPV4_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "DYNAMIC_NAME": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:DYNAMIC_NAME": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV4_SRLG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV4_SRLG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV6_SRLG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV6_SRLG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV6_TE_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV6_TE_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "MT_ISN": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:MT_ISN": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "MT_IS_NEIGHBOR_ATTRIBUTE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:MT_IS_NEIGHBOR_ATTRIBUTE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "MULTI_TOPOLOGY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:MULTI_TOPOLOGY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV6_INTERFACE_ADDRESSES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV6_INTERFACE_ADDRESSES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "MT_IPV4_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:MT_IPV4_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV6_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV6_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "MT_IPV6_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:MT_IPV6_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ROUTER_CAPABILITIES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ROUTER_CAPABILITIES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                },
            ),
            is_leaf=True,
            yang_name="type",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="identityref",
            is_config=False,
        )
        self.__system_id = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_dict={
                    "pattern": "[0-9A-Fa-f]{4}\\.[0-9A-Fa-f]{4}\\.[0-9A-Fa-f]{4}"
                },
            ),
            is_leaf=True,
            yang_name="system-id",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="oc-isis-types:system-id",
            is_config=False,
        )
        self.__psn_number = YANGDynClass(
            base=RestrictedClassType(
                base_type=int, restriction_dict={"range": ["0..255"]}, int_size=8
            ),
            is_leaf=True,
            yang_name="psn-number",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="uint8",
            is_config=False,
        )
        self.__flags = YANGDynClass(
            base=TypedListType(
                allowed_type=RestrictedClassType(
                    base_type=six.text_type,
                    restriction_type="dict_key",
                    restriction_arg={"NA": {}},
                )
            ),
            is_leaf=False,
            yang_name="flags",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="enumeration",
            is_config=False,
        )
        self.__ipv6_interface_address = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_dict={
                    "pattern": "((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\\p{N}\\p{L}]+)?"
                },
            ),
            is_leaf=True,
            yang_name="ipv6-interface-address",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="inet:ipv6-address",
            is_config=False,
        )
        self.__ipv6_neighbor_address = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_dict={
                    "pattern": "((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\\p{N}\\p{L}]+)?"
                },
            ),
            is_leaf=True,
            yang_name="ipv6-neighbor-address",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="inet:ipv6-address",
            is_config=False,
        )
        self.__srlg_value = YANGDynClass(
            base=TypedListType(
                allowed_type=RestrictedClassType(
                    base_type=long,
                    restriction_dict={"range": ["0..4294967295"]},
                    int_size=32,
                )
            ),
            is_leaf=False,
            yang_name="srlg-value",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="uint32",
            is_config=False,
        )

        load = kwargs.pop("load", None)
        if args:
            if len(args) > 1:
                raise TypeError("cannot create a YANG container with >1 argument")
            all_attr = True
            for e in self._pyangbind_elements:
                if not hasattr(args[0], e):
                    all_attr = False
                    break
            if not all_attr:
                raise ValueError("Supplied object did not have the correct attributes")
            for e in self._pyangbind_elements:
                nobj = getattr(args[0], e)
                if nobj._changed() is False:
                    continue
                setmethod = getattr(self, "_set_%s" % e)
                if load is None:
                    setmethod(getattr(args[0], e))
                else:
                    setmethod(getattr(args[0], e), load=load)

    def _path(self):
        if hasattr(self, "_parent"):
            return self._parent._path() + [self._yang_name]
        else:
            return [
                "network-instances",
                "network-instance",
                "protocols",
                "protocol",
                "isis",
                "levels",
                "level",
                "link-state-database",
                "lsp",
                "tlvs",
                "tlv",
                "ipv6-srlg",
                "state",
            ]

    def _get_type(self):
        """
    Getter method for type, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/ipv6_srlg/state/type (identityref)

    YANG Description: The type of TLV being described. The type of TLV is
expressed as a canonical name.
    """
        return self.__type

    def _set_type(self, v, load=False):
        """
    Setter method for type, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/ipv6_srlg/state/type (identityref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_type is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_type() directly.

    YANG Description: The type of TLV being described. The type of TLV is
expressed as a canonical name.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=six.text_type,
                    restriction_type="dict_key",
                    restriction_arg={
                        "AREA_ADDRESSES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:AREA_ADDRESSES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "IIS_NEIGHBORS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:IIS_NEIGHBORS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "INSTANCE_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:INSTANCE_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "AUTHENTICATION": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:AUTHENTICATION": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "PURGE_OI": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:PURGE_OI": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "EXTENDED_IS_REACHABILITY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:EXTENDED_IS_REACHABILITY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "IS_NEIGHBOR_ATTRIBUTE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:IS_NEIGHBOR_ATTRIBUTE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "ISIS_ALIAS_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:ISIS_ALIAS_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "IPV4_INTERNAL_REACHABILITY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:IPV4_INTERNAL_REACHABILITY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "NLPID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:NLPID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "IPV4_EXTERNAL_REACHABILITY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:IPV4_EXTERNAL_REACHABILITY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "IPV4_INTERFACE_ADDRESSES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:IPV4_INTERFACE_ADDRESSES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "IPV4_TE_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:IPV4_TE_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "EXTENDED_IPV4_REACHABILITY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:EXTENDED_IPV4_REACHABILITY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "DYNAMIC_NAME": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:DYNAMIC_NAME": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "IPV4_SRLG": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:IPV4_SRLG": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "IPV6_SRLG": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:IPV6_SRLG": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "IPV6_TE_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:IPV6_TE_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "MT_ISN": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:MT_ISN": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "MT_IS_NEIGHBOR_ATTRIBUTE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:MT_IS_NEIGHBOR_ATTRIBUTE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "MULTI_TOPOLOGY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:MULTI_TOPOLOGY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "IPV6_INTERFACE_ADDRESSES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:IPV6_INTERFACE_ADDRESSES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "MT_IPV4_REACHABILITY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:MT_IPV4_REACHABILITY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "IPV6_REACHABILITY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:IPV6_REACHABILITY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "MT_IPV6_REACHABILITY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:MT_IPV6_REACHABILITY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "ROUTER_CAPABILITIES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:ROUTER_CAPABILITIES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                    },
                ),
                is_leaf=True,
                yang_name="type",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="identityref",
                is_config=False,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """type must be of a type compatible with identityref""",
                    "defined-type": "openconfig-network-instance:identityref",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=six.text_type, restriction_type="dict_key", restriction_arg={'AREA_ADDRESSES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:AREA_ADDRESSES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'IIS_NEIGHBORS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:IIS_NEIGHBORS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'INSTANCE_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:INSTANCE_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'AUTHENTICATION': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:AUTHENTICATION': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'PURGE_OI': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:PURGE_OI': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'EXTENDED_IS_REACHABILITY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:EXTENDED_IS_REACHABILITY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'IS_NEIGHBOR_ATTRIBUTE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:IS_NEIGHBOR_ATTRIBUTE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'ISIS_ALIAS_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:ISIS_ALIAS_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'IPV4_INTERNAL_REACHABILITY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:IPV4_INTERNAL_REACHABILITY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'NLPID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:NLPID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'IPV4_EXTERNAL_REACHABILITY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:IPV4_EXTERNAL_REACHABILITY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'IPV4_INTERFACE_ADDRESSES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:IPV4_INTERFACE_ADDRESSES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'IPV4_TE_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:IPV4_TE_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'EXTENDED_IPV4_REACHABILITY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:EXTENDED_IPV4_REACHABILITY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'DYNAMIC_NAME': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:DYNAMIC_NAME': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'IPV4_SRLG': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:IPV4_SRLG': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'IPV6_SRLG': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:IPV6_SRLG': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'IPV6_TE_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:IPV6_TE_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'MT_ISN': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:MT_ISN': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'MT_IS_NEIGHBOR_ATTRIBUTE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:MT_IS_NEIGHBOR_ATTRIBUTE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'MULTI_TOPOLOGY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:MULTI_TOPOLOGY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'IPV6_INTERFACE_ADDRESSES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:IPV6_INTERFACE_ADDRESSES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'MT_IPV4_REACHABILITY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:MT_IPV4_REACHABILITY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'IPV6_REACHABILITY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:IPV6_REACHABILITY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'MT_IPV6_REACHABILITY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:MT_IPV6_REACHABILITY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'ROUTER_CAPABILITIES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:ROUTER_CAPABILITIES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}},), is_leaf=True, yang_name="type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='identityref', is_config=False)""",
                }
            )

        self.__type = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_type(self):
        self.__type = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_type="dict_key",
                restriction_arg={
                    "AREA_ADDRESSES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:AREA_ADDRESSES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IIS_NEIGHBORS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IIS_NEIGHBORS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "INSTANCE_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:INSTANCE_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "AUTHENTICATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:AUTHENTICATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "PURGE_OI": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:PURGE_OI": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "EXTENDED_IS_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:EXTENDED_IS_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IS_NEIGHBOR_ATTRIBUTE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IS_NEIGHBOR_ATTRIBUTE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_ALIAS_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_ALIAS_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV4_INTERNAL_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV4_INTERNAL_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "NLPID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:NLPID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV4_EXTERNAL_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV4_EXTERNAL_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV4_INTERFACE_ADDRESSES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV4_INTERFACE_ADDRESSES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV4_TE_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV4_TE_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "EXTENDED_IPV4_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:EXTENDED_IPV4_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "DYNAMIC_NAME": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:DYNAMIC_NAME": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV4_SRLG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV4_SRLG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV6_SRLG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV6_SRLG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV6_TE_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV6_TE_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "MT_ISN": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:MT_ISN": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "MT_IS_NEIGHBOR_ATTRIBUTE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:MT_IS_NEIGHBOR_ATTRIBUTE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "MULTI_TOPOLOGY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:MULTI_TOPOLOGY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV6_INTERFACE_ADDRESSES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV6_INTERFACE_ADDRESSES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "MT_IPV4_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:MT_IPV4_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "IPV6_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:IPV6_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "MT_IPV6_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:MT_IPV6_REACHABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ROUTER_CAPABILITIES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ROUTER_CAPABILITIES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                },
            ),
            is_leaf=True,
            yang_name="type",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="identityref",
            is_config=False,
        )

    def _get_system_id(self):
        """
    Getter method for system_id, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/ipv6_srlg/state/system_id (oc-isis-types:system-id)

    YANG Description: Neighbor system ID.
    """
        return self.__system_id

    def _set_system_id(self, v, load=False):
        """
    Setter method for system_id, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/ipv6_srlg/state/system_id (oc-isis-types:system-id)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_system_id is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_system_id() directly.

    YANG Description: Neighbor system ID.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "[0-9A-Fa-f]{4}\\.[0-9A-Fa-f]{4}\\.[0-9A-Fa-f]{4}"
                    },
                ),
                is_leaf=True,
                yang_name="system-id",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="oc-isis-types:system-id",
                is_config=False,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """system_id must be of a type compatible with oc-isis-types:system-id""",
                    "defined-type": "oc-isis-types:system-id",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=six.text_type, restriction_dict={'pattern': '[0-9A-Fa-f]{4}\\.[0-9A-Fa-f]{4}\\.[0-9A-Fa-f]{4}'}), is_leaf=True, yang_name="system-id", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-isis-types:system-id', is_config=False)""",
                }
            )

        self.__system_id = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_system_id(self):
        self.__system_id = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_dict={
                    "pattern": "[0-9A-Fa-f]{4}\\.[0-9A-Fa-f]{4}\\.[0-9A-Fa-f]{4}"
                },
            ),
            is_leaf=True,
            yang_name="system-id",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="oc-isis-types:system-id",
            is_config=False,
        )

    def _get_psn_number(self):
        """
    Getter method for psn_number, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/ipv6_srlg/state/psn_number (uint8)

    YANG Description: Pseudonode number if the neighbor is on a LAN interface.
    """
        return self.__psn_number

    def _set_psn_number(self, v, load=False):
        """
    Setter method for psn_number, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/ipv6_srlg/state/psn_number (uint8)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_psn_number is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_psn_number() directly.

    YANG Description: Pseudonode number if the neighbor is on a LAN interface.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=int, restriction_dict={"range": ["0..255"]}, int_size=8
                ),
                is_leaf=True,
                yang_name="psn-number",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="uint8",
                is_config=False,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """psn_number must be of a type compatible with uint8""",
                    "defined-type": "uint8",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..255']}, int_size=8), is_leaf=True, yang_name="psn-number", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint8', is_config=False)""",
                }
            )

        self.__psn_number = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_psn_number(self):
        self.__psn_number = YANGDynClass(
            base=RestrictedClassType(
                base_type=int, restriction_dict={"range": ["0..255"]}, int_size=8
            ),
            is_leaf=True,
            yang_name="psn-number",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="uint8",
            is_config=False,
        )

    def _get_flags(self):
        """
    Getter method for flags, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/ipv6_srlg/state/flags (enumeration)

    YANG Description: IPv6 SRLG flags.
    """
        return self.__flags

    def _set_flags(self, v, load=False):
        """
    Setter method for flags, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/ipv6_srlg/state/flags (enumeration)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_flags is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_flags() directly.

    YANG Description: IPv6 SRLG flags.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=TypedListType(
                    allowed_type=RestrictedClassType(
                        base_type=six.text_type,
                        restriction_type="dict_key",
                        restriction_arg={"NA": {}},
                    )
                ),
                is_leaf=False,
                yang_name="flags",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="enumeration",
                is_config=False,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """flags must be of a type compatible with enumeration""",
                    "defined-type": "openconfig-network-instance:enumeration",
                    "generated-type": """YANGDynClass(base=TypedListType(allowed_type=RestrictedClassType(base_type=six.text_type,                                     restriction_type="dict_key",                                     restriction_arg={'NA': {}},)), is_leaf=False, yang_name="flags", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='enumeration', is_config=False)""",
                }
            )

        self.__flags = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_flags(self):
        self.__flags = YANGDynClass(
            base=TypedListType(
                allowed_type=RestrictedClassType(
                    base_type=six.text_type,
                    restriction_type="dict_key",
                    restriction_arg={"NA": {}},
                )
            ),
            is_leaf=False,
            yang_name="flags",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="enumeration",
            is_config=False,
        )

    def _get_ipv6_interface_address(self):
        """
    Getter method for ipv6_interface_address, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/ipv6_srlg/state/ipv6_interface_address (inet:ipv6-address)

    YANG Description: IPv6 interface address or Link Local Identifier.
    """
        return self.__ipv6_interface_address

    def _set_ipv6_interface_address(self, v, load=False):
        """
    Setter method for ipv6_interface_address, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/ipv6_srlg/state/ipv6_interface_address (inet:ipv6-address)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_ipv6_interface_address is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_ipv6_interface_address() directly.

    YANG Description: IPv6 interface address or Link Local Identifier.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\\p{N}\\p{L}]+)?"
                    },
                ),
                is_leaf=True,
                yang_name="ipv6-interface-address",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="inet:ipv6-address",
                is_config=False,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """ipv6_interface_address must be of a type compatible with inet:ipv6-address""",
                    "defined-type": "inet:ipv6-address",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=six.text_type, restriction_dict={'pattern': '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\\p{N}\\p{L}]+)?'}), is_leaf=True, yang_name="ipv6-interface-address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='inet:ipv6-address', is_config=False)""",
                }
            )

        self.__ipv6_interface_address = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_ipv6_interface_address(self):
        self.__ipv6_interface_address = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_dict={
                    "pattern": "((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\\p{N}\\p{L}]+)?"
                },
            ),
            is_leaf=True,
            yang_name="ipv6-interface-address",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="inet:ipv6-address",
            is_config=False,
        )

    def _get_ipv6_neighbor_address(self):
        """
    Getter method for ipv6_neighbor_address, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/ipv6_srlg/state/ipv6_neighbor_address (inet:ipv6-address)

    YANG Description: IPv6 neighbor address or Link Remote Identifier.
    """
        return self.__ipv6_neighbor_address

    def _set_ipv6_neighbor_address(self, v, load=False):
        """
    Setter method for ipv6_neighbor_address, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/ipv6_srlg/state/ipv6_neighbor_address (inet:ipv6-address)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_ipv6_neighbor_address is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_ipv6_neighbor_address() directly.

    YANG Description: IPv6 neighbor address or Link Remote Identifier.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=six.text_type,
                    restriction_dict={
                        "pattern": "((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\\p{N}\\p{L}]+)?"
                    },
                ),
                is_leaf=True,
                yang_name="ipv6-neighbor-address",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="inet:ipv6-address",
                is_config=False,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """ipv6_neighbor_address must be of a type compatible with inet:ipv6-address""",
                    "defined-type": "inet:ipv6-address",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=six.text_type, restriction_dict={'pattern': '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\\p{N}\\p{L}]+)?'}), is_leaf=True, yang_name="ipv6-neighbor-address", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='inet:ipv6-address', is_config=False)""",
                }
            )

        self.__ipv6_neighbor_address = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_ipv6_neighbor_address(self):
        self.__ipv6_neighbor_address = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_dict={
                    "pattern": "((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}((([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\\p{N}\\p{L}]+)?"
                },
            ),
            is_leaf=True,
            yang_name="ipv6-neighbor-address",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="inet:ipv6-address",
            is_config=False,
        )

    def _get_srlg_value(self):
        """
    Getter method for srlg_value, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/ipv6_srlg/state/srlg_value (uint32)

    YANG Description: SRLG values.
    """
        return self.__srlg_value

    def _set_srlg_value(self, v, load=False):
        """
    Setter method for srlg_value, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/ipv6_srlg/state/srlg_value (uint32)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_srlg_value is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_srlg_value() directly.

    YANG Description: SRLG values.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=TypedListType(
                    allowed_type=RestrictedClassType(
                        base_type=long,
                        restriction_dict={"range": ["0..4294967295"]},
                        int_size=32,
                    )
                ),
                is_leaf=False,
                yang_name="srlg-value",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="uint32",
                is_config=False,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """srlg_value must be of a type compatible with uint32""",
                    "defined-type": "uint32",
                    "generated-type": """YANGDynClass(base=TypedListType(allowed_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32)), is_leaf=False, yang_name="srlg-value", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint32', is_config=False)""",
                }
            )

        self.__srlg_value = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_srlg_value(self):
        self.__srlg_value = YANGDynClass(
            base=TypedListType(
                allowed_type=RestrictedClassType(
                    base_type=long,
                    restriction_dict={"range": ["0..4294967295"]},
                    int_size=32,
                )
            ),
            is_leaf=False,
            yang_name="srlg-value",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="uint32",
            is_config=False,
        )

    type = __builtin__.property(_get_type)
    system_id = __builtin__.property(_get_system_id)
    psn_number = __builtin__.property(_get_psn_number)
    flags = __builtin__.property(_get_flags)
    ipv6_interface_address = __builtin__.property(_get_ipv6_interface_address)
    ipv6_neighbor_address = __builtin__.property(_get_ipv6_neighbor_address)
    srlg_value = __builtin__.property(_get_srlg_value)

    _pyangbind_elements = OrderedDict(
        [
            ("type", type),
            ("system_id", system_id),
            ("psn_number", psn_number),
            ("flags", flags),
            ("ipv6_interface_address", ipv6_interface_address),
            ("ipv6_neighbor_address", ipv6_neighbor_address),
            ("srlg_value", srlg_value),
        ]
    )
