# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal
from bitarray import bitarray
import six

# PY3 support of some PY2 keywords (needs improved)
if six.PY3:
    import builtins as __builtin__

    long = int
elif six.PY2:
    import __builtin__

from . import srgbs
from . import srlbs


class segment_routing(PybindBase):
    """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance - based on the path /network-instances/network-instance/segment-routing. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration and operational state parameters relating to
segment routing.
  """
    __slots__ = ("_path_helper", "_extmethods", "__srgbs", "__srlbs")

    _yang_name = "segment-routing"

    _pybind_generated_by = "container"

    def __init__(self, *args, **kwargs):

        self._path_helper = False

        self._extmethods = False
        self.__srgbs = YANGDynClass(
            base=srgbs.srgbs,
            is_container="container",
            yang_name="srgbs",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            extensions=None,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="container",
            is_config=True,
        )
        self.__srlbs = YANGDynClass(
            base=srlbs.srlbs,
            is_container="container",
            yang_name="srlbs",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            extensions=None,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="container",
            is_config=True,
        )

        load = kwargs.pop("load", None)
        if args:
            if len(args) > 1:
                raise TypeError("cannot create a YANG container with >1 argument")
            all_attr = True
            for e in self._pyangbind_elements:
                if not hasattr(args[0], e):
                    all_attr = False
                    break
            if not all_attr:
                raise ValueError("Supplied object did not have the correct attributes")
            for e in self._pyangbind_elements:
                nobj = getattr(args[0], e)
                if nobj._changed() is False:
                    continue
                setmethod = getattr(self, "_set_%s" % e)
                if load is None:
                    setmethod(getattr(args[0], e))
                else:
                    setmethod(getattr(args[0], e), load=load)

    def _path(self):
        if hasattr(self, "_parent"):
            return self._parent._path() + [self._yang_name]
        else:
            return ["network-instances", "network-instance", "segment-routing"]

    def _get_srgbs(self):
        """
    Getter method for srgbs, mapped from YANG variable /network_instances/network_instance/segment_routing/srgbs (container)

    YANG Description: Configuration and operational state parameters relating to the
SRGBs defined for the system.
    """
        return self.__srgbs

    def _set_srgbs(self, v, load=False):
        """
    Setter method for srgbs, mapped from YANG variable /network_instances/network_instance/segment_routing/srgbs (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_srgbs is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_srgbs() directly.

    YANG Description: Configuration and operational state parameters relating to the
SRGBs defined for the system.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=srgbs.srgbs,
                is_container="container",
                yang_name="srgbs",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                extensions=None,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="container",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """srgbs must be of a type compatible with container""",
                    "defined-type": "container",
                    "generated-type": """YANGDynClass(base=srgbs.srgbs, is_container='container', yang_name="srgbs", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
                }
            )

        self.__srgbs = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_srgbs(self):
        self.__srgbs = YANGDynClass(
            base=srgbs.srgbs,
            is_container="container",
            yang_name="srgbs",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            extensions=None,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="container",
            is_config=True,
        )

    def _get_srlbs(self):
        """
    Getter method for srlbs, mapped from YANG variable /network_instances/network_instance/segment_routing/srlbs (container)

    YANG Description: Configuration and operational state parameters relating to the
Segment Routing Local Blocks (SRLBs) defined for the system.
    """
        return self.__srlbs

    def _set_srlbs(self, v, load=False):
        """
    Setter method for srlbs, mapped from YANG variable /network_instances/network_instance/segment_routing/srlbs (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_srlbs is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_srlbs() directly.

    YANG Description: Configuration and operational state parameters relating to the
Segment Routing Local Blocks (SRLBs) defined for the system.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=srlbs.srlbs,
                is_container="container",
                yang_name="srlbs",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                extensions=None,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="container",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """srlbs must be of a type compatible with container""",
                    "defined-type": "container",
                    "generated-type": """YANGDynClass(base=srlbs.srlbs, is_container='container', yang_name="srlbs", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
                }
            )

        self.__srlbs = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_srlbs(self):
        self.__srlbs = YANGDynClass(
            base=srlbs.srlbs,
            is_container="container",
            yang_name="srlbs",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            extensions=None,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="container",
            is_config=True,
        )

    srgbs = __builtin__.property(_get_srgbs, _set_srgbs)
    srlbs = __builtin__.property(_get_srlbs, _set_srlbs)

    _pyangbind_elements = OrderedDict([("srgbs", srgbs), ("srlbs", srlbs)])


from . import srgbs
from . import srlbs


class segment_routing(PybindBase):
    """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance-l2 - based on the path /network-instances/network-instance/segment-routing. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: Configuration and operational state parameters relating to
segment routing.
  """
    __slots__ = ("_path_helper", "_extmethods", "__srgbs", "__srlbs")

    _yang_name = "segment-routing"

    _pybind_generated_by = "container"

    def __init__(self, *args, **kwargs):

        self._path_helper = False

        self._extmethods = False
        self.__srgbs = YANGDynClass(
            base=srgbs.srgbs,
            is_container="container",
            yang_name="srgbs",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            extensions=None,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="container",
            is_config=True,
        )
        self.__srlbs = YANGDynClass(
            base=srlbs.srlbs,
            is_container="container",
            yang_name="srlbs",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            extensions=None,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="container",
            is_config=True,
        )

        load = kwargs.pop("load", None)
        if args:
            if len(args) > 1:
                raise TypeError("cannot create a YANG container with >1 argument")
            all_attr = True
            for e in self._pyangbind_elements:
                if not hasattr(args[0], e):
                    all_attr = False
                    break
            if not all_attr:
                raise ValueError("Supplied object did not have the correct attributes")
            for e in self._pyangbind_elements:
                nobj = getattr(args[0], e)
                if nobj._changed() is False:
                    continue
                setmethod = getattr(self, "_set_%s" % e)
                if load is None:
                    setmethod(getattr(args[0], e))
                else:
                    setmethod(getattr(args[0], e), load=load)

    def _path(self):
        if hasattr(self, "_parent"):
            return self._parent._path() + [self._yang_name]
        else:
            return ["network-instances", "network-instance", "segment-routing"]

    def _get_srgbs(self):
        """
    Getter method for srgbs, mapped from YANG variable /network_instances/network_instance/segment_routing/srgbs (container)

    YANG Description: Configuration and operational state parameters relating to the
SRGBs defined for the system.
    """
        return self.__srgbs

    def _set_srgbs(self, v, load=False):
        """
    Setter method for srgbs, mapped from YANG variable /network_instances/network_instance/segment_routing/srgbs (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_srgbs is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_srgbs() directly.

    YANG Description: Configuration and operational state parameters relating to the
SRGBs defined for the system.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=srgbs.srgbs,
                is_container="container",
                yang_name="srgbs",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                extensions=None,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="container",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """srgbs must be of a type compatible with container""",
                    "defined-type": "container",
                    "generated-type": """YANGDynClass(base=srgbs.srgbs, is_container='container', yang_name="srgbs", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
                }
            )

        self.__srgbs = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_srgbs(self):
        self.__srgbs = YANGDynClass(
            base=srgbs.srgbs,
            is_container="container",
            yang_name="srgbs",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            extensions=None,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="container",
            is_config=True,
        )

    def _get_srlbs(self):
        """
    Getter method for srlbs, mapped from YANG variable /network_instances/network_instance/segment_routing/srlbs (container)

    YANG Description: Configuration and operational state parameters relating to the
Segment Routing Local Blocks (SRLBs) defined for the system.
    """
        return self.__srlbs

    def _set_srlbs(self, v, load=False):
        """
    Setter method for srlbs, mapped from YANG variable /network_instances/network_instance/segment_routing/srlbs (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_srlbs is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_srlbs() directly.

    YANG Description: Configuration and operational state parameters relating to the
Segment Routing Local Blocks (SRLBs) defined for the system.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=srlbs.srlbs,
                is_container="container",
                yang_name="srlbs",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                extensions=None,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="container",
                is_config=True,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """srlbs must be of a type compatible with container""",
                    "defined-type": "container",
                    "generated-type": """YANGDynClass(base=srlbs.srlbs, is_container='container', yang_name="srlbs", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions=None, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='container', is_config=True)""",
                }
            )

        self.__srlbs = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_srlbs(self):
        self.__srlbs = YANGDynClass(
            base=srlbs.srlbs,
            is_container="container",
            yang_name="srlbs",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            extensions=None,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="container",
            is_config=True,
        )

    srgbs = __builtin__.property(_get_srgbs, _set_srgbs)
    srlbs = __builtin__.property(_get_srlbs, _set_srlbs)

    _pyangbind_elements = OrderedDict([("srgbs", srgbs), ("srlbs", srlbs)])
