# -*- coding: utf-8 -*-
from operator import attrgetter
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType
from pyangbind.lib.yangtypes import RestrictedClassType
from pyangbind.lib.yangtypes import TypedListType
from pyangbind.lib.yangtypes import YANGBool
from pyangbind.lib.yangtypes import YANGListType
from pyangbind.lib.yangtypes import YANGDynClass
from pyangbind.lib.yangtypes import ReferenceType
from pyangbind.lib.base import PybindBase
from collections import OrderedDict
from decimal import Decimal
from bitarray import bitarray
import six

# PY3 support of some PY2 keywords (needs improved)
if six.PY3:
    import builtins as __builtin__

    long = int
elif six.PY2:
    import __builtin__


class state(PybindBase):
    """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance - based on the path /network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/subTLVs/subTLVs/unreserved-bandwidth/setup-priority/state. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: State parameters of IS Extended Reachability sub-TLV 11.
  """
    __slots__ = (
        "_path_helper",
        "_extmethods",
        "__setup_priority",
        "__subtlv_type",
        "__unreserved_bandwidth",
    )

    _yang_name = "state"

    _pybind_generated_by = "container"

    def __init__(self, *args, **kwargs):

        self._path_helper = False

        self._extmethods = False
        self.__setup_priority = YANGDynClass(
            base=RestrictedClassType(
                base_type=RestrictedClassType(
                    base_type=int, restriction_dict={"range": ["0..255"]}, int_size=8
                ),
                restriction_dict={"range": ["0 .. 7"]},
            ),
            is_leaf=True,
            yang_name="setup-priority",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="uint8",
            is_config=False,
        )
        self.__subtlv_type = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_type="dict_key",
                restriction_arg={
                    "ISIS_TLV22_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV22_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV23_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV23_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV135_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV135_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV135_TAG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV135_TAG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV135_TAG64": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV135_TAG64": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV135_PREFIX_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV135_PREFIX_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV135_PREFIX_FLAGS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV135_PREFIX_FLAGS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV135_IPV4_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV135_IPV4_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV135_IPV6_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV135_IPV6_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV141_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV141_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV222_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV222_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV223_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV223_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV235_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV235_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV235_TAG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV235_TAG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV235_TAG64": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV235_TAG64": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV235_PREFIX_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV235_PREFIX_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV235_PREFIX_FLAGS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV235_PREFIX_FLAGS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV235_IPV4_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV235_IPV4_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV235_IPV6_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV235_IPV6_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV236_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV236_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV236_TAG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV236_TAG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV236_TAG64": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV236_TAG64": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV236_PREFIX_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV236_PREFIX_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV236_PREFIX_FLAGS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV236_PREFIX_FLAGS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV236_IPV4_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV236_IPV4_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV236_IPV6_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV236_IPV6_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV237_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV237_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV237_TAG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV237_TAG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV237_TAG64": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV237_TAG64": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV237_PREFIX_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV237_PREFIX_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV237_PREFIX_FLAGS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV237_PREFIX_FLAGS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV237_IPV4_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV237_IPV4_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV237_IPV6_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV237_IPV6_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV242_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV242_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV242_SR_CAPABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV242_SR_CAPABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV242_SR_ALGORITHM": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV242_SR_ALGORITHM": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                },
            ),
            is_leaf=True,
            yang_name="subtlv-type",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="identityref",
            is_config=False,
        )
        self.__unreserved_bandwidth = YANGDynClass(
            base=RestrictedClassType(
                base_type=bitarray, restriction_dict={"length": ["32"]}
            ),
            is_leaf=True,
            yang_name="unreserved-bandwidth",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="oc-types:ieeefloat32",
            is_config=False,
        )

        load = kwargs.pop("load", None)
        if args:
            if len(args) > 1:
                raise TypeError("cannot create a YANG container with >1 argument")
            all_attr = True
            for e in self._pyangbind_elements:
                if not hasattr(args[0], e):
                    all_attr = False
                    break
            if not all_attr:
                raise ValueError("Supplied object did not have the correct attributes")
            for e in self._pyangbind_elements:
                nobj = getattr(args[0], e)
                if nobj._changed() is False:
                    continue
                setmethod = getattr(self, "_set_%s" % e)
                if load is None:
                    setmethod(getattr(args[0], e))
                else:
                    setmethod(getattr(args[0], e), load=load)

    def _path(self):
        if hasattr(self, "_parent"):
            return self._parent._path() + [self._yang_name]
        else:
            return [
                "network-instances",
                "network-instance",
                "protocols",
                "protocol",
                "isis",
                "levels",
                "level",
                "link-state-database",
                "lsp",
                "tlvs",
                "tlv",
                "isis-neighbor-attribute",
                "neighbors",
                "neighbor",
                "subTLVs",
                "subTLVs",
                "unreserved-bandwidth",
                "setup-priority",
                "state",
            ]

    def _get_setup_priority(self):
        """
    Getter method for setup_priority, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/isis_neighbor_attribute/neighbors/neighbor/subTLVs/subTLVs/unreserved_bandwidth/setup_priority/state/setup_priority (uint8)

    YANG Description: Setup priority level of 0 through 7 to be used by Unreserved Bandwidth
sub-TLV 11.
    """
        return self.__setup_priority

    def _set_setup_priority(self, v, load=False):
        """
    Setter method for setup_priority, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/isis_neighbor_attribute/neighbors/neighbor/subTLVs/subTLVs/unreserved_bandwidth/setup_priority/state/setup_priority (uint8)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_setup_priority is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_setup_priority() directly.

    YANG Description: Setup priority level of 0 through 7 to be used by Unreserved Bandwidth
sub-TLV 11.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=RestrictedClassType(
                        base_type=int,
                        restriction_dict={"range": ["0..255"]},
                        int_size=8,
                    ),
                    restriction_dict={"range": ["0 .. 7"]},
                ),
                is_leaf=True,
                yang_name="setup-priority",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="uint8",
                is_config=False,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """setup_priority must be of a type compatible with uint8""",
                    "defined-type": "uint8",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..255']}, int_size=8), restriction_dict={'range': ['0 .. 7']}), is_leaf=True, yang_name="setup-priority", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint8', is_config=False)""",
                }
            )

        self.__setup_priority = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_setup_priority(self):
        self.__setup_priority = YANGDynClass(
            base=RestrictedClassType(
                base_type=RestrictedClassType(
                    base_type=int, restriction_dict={"range": ["0..255"]}, int_size=8
                ),
                restriction_dict={"range": ["0 .. 7"]},
            ),
            is_leaf=True,
            yang_name="setup-priority",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="uint8",
            is_config=False,
        )

    def _get_subtlv_type(self):
        """
    Getter method for subtlv_type, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/isis_neighbor_attribute/neighbors/neighbor/subTLVs/subTLVs/unreserved_bandwidth/setup_priority/state/subtlv_type (identityref)

    YANG Description: The type of subTLV being described. The type of subTLV is
expressed as a canonical name.
    """
        return self.__subtlv_type

    def _set_subtlv_type(self, v, load=False):
        """
    Setter method for subtlv_type, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/isis_neighbor_attribute/neighbors/neighbor/subTLVs/subTLVs/unreserved_bandwidth/setup_priority/state/subtlv_type (identityref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_subtlv_type is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_subtlv_type() directly.

    YANG Description: The type of subTLV being described. The type of subTLV is
expressed as a canonical name.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=six.text_type,
                    restriction_type="dict_key",
                    restriction_arg={
                        "ISIS_TLV22_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:ISIS_TLV22_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_IPV4_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_IPV4_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_IPV4_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_IPV4_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_MAX_LINK_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_MAX_LINK_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_MAX_RESERVABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_MAX_RESERVABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_UNRESERVED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_UNRESERVED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_IPV6_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_IPV6_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_IPV6_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_IPV6_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_EXTENDED_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_EXTENDED_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_TE_DEFAULT_METRIC": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_TE_DEFAULT_METRIC": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_LINK_ATTRIBUTES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_LINK_ATTRIBUTES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_LINK_PROTECTION_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_LINK_PROTECTION_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_BANDWIDTH_CONSTRAINTS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_BANDWIDTH_CONSTRAINTS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_UNCONSTRAINED_LSP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_UNCONSTRAINED_LSP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_ADJ_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_ADJ_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_ADJ_LAN_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_ADJ_LAN_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_MIN_MAX_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_MIN_MAX_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_LINK_DELAY_VARIATION": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_LINK_DELAY_VARIATION": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_LINK_LOSS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_LINK_LOSS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_RESIDUAL_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_RESIDUAL_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_AVAILABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_AVAILABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_UTILIZED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_UTILIZED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "ISIS_TLV23_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:ISIS_TLV23_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_IPV4_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_IPV4_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_IPV4_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_IPV4_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_MAX_LINK_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_MAX_LINK_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_MAX_RESERVABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_MAX_RESERVABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_UNRESERVED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_UNRESERVED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_IPV6_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_IPV6_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_IPV6_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_IPV6_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_EXTENDED_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_EXTENDED_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_TE_DEFAULT_METRIC": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_TE_DEFAULT_METRIC": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_LINK_ATTRIBUTES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_LINK_ATTRIBUTES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_LINK_PROTECTION_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_LINK_PROTECTION_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_BANDWIDTH_CONSTRAINTS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_BANDWIDTH_CONSTRAINTS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_UNCONSTRAINED_LSP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_UNCONSTRAINED_LSP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_ADJ_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_ADJ_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_ADJ_LAN_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_ADJ_LAN_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_MIN_MAX_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_MIN_MAX_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_LINK_DELAY_VARIATION": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_LINK_DELAY_VARIATION": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_LINK_LOSS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_LINK_LOSS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_RESIDUAL_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_RESIDUAL_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_AVAILABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_AVAILABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_UTILIZED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_UTILIZED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "ISIS_TLV135_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:ISIS_TLV135_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV135_TAG": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV135_TAG": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV135_TAG64": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV135_TAG64": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV135_PREFIX_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV135_PREFIX_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV135_PREFIX_FLAGS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV135_PREFIX_FLAGS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV135_IPV4_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV135_IPV4_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV135_IPV6_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV135_IPV6_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "ISIS_TLV141_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:ISIS_TLV141_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_IPV4_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_IPV4_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_IPV4_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_IPV4_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_MAX_LINK_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_MAX_LINK_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_MAX_RESERVABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_MAX_RESERVABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_UNRESERVED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_UNRESERVED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_IPV6_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_IPV6_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_IPV6_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_IPV6_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_EXTENDED_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_EXTENDED_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_TE_DEFAULT_METRIC": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_TE_DEFAULT_METRIC": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_LINK_ATTRIBUTES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_LINK_ATTRIBUTES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_LINK_PROTECTION_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_LINK_PROTECTION_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_BANDWIDTH_CONSTRAINTS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_BANDWIDTH_CONSTRAINTS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_UNCONSTRAINED_LSP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_UNCONSTRAINED_LSP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_ADJ_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_ADJ_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_ADJ_LAN_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_ADJ_LAN_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_MIN_MAX_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_MIN_MAX_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_LINK_DELAY_VARIATION": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_LINK_DELAY_VARIATION": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_LINK_LOSS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_LINK_LOSS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_RESIDUAL_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_RESIDUAL_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_AVAILABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_AVAILABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_UTILIZED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_UTILIZED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "ISIS_TLV222_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:ISIS_TLV222_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_IPV4_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_IPV4_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_IPV4_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_IPV4_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_MAX_LINK_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_MAX_LINK_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_MAX_RESERVABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_MAX_RESERVABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_UNRESERVED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_UNRESERVED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_IPV6_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_IPV6_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_IPV6_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_IPV6_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_EXTENDED_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_EXTENDED_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_TE_DEFAULT_METRIC": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_TE_DEFAULT_METRIC": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_LINK_ATTRIBUTES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_LINK_ATTRIBUTES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_LINK_PROTECTION_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_LINK_PROTECTION_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_BANDWIDTH_CONSTRAINTS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_BANDWIDTH_CONSTRAINTS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_UNCONSTRAINED_LSP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_UNCONSTRAINED_LSP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_ADJ_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_ADJ_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_ADJ_LAN_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_ADJ_LAN_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_MIN_MAX_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_MIN_MAX_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_LINK_DELAY_VARIATION": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_LINK_DELAY_VARIATION": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_LINK_LOSS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_LINK_LOSS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_RESIDUAL_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_RESIDUAL_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_AVAILABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_AVAILABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_UTILIZED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_UTILIZED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "ISIS_TLV223_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:ISIS_TLV223_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_IPV4_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_IPV4_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_IPV4_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_IPV4_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_MAX_LINK_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_MAX_LINK_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_MAX_RESERVABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_MAX_RESERVABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_UNRESERVED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_UNRESERVED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_IPV6_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_IPV6_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_IPV6_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_IPV6_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_EXTENDED_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_EXTENDED_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_TE_DEFAULT_METRIC": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_TE_DEFAULT_METRIC": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_LINK_ATTRIBUTES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_LINK_ATTRIBUTES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_LINK_PROTECTION_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_LINK_PROTECTION_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_BANDWIDTH_CONSTRAINTS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_BANDWIDTH_CONSTRAINTS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_UNCONSTRAINED_LSP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_UNCONSTRAINED_LSP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_ADJ_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_ADJ_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_ADJ_LAN_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_ADJ_LAN_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_MIN_MAX_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_MIN_MAX_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_LINK_DELAY_VARIATION": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_LINK_DELAY_VARIATION": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_LINK_LOSS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_LINK_LOSS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_RESIDUAL_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_RESIDUAL_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_AVAILABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_AVAILABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_UTILIZED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_UTILIZED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "ISIS_TLV235_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:ISIS_TLV235_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV235_TAG": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV235_TAG": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV235_TAG64": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV235_TAG64": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV235_PREFIX_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV235_PREFIX_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV235_PREFIX_FLAGS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV235_PREFIX_FLAGS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV235_IPV4_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV235_IPV4_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV235_IPV6_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV235_IPV6_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "ISIS_TLV236_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:ISIS_TLV236_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV236_TAG": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV236_TAG": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV236_TAG64": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV236_TAG64": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV236_PREFIX_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV236_PREFIX_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV236_PREFIX_FLAGS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV236_PREFIX_FLAGS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV236_IPV4_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV236_IPV4_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV236_IPV6_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV236_IPV6_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "ISIS_TLV237_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:ISIS_TLV237_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV237_TAG": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV237_TAG": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV237_TAG64": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV237_TAG64": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV237_PREFIX_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV237_PREFIX_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV237_PREFIX_FLAGS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV237_PREFIX_FLAGS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV237_IPV4_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV237_IPV4_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV237_IPV6_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV237_IPV6_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "ISIS_TLV242_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:ISIS_TLV242_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV242_SR_CAPABILITY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV242_SR_CAPABILITY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV242_SR_ALGORITHM": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV242_SR_ALGORITHM": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                    },
                ),
                is_leaf=True,
                yang_name="subtlv-type",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="identityref",
                is_config=False,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """subtlv_type must be of a type compatible with identityref""",
                    "defined-type": "openconfig-network-instance:identityref",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=six.text_type, restriction_type="dict_key", restriction_arg={'ISIS_TLV22_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:ISIS_TLV22_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_IPV4_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_IPV4_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_IPV4_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_IPV4_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_MAX_LINK_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_MAX_LINK_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_MAX_RESERVABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_MAX_RESERVABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_UNRESERVED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_UNRESERVED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_IPV6_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_IPV6_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_IPV6_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_IPV6_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_EXTENDED_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_EXTENDED_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_TE_DEFAULT_METRIC': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_TE_DEFAULT_METRIC': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_LINK_ATTRIBUTES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_LINK_ATTRIBUTES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_LINK_PROTECTION_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_LINK_PROTECTION_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_BANDWIDTH_CONSTRAINTS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_BANDWIDTH_CONSTRAINTS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_UNCONSTRAINED_LSP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_UNCONSTRAINED_LSP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_ADJ_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_ADJ_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_ADJ_LAN_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_ADJ_LAN_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_MIN_MAX_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_MIN_MAX_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_LINK_DELAY_VARIATION': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_LINK_DELAY_VARIATION': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_LINK_LOSS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_LINK_LOSS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_RESIDUAL_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_RESIDUAL_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_AVAILABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_AVAILABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_UTILIZED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_UTILIZED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'ISIS_TLV23_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:ISIS_TLV23_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_IPV4_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_IPV4_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_IPV4_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_IPV4_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_MAX_LINK_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_MAX_LINK_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_MAX_RESERVABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_MAX_RESERVABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_UNRESERVED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_UNRESERVED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_IPV6_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_IPV6_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_IPV6_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_IPV6_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_EXTENDED_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_EXTENDED_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_TE_DEFAULT_METRIC': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_TE_DEFAULT_METRIC': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_LINK_ATTRIBUTES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_LINK_ATTRIBUTES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_LINK_PROTECTION_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_LINK_PROTECTION_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_BANDWIDTH_CONSTRAINTS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_BANDWIDTH_CONSTRAINTS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_UNCONSTRAINED_LSP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_UNCONSTRAINED_LSP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_ADJ_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_ADJ_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_ADJ_LAN_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_ADJ_LAN_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_MIN_MAX_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_MIN_MAX_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_LINK_DELAY_VARIATION': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_LINK_DELAY_VARIATION': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_LINK_LOSS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_LINK_LOSS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_RESIDUAL_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_RESIDUAL_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_AVAILABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_AVAILABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_UTILIZED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_UTILIZED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'ISIS_TLV135_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:ISIS_TLV135_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV135_TAG': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV135_TAG': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV135_TAG64': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV135_TAG64': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV135_PREFIX_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV135_PREFIX_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV135_PREFIX_FLAGS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV135_PREFIX_FLAGS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV135_IPV4_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV135_IPV4_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV135_IPV6_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV135_IPV6_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'ISIS_TLV141_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:ISIS_TLV141_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_IPV4_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_IPV4_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_IPV4_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_IPV4_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_MAX_LINK_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_MAX_LINK_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_MAX_RESERVABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_MAX_RESERVABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_UNRESERVED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_UNRESERVED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_IPV6_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_IPV6_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_IPV6_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_IPV6_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_EXTENDED_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_EXTENDED_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_TE_DEFAULT_METRIC': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_TE_DEFAULT_METRIC': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_LINK_ATTRIBUTES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_LINK_ATTRIBUTES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_LINK_PROTECTION_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_LINK_PROTECTION_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_BANDWIDTH_CONSTRAINTS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_BANDWIDTH_CONSTRAINTS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_UNCONSTRAINED_LSP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_UNCONSTRAINED_LSP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_ADJ_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_ADJ_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_ADJ_LAN_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_ADJ_LAN_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_MIN_MAX_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_MIN_MAX_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_LINK_DELAY_VARIATION': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_LINK_DELAY_VARIATION': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_LINK_LOSS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_LINK_LOSS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_RESIDUAL_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_RESIDUAL_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_AVAILABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_AVAILABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_UTILIZED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_UTILIZED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'ISIS_TLV222_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:ISIS_TLV222_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_IPV4_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_IPV4_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_IPV4_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_IPV4_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_MAX_LINK_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_MAX_LINK_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_MAX_RESERVABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_MAX_RESERVABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_UNRESERVED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_UNRESERVED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_IPV6_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_IPV6_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_IPV6_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_IPV6_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_EXTENDED_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_EXTENDED_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_TE_DEFAULT_METRIC': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_TE_DEFAULT_METRIC': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_LINK_ATTRIBUTES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_LINK_ATTRIBUTES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_LINK_PROTECTION_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_LINK_PROTECTION_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_BANDWIDTH_CONSTRAINTS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_BANDWIDTH_CONSTRAINTS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_UNCONSTRAINED_LSP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_UNCONSTRAINED_LSP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_ADJ_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_ADJ_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_ADJ_LAN_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_ADJ_LAN_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_MIN_MAX_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_MIN_MAX_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_LINK_DELAY_VARIATION': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_LINK_DELAY_VARIATION': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_LINK_LOSS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_LINK_LOSS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_RESIDUAL_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_RESIDUAL_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_AVAILABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_AVAILABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_UTILIZED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_UTILIZED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'ISIS_TLV223_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:ISIS_TLV223_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_IPV4_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_IPV4_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_IPV4_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_IPV4_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_MAX_LINK_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_MAX_LINK_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_MAX_RESERVABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_MAX_RESERVABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_UNRESERVED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_UNRESERVED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_IPV6_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_IPV6_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_IPV6_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_IPV6_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_EXTENDED_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_EXTENDED_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_TE_DEFAULT_METRIC': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_TE_DEFAULT_METRIC': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_LINK_ATTRIBUTES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_LINK_ATTRIBUTES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_LINK_PROTECTION_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_LINK_PROTECTION_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_BANDWIDTH_CONSTRAINTS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_BANDWIDTH_CONSTRAINTS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_UNCONSTRAINED_LSP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_UNCONSTRAINED_LSP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_ADJ_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_ADJ_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_ADJ_LAN_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_ADJ_LAN_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_MIN_MAX_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_MIN_MAX_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_LINK_DELAY_VARIATION': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_LINK_DELAY_VARIATION': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_LINK_LOSS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_LINK_LOSS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_RESIDUAL_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_RESIDUAL_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_AVAILABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_AVAILABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_UTILIZED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_UTILIZED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'ISIS_TLV235_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:ISIS_TLV235_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV235_TAG': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV235_TAG': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV235_TAG64': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV235_TAG64': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV235_PREFIX_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV235_PREFIX_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV235_PREFIX_FLAGS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV235_PREFIX_FLAGS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV235_IPV4_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV235_IPV4_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV235_IPV6_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV235_IPV6_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'ISIS_TLV236_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:ISIS_TLV236_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV236_TAG': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV236_TAG': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV236_TAG64': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV236_TAG64': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV236_PREFIX_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV236_PREFIX_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV236_PREFIX_FLAGS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV236_PREFIX_FLAGS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV236_IPV4_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV236_IPV4_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV236_IPV6_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV236_IPV6_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'ISIS_TLV237_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:ISIS_TLV237_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV237_TAG': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV237_TAG': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV237_TAG64': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV237_TAG64': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV237_PREFIX_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV237_PREFIX_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV237_PREFIX_FLAGS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV237_PREFIX_FLAGS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV237_IPV4_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV237_IPV4_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV237_IPV6_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV237_IPV6_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'ISIS_TLV242_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:ISIS_TLV242_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV242_SR_CAPABILITY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV242_SR_CAPABILITY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV242_SR_ALGORITHM': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV242_SR_ALGORITHM': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}},), is_leaf=True, yang_name="subtlv-type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='identityref', is_config=False)""",
                }
            )

        self.__subtlv_type = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_subtlv_type(self):
        self.__subtlv_type = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_type="dict_key",
                restriction_arg={
                    "ISIS_TLV22_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV22_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV23_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV23_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV135_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV135_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV135_TAG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV135_TAG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV135_TAG64": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV135_TAG64": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV135_PREFIX_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV135_PREFIX_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV135_PREFIX_FLAGS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV135_PREFIX_FLAGS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV135_IPV4_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV135_IPV4_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV135_IPV6_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV135_IPV6_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV141_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV141_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV222_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV222_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV223_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV223_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV235_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV235_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV235_TAG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV235_TAG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV235_TAG64": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV235_TAG64": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV235_PREFIX_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV235_PREFIX_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV235_PREFIX_FLAGS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV235_PREFIX_FLAGS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV235_IPV4_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV235_IPV4_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV235_IPV6_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV235_IPV6_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV236_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV236_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV236_TAG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV236_TAG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV236_TAG64": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV236_TAG64": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV236_PREFIX_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV236_PREFIX_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV236_PREFIX_FLAGS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV236_PREFIX_FLAGS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV236_IPV4_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV236_IPV4_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV236_IPV6_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV236_IPV6_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV237_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV237_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV237_TAG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV237_TAG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV237_TAG64": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV237_TAG64": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV237_PREFIX_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV237_PREFIX_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV237_PREFIX_FLAGS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV237_PREFIX_FLAGS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV237_IPV4_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV237_IPV4_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV237_IPV6_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV237_IPV6_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV242_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV242_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV242_SR_CAPABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV242_SR_CAPABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV242_SR_ALGORITHM": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV242_SR_ALGORITHM": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                },
            ),
            is_leaf=True,
            yang_name="subtlv-type",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="identityref",
            is_config=False,
        )

    def _get_unreserved_bandwidth(self):
        """
    Getter method for unreserved_bandwidth, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/isis_neighbor_attribute/neighbors/neighbor/subTLVs/subTLVs/unreserved_bandwidth/setup_priority/state/unreserved_bandwidth (oc-types:ieeefloat32)

    YANG Description: The amount of bandwidth reservable in this direction on this
link. Note that for oversubscription purposes, this can be
greater than the bandwidth of the link. It contains eight
32-bit IEEE floating point numbers(one for each priority). The
units are bytes (not bits!) per second. The values correspond
to the bandwidth that can be reserved with a setup priority of
0 through 7, arranged in increasing order with priority 0
occurring at the start of the sub-TLV, and priority 7 at the
end of the sub-TLV.
    """
        return self.__unreserved_bandwidth

    def _set_unreserved_bandwidth(self, v, load=False):
        """
    Setter method for unreserved_bandwidth, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/isis_neighbor_attribute/neighbors/neighbor/subTLVs/subTLVs/unreserved_bandwidth/setup_priority/state/unreserved_bandwidth (oc-types:ieeefloat32)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_unreserved_bandwidth is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_unreserved_bandwidth() directly.

    YANG Description: The amount of bandwidth reservable in this direction on this
link. Note that for oversubscription purposes, this can be
greater than the bandwidth of the link. It contains eight
32-bit IEEE floating point numbers(one for each priority). The
units are bytes (not bits!) per second. The values correspond
to the bandwidth that can be reserved with a setup priority of
0 through 7, arranged in increasing order with priority 0
occurring at the start of the sub-TLV, and priority 7 at the
end of the sub-TLV.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=bitarray, restriction_dict={"length": ["32"]}
                ),
                is_leaf=True,
                yang_name="unreserved-bandwidth",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="oc-types:ieeefloat32",
                is_config=False,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """unreserved_bandwidth must be of a type compatible with oc-types:ieeefloat32""",
                    "defined-type": "oc-types:ieeefloat32",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=bitarray, restriction_dict={'length': ['32']}), is_leaf=True, yang_name="unreserved-bandwidth", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-types:ieeefloat32', is_config=False)""",
                }
            )

        self.__unreserved_bandwidth = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_unreserved_bandwidth(self):
        self.__unreserved_bandwidth = YANGDynClass(
            base=RestrictedClassType(
                base_type=bitarray, restriction_dict={"length": ["32"]}
            ),
            is_leaf=True,
            yang_name="unreserved-bandwidth",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="oc-types:ieeefloat32",
            is_config=False,
        )

    setup_priority = __builtin__.property(_get_setup_priority)
    subtlv_type = __builtin__.property(_get_subtlv_type)
    unreserved_bandwidth = __builtin__.property(_get_unreserved_bandwidth)

    _pyangbind_elements = OrderedDict(
        [
            ("setup_priority", setup_priority),
            ("subtlv_type", subtlv_type),
            ("unreserved_bandwidth", unreserved_bandwidth),
        ]
    )


class state(PybindBase):
    """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module openconfig-network-instance-l2 - based on the path /network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/subTLVs/subTLVs/unreserved-bandwidth/setup-priority/state. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: State parameters of IS Extended Reachability sub-TLV 11.
  """
    __slots__ = (
        "_path_helper",
        "_extmethods",
        "__setup_priority",
        "__subtlv_type",
        "__unreserved_bandwidth",
    )

    _yang_name = "state"

    _pybind_generated_by = "container"

    def __init__(self, *args, **kwargs):

        self._path_helper = False

        self._extmethods = False
        self.__setup_priority = YANGDynClass(
            base=RestrictedClassType(
                base_type=RestrictedClassType(
                    base_type=int, restriction_dict={"range": ["0..255"]}, int_size=8
                ),
                restriction_dict={"range": ["0 .. 7"]},
            ),
            is_leaf=True,
            yang_name="setup-priority",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="uint8",
            is_config=False,
        )
        self.__subtlv_type = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_type="dict_key",
                restriction_arg={
                    "ISIS_TLV22_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV22_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV23_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV23_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV135_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV135_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV135_TAG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV135_TAG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV135_TAG64": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV135_TAG64": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV135_PREFIX_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV135_PREFIX_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV135_PREFIX_FLAGS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV135_PREFIX_FLAGS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV135_IPV4_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV135_IPV4_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV135_IPV6_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV135_IPV6_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV141_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV141_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV222_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV222_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV223_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV223_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV235_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV235_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV235_TAG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV235_TAG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV235_TAG64": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV235_TAG64": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV235_PREFIX_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV235_PREFIX_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV235_PREFIX_FLAGS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV235_PREFIX_FLAGS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV235_IPV4_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV235_IPV4_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV235_IPV6_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV235_IPV6_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV236_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV236_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV236_TAG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV236_TAG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV236_TAG64": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV236_TAG64": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV236_PREFIX_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV236_PREFIX_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV236_PREFIX_FLAGS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV236_PREFIX_FLAGS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV236_IPV4_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV236_IPV4_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV236_IPV6_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV236_IPV6_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV237_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV237_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV237_TAG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV237_TAG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV237_TAG64": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV237_TAG64": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV237_PREFIX_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV237_PREFIX_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV237_PREFIX_FLAGS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV237_PREFIX_FLAGS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV237_IPV4_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV237_IPV4_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV237_IPV6_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV237_IPV6_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV242_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV242_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV242_SR_CAPABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV242_SR_CAPABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV242_SR_ALGORITHM": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV242_SR_ALGORITHM": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                },
            ),
            is_leaf=True,
            yang_name="subtlv-type",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="identityref",
            is_config=False,
        )
        self.__unreserved_bandwidth = YANGDynClass(
            base=RestrictedClassType(
                base_type=bitarray, restriction_dict={"length": ["32"]}
            ),
            is_leaf=True,
            yang_name="unreserved-bandwidth",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="oc-types:ieeefloat32",
            is_config=False,
        )

        load = kwargs.pop("load", None)
        if args:
            if len(args) > 1:
                raise TypeError("cannot create a YANG container with >1 argument")
            all_attr = True
            for e in self._pyangbind_elements:
                if not hasattr(args[0], e):
                    all_attr = False
                    break
            if not all_attr:
                raise ValueError("Supplied object did not have the correct attributes")
            for e in self._pyangbind_elements:
                nobj = getattr(args[0], e)
                if nobj._changed() is False:
                    continue
                setmethod = getattr(self, "_set_%s" % e)
                if load is None:
                    setmethod(getattr(args[0], e))
                else:
                    setmethod(getattr(args[0], e), load=load)

    def _path(self):
        if hasattr(self, "_parent"):
            return self._parent._path() + [self._yang_name]
        else:
            return [
                "network-instances",
                "network-instance",
                "protocols",
                "protocol",
                "isis",
                "levels",
                "level",
                "link-state-database",
                "lsp",
                "tlvs",
                "tlv",
                "isis-neighbor-attribute",
                "neighbors",
                "neighbor",
                "subTLVs",
                "subTLVs",
                "unreserved-bandwidth",
                "setup-priority",
                "state",
            ]

    def _get_setup_priority(self):
        """
    Getter method for setup_priority, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/isis_neighbor_attribute/neighbors/neighbor/subTLVs/subTLVs/unreserved_bandwidth/setup_priority/state/setup_priority (uint8)

    YANG Description: Setup priority level of 0 through 7 to be used by Unreserved Bandwidth
sub-TLV 11.
    """
        return self.__setup_priority

    def _set_setup_priority(self, v, load=False):
        """
    Setter method for setup_priority, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/isis_neighbor_attribute/neighbors/neighbor/subTLVs/subTLVs/unreserved_bandwidth/setup_priority/state/setup_priority (uint8)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_setup_priority is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_setup_priority() directly.

    YANG Description: Setup priority level of 0 through 7 to be used by Unreserved Bandwidth
sub-TLV 11.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=RestrictedClassType(
                        base_type=int,
                        restriction_dict={"range": ["0..255"]},
                        int_size=8,
                    ),
                    restriction_dict={"range": ["0 .. 7"]},
                ),
                is_leaf=True,
                yang_name="setup-priority",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="uint8",
                is_config=False,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """setup_priority must be of a type compatible with uint8""",
                    "defined-type": "uint8",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..255']}, int_size=8), restriction_dict={'range': ['0 .. 7']}), is_leaf=True, yang_name="setup-priority", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='uint8', is_config=False)""",
                }
            )

        self.__setup_priority = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_setup_priority(self):
        self.__setup_priority = YANGDynClass(
            base=RestrictedClassType(
                base_type=RestrictedClassType(
                    base_type=int, restriction_dict={"range": ["0..255"]}, int_size=8
                ),
                restriction_dict={"range": ["0 .. 7"]},
            ),
            is_leaf=True,
            yang_name="setup-priority",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="uint8",
            is_config=False,
        )

    def _get_subtlv_type(self):
        """
    Getter method for subtlv_type, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/isis_neighbor_attribute/neighbors/neighbor/subTLVs/subTLVs/unreserved_bandwidth/setup_priority/state/subtlv_type (identityref)

    YANG Description: The type of subTLV being described. The type of subTLV is
expressed as a canonical name.
    """
        return self.__subtlv_type

    def _set_subtlv_type(self, v, load=False):
        """
    Setter method for subtlv_type, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/isis_neighbor_attribute/neighbors/neighbor/subTLVs/subTLVs/unreserved_bandwidth/setup_priority/state/subtlv_type (identityref)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_subtlv_type is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_subtlv_type() directly.

    YANG Description: The type of subTLV being described. The type of subTLV is
expressed as a canonical name.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=six.text_type,
                    restriction_type="dict_key",
                    restriction_arg={
                        "ISIS_TLV22_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:ISIS_TLV22_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_IPV4_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_IPV4_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_IPV4_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_IPV4_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_MAX_LINK_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_MAX_LINK_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_MAX_RESERVABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_MAX_RESERVABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_UNRESERVED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_UNRESERVED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_IPV6_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_IPV6_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_IPV6_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_IPV6_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_EXTENDED_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_EXTENDED_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_TE_DEFAULT_METRIC": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_TE_DEFAULT_METRIC": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_LINK_ATTRIBUTES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_LINK_ATTRIBUTES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_LINK_PROTECTION_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_LINK_PROTECTION_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_BANDWIDTH_CONSTRAINTS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_BANDWIDTH_CONSTRAINTS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_UNCONSTRAINED_LSP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_UNCONSTRAINED_LSP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_ADJ_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_ADJ_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_ADJ_LAN_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_ADJ_LAN_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_MIN_MAX_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_MIN_MAX_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_LINK_DELAY_VARIATION": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_LINK_DELAY_VARIATION": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_LINK_LOSS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_LINK_LOSS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_RESIDUAL_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_RESIDUAL_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_AVAILABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_AVAILABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV22_UTILIZED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV22_UTILIZED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "ISIS_TLV23_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:ISIS_TLV23_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_IPV4_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_IPV4_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_IPV4_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_IPV4_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_MAX_LINK_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_MAX_LINK_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_MAX_RESERVABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_MAX_RESERVABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_UNRESERVED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_UNRESERVED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_IPV6_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_IPV6_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_IPV6_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_IPV6_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_EXTENDED_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_EXTENDED_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_TE_DEFAULT_METRIC": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_TE_DEFAULT_METRIC": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_LINK_ATTRIBUTES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_LINK_ATTRIBUTES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_LINK_PROTECTION_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_LINK_PROTECTION_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_BANDWIDTH_CONSTRAINTS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_BANDWIDTH_CONSTRAINTS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_UNCONSTRAINED_LSP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_UNCONSTRAINED_LSP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_ADJ_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_ADJ_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_ADJ_LAN_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_ADJ_LAN_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_MIN_MAX_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_MIN_MAX_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_LINK_DELAY_VARIATION": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_LINK_DELAY_VARIATION": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_LINK_LOSS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_LINK_LOSS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_RESIDUAL_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_RESIDUAL_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_AVAILABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_AVAILABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV23_UTILIZED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV23_UTILIZED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "ISIS_TLV135_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:ISIS_TLV135_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV135_TAG": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV135_TAG": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV135_TAG64": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV135_TAG64": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV135_PREFIX_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV135_PREFIX_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV135_PREFIX_FLAGS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV135_PREFIX_FLAGS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV135_IPV4_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV135_IPV4_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV135_IPV6_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV135_IPV6_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "ISIS_TLV141_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:ISIS_TLV141_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_IPV4_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_IPV4_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_IPV4_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_IPV4_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_MAX_LINK_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_MAX_LINK_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_MAX_RESERVABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_MAX_RESERVABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_UNRESERVED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_UNRESERVED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_IPV6_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_IPV6_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_IPV6_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_IPV6_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_EXTENDED_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_EXTENDED_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_TE_DEFAULT_METRIC": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_TE_DEFAULT_METRIC": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_LINK_ATTRIBUTES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_LINK_ATTRIBUTES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_LINK_PROTECTION_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_LINK_PROTECTION_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_BANDWIDTH_CONSTRAINTS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_BANDWIDTH_CONSTRAINTS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_UNCONSTRAINED_LSP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_UNCONSTRAINED_LSP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_ADJ_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_ADJ_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_ADJ_LAN_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_ADJ_LAN_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_MIN_MAX_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_MIN_MAX_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_LINK_DELAY_VARIATION": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_LINK_DELAY_VARIATION": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_LINK_LOSS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_LINK_LOSS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_RESIDUAL_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_RESIDUAL_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_AVAILABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_AVAILABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV141_UTILIZED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV141_UTILIZED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "ISIS_TLV222_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:ISIS_TLV222_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_IPV4_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_IPV4_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_IPV4_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_IPV4_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_MAX_LINK_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_MAX_LINK_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_MAX_RESERVABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_MAX_RESERVABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_UNRESERVED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_UNRESERVED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_IPV6_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_IPV6_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_IPV6_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_IPV6_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_EXTENDED_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_EXTENDED_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_TE_DEFAULT_METRIC": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_TE_DEFAULT_METRIC": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_LINK_ATTRIBUTES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_LINK_ATTRIBUTES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_LINK_PROTECTION_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_LINK_PROTECTION_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_BANDWIDTH_CONSTRAINTS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_BANDWIDTH_CONSTRAINTS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_UNCONSTRAINED_LSP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_UNCONSTRAINED_LSP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_ADJ_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_ADJ_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_ADJ_LAN_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_ADJ_LAN_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_MIN_MAX_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_MIN_MAX_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_LINK_DELAY_VARIATION": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_LINK_DELAY_VARIATION": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_LINK_LOSS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_LINK_LOSS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_RESIDUAL_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_RESIDUAL_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_AVAILABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_AVAILABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV222_UTILIZED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV222_UTILIZED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "ISIS_TLV223_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:ISIS_TLV223_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_IPV4_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_IPV4_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_IPV4_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_IPV4_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_MAX_LINK_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_MAX_LINK_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_MAX_RESERVABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_MAX_RESERVABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_UNRESERVED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_UNRESERVED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_IPV6_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_IPV6_INTERFACE_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_IPV6_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_IPV6_NEIGHBOR_ADDRESS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_EXTENDED_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_EXTENDED_ADMIN_GROUP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_TE_DEFAULT_METRIC": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_TE_DEFAULT_METRIC": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_LINK_ATTRIBUTES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_LINK_ATTRIBUTES": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_LINK_PROTECTION_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_LINK_PROTECTION_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_BANDWIDTH_CONSTRAINTS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_BANDWIDTH_CONSTRAINTS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_UNCONSTRAINED_LSP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_UNCONSTRAINED_LSP": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_ADJ_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_ADJ_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_ADJ_LAN_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_ADJ_LAN_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_MIN_MAX_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_MIN_MAX_LINK_DELAY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_LINK_DELAY_VARIATION": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_LINK_DELAY_VARIATION": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_LINK_LOSS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_LINK_LOSS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_RESIDUAL_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_RESIDUAL_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_AVAILABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_AVAILABLE_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV223_UTILIZED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV223_UTILIZED_BANDWIDTH": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "ISIS_TLV235_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:ISIS_TLV235_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV235_TAG": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV235_TAG": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV235_TAG64": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV235_TAG64": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV235_PREFIX_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV235_PREFIX_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV235_PREFIX_FLAGS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV235_PREFIX_FLAGS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV235_IPV4_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV235_IPV4_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV235_IPV6_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV235_IPV6_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "ISIS_TLV236_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:ISIS_TLV236_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV236_TAG": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV236_TAG": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV236_TAG64": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV236_TAG64": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV236_PREFIX_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV236_PREFIX_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV236_PREFIX_FLAGS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV236_PREFIX_FLAGS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV236_IPV4_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV236_IPV4_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV236_IPV6_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV236_IPV6_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "ISIS_TLV237_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:ISIS_TLV237_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV237_TAG": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV237_TAG": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV237_TAG64": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV237_TAG64": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV237_PREFIX_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV237_PREFIX_SID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV237_PREFIX_FLAGS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV237_PREFIX_FLAGS": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV237_IPV4_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV237_IPV4_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV237_IPV6_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV237_IPV6_ROUTER_ID": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "ISIS_TLV242_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:ISIS_TLV242_SUBTLVS_TYPE": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV242_SR_CAPABILITY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV242_SR_CAPABILITY": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "TLV242_SR_ALGORITHM": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                        "oc-isis-lsdb-types:TLV242_SR_ALGORITHM": {
                            "@module": "openconfig-isis-lsdb-types",
                            "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                        },
                    },
                ),
                is_leaf=True,
                yang_name="subtlv-type",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="identityref",
                is_config=False,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """subtlv_type must be of a type compatible with identityref""",
                    "defined-type": "openconfig-network-instance:identityref",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=six.text_type, restriction_type="dict_key", restriction_arg={'ISIS_TLV22_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:ISIS_TLV22_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_IPV4_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_IPV4_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_IPV4_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_IPV4_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_MAX_LINK_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_MAX_LINK_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_MAX_RESERVABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_MAX_RESERVABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_UNRESERVED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_UNRESERVED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_IPV6_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_IPV6_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_IPV6_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_IPV6_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_EXTENDED_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_EXTENDED_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_TE_DEFAULT_METRIC': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_TE_DEFAULT_METRIC': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_LINK_ATTRIBUTES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_LINK_ATTRIBUTES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_LINK_PROTECTION_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_LINK_PROTECTION_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_BANDWIDTH_CONSTRAINTS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_BANDWIDTH_CONSTRAINTS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_UNCONSTRAINED_LSP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_UNCONSTRAINED_LSP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_ADJ_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_ADJ_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_ADJ_LAN_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_ADJ_LAN_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_MIN_MAX_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_MIN_MAX_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_LINK_DELAY_VARIATION': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_LINK_DELAY_VARIATION': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_LINK_LOSS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_LINK_LOSS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_RESIDUAL_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_RESIDUAL_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_AVAILABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_AVAILABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV22_UTILIZED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV22_UTILIZED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'ISIS_TLV23_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:ISIS_TLV23_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_IPV4_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_IPV4_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_IPV4_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_IPV4_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_MAX_LINK_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_MAX_LINK_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_MAX_RESERVABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_MAX_RESERVABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_UNRESERVED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_UNRESERVED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_IPV6_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_IPV6_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_IPV6_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_IPV6_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_EXTENDED_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_EXTENDED_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_TE_DEFAULT_METRIC': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_TE_DEFAULT_METRIC': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_LINK_ATTRIBUTES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_LINK_ATTRIBUTES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_LINK_PROTECTION_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_LINK_PROTECTION_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_BANDWIDTH_CONSTRAINTS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_BANDWIDTH_CONSTRAINTS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_UNCONSTRAINED_LSP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_UNCONSTRAINED_LSP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_ADJ_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_ADJ_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_ADJ_LAN_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_ADJ_LAN_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_MIN_MAX_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_MIN_MAX_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_LINK_DELAY_VARIATION': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_LINK_DELAY_VARIATION': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_LINK_LOSS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_LINK_LOSS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_RESIDUAL_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_RESIDUAL_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_AVAILABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_AVAILABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV23_UTILIZED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV23_UTILIZED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'ISIS_TLV135_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:ISIS_TLV135_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV135_TAG': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV135_TAG': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV135_TAG64': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV135_TAG64': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV135_PREFIX_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV135_PREFIX_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV135_PREFIX_FLAGS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV135_PREFIX_FLAGS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV135_IPV4_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV135_IPV4_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV135_IPV6_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV135_IPV6_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'ISIS_TLV141_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:ISIS_TLV141_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_IPV4_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_IPV4_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_IPV4_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_IPV4_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_MAX_LINK_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_MAX_LINK_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_MAX_RESERVABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_MAX_RESERVABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_UNRESERVED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_UNRESERVED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_IPV6_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_IPV6_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_IPV6_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_IPV6_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_EXTENDED_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_EXTENDED_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_TE_DEFAULT_METRIC': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_TE_DEFAULT_METRIC': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_LINK_ATTRIBUTES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_LINK_ATTRIBUTES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_LINK_PROTECTION_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_LINK_PROTECTION_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_BANDWIDTH_CONSTRAINTS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_BANDWIDTH_CONSTRAINTS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_UNCONSTRAINED_LSP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_UNCONSTRAINED_LSP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_ADJ_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_ADJ_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_ADJ_LAN_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_ADJ_LAN_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_MIN_MAX_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_MIN_MAX_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_LINK_DELAY_VARIATION': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_LINK_DELAY_VARIATION': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_LINK_LOSS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_LINK_LOSS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_RESIDUAL_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_RESIDUAL_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_AVAILABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_AVAILABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV141_UTILIZED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV141_UTILIZED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'ISIS_TLV222_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:ISIS_TLV222_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_IPV4_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_IPV4_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_IPV4_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_IPV4_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_MAX_LINK_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_MAX_LINK_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_MAX_RESERVABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_MAX_RESERVABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_UNRESERVED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_UNRESERVED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_IPV6_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_IPV6_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_IPV6_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_IPV6_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_EXTENDED_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_EXTENDED_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_TE_DEFAULT_METRIC': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_TE_DEFAULT_METRIC': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_LINK_ATTRIBUTES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_LINK_ATTRIBUTES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_LINK_PROTECTION_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_LINK_PROTECTION_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_BANDWIDTH_CONSTRAINTS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_BANDWIDTH_CONSTRAINTS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_UNCONSTRAINED_LSP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_UNCONSTRAINED_LSP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_ADJ_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_ADJ_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_ADJ_LAN_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_ADJ_LAN_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_MIN_MAX_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_MIN_MAX_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_LINK_DELAY_VARIATION': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_LINK_DELAY_VARIATION': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_LINK_LOSS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_LINK_LOSS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_RESIDUAL_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_RESIDUAL_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_AVAILABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_AVAILABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV222_UTILIZED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV222_UTILIZED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'ISIS_TLV223_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:ISIS_TLV223_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_IPV4_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_IPV4_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_IPV4_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_IPV4_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_MAX_LINK_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_MAX_LINK_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_MAX_RESERVABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_MAX_RESERVABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_UNRESERVED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_UNRESERVED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_IPV6_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_IPV6_INTERFACE_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_IPV6_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_IPV6_NEIGHBOR_ADDRESS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_EXTENDED_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_EXTENDED_ADMIN_GROUP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_TE_DEFAULT_METRIC': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_TE_DEFAULT_METRIC': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_LINK_ATTRIBUTES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_LINK_ATTRIBUTES': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_LINK_PROTECTION_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_LINK_PROTECTION_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_BANDWIDTH_CONSTRAINTS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_BANDWIDTH_CONSTRAINTS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_UNCONSTRAINED_LSP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_UNCONSTRAINED_LSP': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_ADJ_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_ADJ_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_ADJ_LAN_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_ADJ_LAN_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_MIN_MAX_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_MIN_MAX_LINK_DELAY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_LINK_DELAY_VARIATION': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_LINK_DELAY_VARIATION': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_LINK_LOSS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_LINK_LOSS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_RESIDUAL_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_RESIDUAL_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_AVAILABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_AVAILABLE_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV223_UTILIZED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV223_UTILIZED_BANDWIDTH': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'ISIS_TLV235_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:ISIS_TLV235_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV235_TAG': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV235_TAG': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV235_TAG64': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV235_TAG64': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV235_PREFIX_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV235_PREFIX_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV235_PREFIX_FLAGS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV235_PREFIX_FLAGS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV235_IPV4_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV235_IPV4_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV235_IPV6_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV235_IPV6_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'ISIS_TLV236_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:ISIS_TLV236_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV236_TAG': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV236_TAG': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV236_TAG64': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV236_TAG64': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV236_PREFIX_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV236_PREFIX_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV236_PREFIX_FLAGS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV236_PREFIX_FLAGS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV236_IPV4_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV236_IPV4_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV236_IPV6_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV236_IPV6_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'ISIS_TLV237_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:ISIS_TLV237_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV237_TAG': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV237_TAG': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV237_TAG64': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV237_TAG64': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV237_PREFIX_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV237_PREFIX_SID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV237_PREFIX_FLAGS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV237_PREFIX_FLAGS': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV237_IPV4_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV237_IPV4_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV237_IPV6_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV237_IPV6_ROUTER_ID': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'ISIS_TLV242_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:ISIS_TLV242_SUBTLVS_TYPE': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV242_SR_CAPABILITY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV242_SR_CAPABILITY': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'TLV242_SR_ALGORITHM': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}, 'oc-isis-lsdb-types:TLV242_SR_ALGORITHM': {'@module': 'openconfig-isis-lsdb-types', '@namespace': 'http://openconfig.net/yang/isis-lsdb-types'}},), is_leaf=True, yang_name="subtlv-type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='identityref', is_config=False)""",
                }
            )

        self.__subtlv_type = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_subtlv_type(self):
        self.__subtlv_type = YANGDynClass(
            base=RestrictedClassType(
                base_type=six.text_type,
                restriction_type="dict_key",
                restriction_arg={
                    "ISIS_TLV22_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV22_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV22_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV22_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV23_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV23_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV23_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV23_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV135_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV135_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV135_TAG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV135_TAG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV135_TAG64": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV135_TAG64": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV135_PREFIX_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV135_PREFIX_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV135_PREFIX_FLAGS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV135_PREFIX_FLAGS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV135_IPV4_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV135_IPV4_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV135_IPV6_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV135_IPV6_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV141_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV141_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV141_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV141_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV222_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV222_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV222_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV222_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV223_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV223_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_IPV4_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_IPV4_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_MAX_LINK_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_MAX_RESERVABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_UNRESERVED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_IPV6_INTERFACE_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_IPV6_NEIGHBOR_ADDRESS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_EXTENDED_ADMIN_GROUP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_TE_DEFAULT_METRIC": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_LINK_ATTRIBUTES": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_LINK_PROTECTION_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_BANDWIDTH_CONSTRAINTS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_UNCONSTRAINED_LSP": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_ADJ_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_ADJ_LAN_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_MIN_MAX_LINK_DELAY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_LINK_DELAY_VARIATION": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_LINK_LOSS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_RESIDUAL_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_AVAILABLE_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV223_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV223_UTILIZED_BANDWIDTH": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV235_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV235_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV235_TAG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV235_TAG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV235_TAG64": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV235_TAG64": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV235_PREFIX_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV235_PREFIX_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV235_PREFIX_FLAGS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV235_PREFIX_FLAGS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV235_IPV4_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV235_IPV4_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV235_IPV6_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV235_IPV6_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV236_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV236_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV236_TAG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV236_TAG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV236_TAG64": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV236_TAG64": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV236_PREFIX_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV236_PREFIX_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV236_PREFIX_FLAGS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV236_PREFIX_FLAGS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV236_IPV4_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV236_IPV4_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV236_IPV6_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV236_IPV6_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV237_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV237_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV237_TAG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV237_TAG": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV237_TAG64": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV237_TAG64": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV237_PREFIX_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV237_PREFIX_SID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV237_PREFIX_FLAGS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV237_PREFIX_FLAGS": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV237_IPV4_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV237_IPV4_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV237_IPV6_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV237_IPV6_ROUTER_ID": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "ISIS_TLV242_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:ISIS_TLV242_SUBTLVS_TYPE": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV242_SR_CAPABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV242_SR_CAPABILITY": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "TLV242_SR_ALGORITHM": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                    "oc-isis-lsdb-types:TLV242_SR_ALGORITHM": {
                        "@module": "openconfig-isis-lsdb-types",
                        "@namespace": "http://openconfig.net/yang/isis-lsdb-types",
                    },
                },
            ),
            is_leaf=True,
            yang_name="subtlv-type",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="identityref",
            is_config=False,
        )

    def _get_unreserved_bandwidth(self):
        """
    Getter method for unreserved_bandwidth, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/isis_neighbor_attribute/neighbors/neighbor/subTLVs/subTLVs/unreserved_bandwidth/setup_priority/state/unreserved_bandwidth (oc-types:ieeefloat32)

    YANG Description: The amount of bandwidth reservable in this direction on this
link. Note that for oversubscription purposes, this can be
greater than the bandwidth of the link. It contains eight
32-bit IEEE floating point numbers(one for each priority). The
units are bytes (not bits!) per second. The values correspond
to the bandwidth that can be reserved with a setup priority of
0 through 7, arranged in increasing order with priority 0
occurring at the start of the sub-TLV, and priority 7 at the
end of the sub-TLV.
    """
        return self.__unreserved_bandwidth

    def _set_unreserved_bandwidth(self, v, load=False):
        """
    Setter method for unreserved_bandwidth, mapped from YANG variable /network_instances/network_instance/protocols/protocol/isis/levels/level/link_state_database/lsp/tlvs/tlv/isis_neighbor_attribute/neighbors/neighbor/subTLVs/subTLVs/unreserved_bandwidth/setup_priority/state/unreserved_bandwidth (oc-types:ieeefloat32)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_unreserved_bandwidth is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_unreserved_bandwidth() directly.

    YANG Description: The amount of bandwidth reservable in this direction on this
link. Note that for oversubscription purposes, this can be
greater than the bandwidth of the link. It contains eight
32-bit IEEE floating point numbers(one for each priority). The
units are bytes (not bits!) per second. The values correspond
to the bandwidth that can be reserved with a setup priority of
0 through 7, arranged in increasing order with priority 0
occurring at the start of the sub-TLV, and priority 7 at the
end of the sub-TLV.
    """
        if hasattr(v, "_utype"):
            v = v._utype(v)
        try:
            t = YANGDynClass(
                v,
                base=RestrictedClassType(
                    base_type=bitarray, restriction_dict={"length": ["32"]}
                ),
                is_leaf=True,
                yang_name="unreserved-bandwidth",
                parent=self,
                path_helper=self._path_helper,
                extmethods=self._extmethods,
                register_paths=True,
                namespace="http://openconfig.net/yang/network-instance",
                defining_module="openconfig-network-instance",
                yang_type="oc-types:ieeefloat32",
                is_config=False,
            )
        except (TypeError, ValueError):
            raise ValueError(
                {
                    "error-string": """unreserved_bandwidth must be of a type compatible with oc-types:ieeefloat32""",
                    "defined-type": "oc-types:ieeefloat32",
                    "generated-type": """YANGDynClass(base=RestrictedClassType(base_type=bitarray, restriction_dict={'length': ['32']}), is_leaf=True, yang_name="unreserved-bandwidth", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='http://openconfig.net/yang/network-instance', defining_module='openconfig-network-instance', yang_type='oc-types:ieeefloat32', is_config=False)""",
                }
            )

        self.__unreserved_bandwidth = t
        if hasattr(self, "_set"):
            self._set()

    def _unset_unreserved_bandwidth(self):
        self.__unreserved_bandwidth = YANGDynClass(
            base=RestrictedClassType(
                base_type=bitarray, restriction_dict={"length": ["32"]}
            ),
            is_leaf=True,
            yang_name="unreserved-bandwidth",
            parent=self,
            path_helper=self._path_helper,
            extmethods=self._extmethods,
            register_paths=True,
            namespace="http://openconfig.net/yang/network-instance",
            defining_module="openconfig-network-instance",
            yang_type="oc-types:ieeefloat32",
            is_config=False,
        )

    setup_priority = __builtin__.property(_get_setup_priority)
    subtlv_type = __builtin__.property(_get_subtlv_type)
    unreserved_bandwidth = __builtin__.property(_get_unreserved_bandwidth)

    _pyangbind_elements = OrderedDict(
        [
            ("setup_priority", setup_priority),
            ("subtlv_type", subtlv_type),
            ("unreserved_bandwidth", unreserved_bandwidth),
        ]
    )
